/*******************************************************************
*                                                                  *
*  Author      : Dr. Thomas Brandes, GMD, I1.LAB                   *
*  Copyright   : GMD St. Augustin, Germany                         *
*  Date        : Feb 94                                            *
*  Last Update : Feb 94                                            *
*                                                                  *
*  This Module is part of the DALIB                                *
*                                                                  *
*  INITIALIZATION OF PROGRAM for MEIKO CS-2 / Paragon on NX        *
*                                                                  *
*  MODULE : init.m4                                                *
*                                                                  *
*  Function: Realization of System Dependent Operations            *
*                                                                  *
*******************************************************************/

#include <stdio.h>
#include <string.h>
#include "dalib.h"

#undef DEBUG

int tids[MAXP1];   /* communication with task identifiers */

void dalib_machine_enroll (NP)

int *NP;

{ int rank, size;
  int i;

  rank = mynode();
  size = numnodes ();

#ifdef DEBUG
  printf ("%d of %d will enroll\n", rank, size);
#endif

  pcb.i = rank+1;
  *NP   = size;

  for (i=1; i<=size; i++) tids[i] = i-1;

  if (pcb.i == 1)

      { /* only first process gets the parameters */

        eval_arg (*NP, *NP);

      }


} /* dalib_machine_enroll */

/*******************************************************************
*                                                                  *
*  dalib_machine_exit                                              *
*                                                                  *
*******************************************************************/

void dalib_machine_exit () 

{
  exit (0);

} /* dalib_machine_exit */
