# include "Accepted.h"
# ifdef __cplusplus
extern "C" {
# include "General.h"
# include "rSystem.h"
}
# else
# include "General.h"
# include "rSystem.h"
# endif
# include <stdio.h>
# include "Tree.h"
# include "Definitions.h"

# ifndef NULL
# define NULL 0L
# endif
# ifndef rfalse
# define rfalse 0
# endif
# ifndef rtrue
# define rtrue 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, start, alloc, type, make, ptr, kind, init) \
  ptr = (free -= yyAlignedSize (sizeof (type))) >= start ? \
   (tree) free : alloc (sizeof (type)); \
  init (ptr, kind);
# else
# define yyALLOC(tree, free, start, alloc, type, make, ptr, kind, init) \
  ptr = make (kind);
# endif

/* line 22 "Accepted.puma" */


# include <stdio.h>
# include "Idents.h"
# include "StringM.h"
 
# include "protocol.h"

# include "Transform.h"      /* CombineACF     */
# include "Objects.h"
# include "Distributions.h"
# include "Intrinsics.h"
# include "Rank.h"
# include "Expressions.h"

# define MODULE "Accepted"
 
# undef DEBUG



# ifndef yyWrite
# define yyWrite(s) (void) fputs (s, yyf)
# endif
# ifndef yyWriteNl
# define yyWriteNl (void) fputc ('\n', yyf)
# endif

# include "yyAccepted.h"

static void yyExit ARGS ((void)) { rExit (1); }

void (* Accepted_Exit) ARGS ((void)) = yyExit;

# ifdef UNIX
static FILE * yyf = stdout;
# else
static FILE * yyf;
# endif
static rbool yyb;

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module Accepted, routine %s failed\n",
  yyFunction);
 Accepted_Exit ();
}

rbool IsDescriptorVar ARGS ((tTree var));
rbool IsF77 ARGS ((tTree exp));
rbool DoLoopExpression ARGS ((tTree t));

rbool IsDescriptorVar
# if defined __STDC__ | defined __cplusplus
(register tTree var)
# else
(var)
 register tTree var;
# endif
{
  if (var->Kind == kUSED_VAR) {
/* line 62 "Accepted.puma" */
   return rtrue;

  }
  if (var->Kind == kLOOP_VAR) {
/* line 65 "Accepted.puma" */
   return rtrue;

  }
  if (var->Kind == kSUBSTRING_VAR) {
/* line 68 "Accepted.puma" */
  {
/* line 70 "Accepted.puma" */
   if (! ((IsDescriptorVar (var->SUBSTRING_VAR.IND_VAR)))) goto yyL3;
  }
   return rtrue;
yyL3:;

  }
  if (var->Kind == kINDEXED_VAR) {
/* line 73 "Accepted.puma" */
  {
/* line 75 "Accepted.puma" */
   if (! ((IsDescriptorVar (var->INDEXED_VAR.IND_VAR)))) goto yyL4;
  {
/* line 76 "Accepted.puma" */
   if (! ((IsF77 (var->INDEXED_VAR.IND_EXPS)))) goto yyL4;
  {
/* line 77 "Accepted.puma" */
   if (! ((TreeReadDistribution (var->INDEXED_VAR.IND_EXPS) == 0))) goto yyL4;
  }
  }
  }
   return rtrue;
yyL4:;

  }
  if (var->Kind == kSELECTED_VAR) {
/* line 80 "Accepted.puma" */
  {
/* line 82 "Accepted.puma" */
   if (! ((IsDescriptorVar (var->SELECTED_VAR.SELEC_VAR)))) goto yyL5;
  }
   return rtrue;
yyL5:;

  }
  return rfalse;
}

rbool IsF77
# if defined __STDC__ | defined __cplusplus
(register tTree exp)
# else
(exp)
 register tTree exp;
# endif
{

  switch (exp->Kind) {
  case kADDR:
/* line 98 "Accepted.puma" */
  {
/* line 99 "Accepted.puma" */
   if (! ((IsF77 (exp->ADDR.E)))) goto yyL1;
  }
   return rtrue;
yyL1:;

  break;
  case kDUMMY_EXP:
/* line 102 "Accepted.puma" */
   return rtrue;

  case kCONST_EXP:
/* line 105 "Accepted.puma" */
   return rtrue;

  case kARRAY_EXP:
/* line 108 "Accepted.puma" */
  {
/* line 109 "Accepted.puma" */
   return rfalse;
  }

  case kTYPE_EXP:
/* line 112 "Accepted.puma" */
  {
/* line 113 "Accepted.puma" */
   return rfalse;
  }

  case kSLICE_EXP:
/* line 116 "Accepted.puma" */
  {
/* line 117 "Accepted.puma" */
   if (! ((IsF77 (exp->SLICE_EXP.FIRST)))) goto yyL6;
  {
/* line 118 "Accepted.puma" */
   if (! ((IsF77 (exp->SLICE_EXP.STOP)))) goto yyL6;
  {
/* line 119 "Accepted.puma" */
   if (! ((IsF77 (exp->SLICE_EXP.INC)))) goto yyL6;
  }
  }
  }
   return rtrue;
yyL6:;

  break;
  case kOP_EXP:
/* line 122 "Accepted.puma" */
  {
/* line 123 "Accepted.puma" */
   if (! ((IsF77 (exp->OP_EXP.OPND1)))) goto yyL7;
  {
/* line 124 "Accepted.puma" */
   if (! ((IsF77 (exp->OP_EXP.OPND2)))) goto yyL7;
  }
  }
   return rtrue;
yyL7:;

  break;
  case kOP1_EXP:
/* line 127 "Accepted.puma" */
  {
/* line 128 "Accepted.puma" */
   if (! ((IsF77 (exp->OP1_EXP.OPND)))) goto yyL8;
  }
   return rtrue;
yyL8:;

  break;
  case kPERM_EXP:
/* line 131 "Accepted.puma" */
  {
/* line 132 "Accepted.puma" */
   return rfalse;
  }

  case kVAR_EXP:
/* line 135 "Accepted.puma" */
  {
/* line 136 "Accepted.puma" */
   if (! ((IsF77 (exp->VAR_EXP.V)))) goto yyL10;
  }
   return rtrue;
yyL10:;

  break;
  case kFUNC_CALL_EXP:
/* line 139 "Accepted.puma" */
  {
/* line 141 "Accepted.puma" */
   if (! ((IsIntrCall (exp)))) goto yyL11;
  {
/* line 142 "Accepted.puma" */
   if (! ((IntrFuncElemental (exp->FUNC_CALL_EXP.FUNC_ID->PROC_OBJ.Ident) || IntrFuncInquiry (exp->FUNC_CALL_EXP.FUNC_ID->PROC_OBJ.Ident)))) goto yyL11;
  {
/* line 143 "Accepted.puma" */
   if (! ((IsF77 (exp->FUNC_CALL_EXP.FUNC_PARAMS)))) goto yyL11;
  }
  }
  }
   return rtrue;
yyL11:;

/* line 146 "Accepted.puma" */
  {
/* line 149 "Accepted.puma" */
   return rfalse;
  }

  case kBOUND_EXP:
/* line 152 "Accepted.puma" */
   return rtrue;

  case kRANK_EXP:
/* line 155 "Accepted.puma" */
   return rtrue;

  case kBTE_LIST:
/* line 158 "Accepted.puma" */
  {
/* line 159 "Accepted.puma" */
   if (! ((IsF77 (exp->BTE_LIST.Elem)))) goto yyL15;
  {
/* line 160 "Accepted.puma" */
   if (! ((IsF77 (exp->BTE_LIST.Next)))) goto yyL15;
  }
  }
   return rtrue;
yyL15:;

  break;
  case kBTE_EMPTY:
/* line 163 "Accepted.puma" */
   return rtrue;

  case kBTP_LIST:
/* line 166 "Accepted.puma" */
  {
/* line 167 "Accepted.puma" */
   if (! ((IsF77 (exp->BTP_LIST.Elem)))) goto yyL17;
  {
/* line 168 "Accepted.puma" */
   if (! ((IsF77 (exp->BTP_LIST.Next)))) goto yyL17;
  }
  }
   return rtrue;
yyL17:;

  break;
  case kBTP_EMPTY:
/* line 171 "Accepted.puma" */
   return rtrue;

  case kVAR_PARAM:
  if (exp->VAR_PARAM.V->Kind == kADDR) {
/* line 174 "Accepted.puma" */
  {
/* line 175 "Accepted.puma" */
   if (! ((IsF77 (exp->VAR_PARAM.V->ADDR.E)))) goto yyL19;
  }
   return rtrue;
yyL19:;

  }
/* line 178 "Accepted.puma" */
  {
/* line 179 "Accepted.puma" */
   if (! ((IsF77 (exp->VAR_PARAM.V)))) goto yyL20;
  }
   return rtrue;
yyL20:;

  break;
  case kNO_PARAM:
/* line 182 "Accepted.puma" */
   return rtrue;

  case kUSED_VAR:
/* line 185 "Accepted.puma" */
   return rtrue;

  case kLOOP_VAR:
/* line 188 "Accepted.puma" */
   return rtrue;

  case kSUBSTRING_VAR:
  if (exp->SUBSTRING_VAR.IND_EXP->Kind == kSLICE_EXP) {
/* line 191 "Accepted.puma" */
  {
/* line 193 "Accepted.puma" */
   if (! ((IsF77 (exp->SUBSTRING_VAR.IND_VAR)))) goto yyL24;
  {
/* line 194 "Accepted.puma" */
   if (! ((IsF77 (exp->SUBSTRING_VAR.IND_EXP->SLICE_EXP.FIRST)))) goto yyL24;
  {
/* line 195 "Accepted.puma" */
   if (! ((IsF77 (exp->SUBSTRING_VAR.IND_EXP->SLICE_EXP.STOP)))) goto yyL24;
  }
  }
  }
   return rtrue;
yyL24:;

  }
  break;
  case kSELECTED_VAR:
/* line 198 "Accepted.puma" */
  {
/* line 200 "Accepted.puma" */
   if (! ((IsF77 (exp->SELECTED_VAR.SELEC_VAR)))) goto yyL25;
  }
   return rtrue;
yyL25:;

  break;
  case kINDEXED_VAR:
/* line 203 "Accepted.puma" */
  {
/* line 205 "Accepted.puma" */
   if (! ((IsF77 (exp->INDEXED_VAR.IND_VAR)))) goto yyL26;
  {
/* line 206 "Accepted.puma" */
   if (! ((TreeRank (exp) == 0))) goto yyL26;
  {
/* line 207 "Accepted.puma" */
   if (! ((IsF77 (exp->INDEXED_VAR.IND_EXPS)))) goto yyL26;
  }
  }
  }
   return rtrue;
yyL26:;

  break;
  }

  return rfalse;
}

rbool DoLoopExpression
# if defined __STDC__ | defined __cplusplus
(register tTree t)
# else
(t)
 register tTree t;
# endif
{

  switch (t->Kind) {
  case kVAR_PARAM:
/* line 226 "Accepted.puma" */
  {
/* line 228 "Accepted.puma" */
   if (! ((DoLoopExpression (t->VAR_PARAM.V)))) goto yyL1;
  }
   return rtrue;
yyL1:;

  break;
  case kADDR:
/* line 231 "Accepted.puma" */
  {
/* line 233 "Accepted.puma" */
   if (! ((DoLoopExpression (t->ADDR.E)))) goto yyL2;
  }
   return rtrue;
yyL2:;

  break;
  case kVAR_EXP:
/* line 236 "Accepted.puma" */
  {
/* line 238 "Accepted.puma" */
   if (! ((DoLoopExpression (t->VAR_EXP.V)))) goto yyL3;
  }
   return rtrue;
yyL3:;

  break;
  case kSELECTED_VAR:
/* line 241 "Accepted.puma" */
  {
/* line 243 "Accepted.puma" */
   if (! ((DoLoopExpression (t->SELECTED_VAR.SELEC_VAR)))) goto yyL4;
  }
   return rtrue;
yyL4:;

  break;
  case kUSED_VAR:
/* line 246 "Accepted.puma" */
   return rtrue;

  case kLOOP_VAR:
/* line 249 "Accepted.puma" */
   return rtrue;

  case kCONST_EXP:
/* line 252 "Accepted.puma" */
   return rtrue;

  case kOP_EXP:
/* line 255 "Accepted.puma" */
  {
/* line 257 "Accepted.puma" */
   if (! ((DoLoopExpression (t->OP_EXP.OPND1)))) goto yyL8;
  {
/* line 258 "Accepted.puma" */
   if (! ((DoLoopExpression (t->OP_EXP.OPND2)))) goto yyL8;
  }
  }
   return rtrue;
yyL8:;

  break;
  case kOP1_EXP:
/* line 261 "Accepted.puma" */
  {
/* line 263 "Accepted.puma" */
   if (! ((DoLoopExpression (t->OP1_EXP.OPND)))) goto yyL9;
  }
   return rtrue;
yyL9:;

  break;
  case kSLICE_EXP:
/* line 266 "Accepted.puma" */
  {
/* line 268 "Accepted.puma" */
   if (! ((DoLoopExpression (t->SLICE_EXP.FIRST)))) goto yyL10;
  {
/* line 269 "Accepted.puma" */
   if (! ((DoLoopExpression (t->SLICE_EXP.STOP)))) goto yyL10;
  {
/* line 270 "Accepted.puma" */
   if (! ((DoLoopExpression (t->SLICE_EXP.INC)))) goto yyL10;
  }
  }
  }
   return rtrue;
yyL10:;

  break;
  case kDUMMY_EXP:
/* line 273 "Accepted.puma" */
   return rtrue;

  case kBOUND_EXP:
/* line 276 "Accepted.puma" */
   return rtrue;

  case kRANK_EXP:
/* line 279 "Accepted.puma" */
   return rtrue;

  case kARRAY_EXP:
  if (t->ARRAY_EXP.ELEMENTS->Kind == kBTE_LIST) {
  if (t->ARRAY_EXP.ELEMENTS->BTE_LIST.Elem->Kind == kSLICE_EXP) {
  if (t->ARRAY_EXP.ELEMENTS->BTE_LIST.Next->Kind == kBTE_EMPTY) {
/* line 282 "Accepted.puma" */
   return rtrue;

  }
  }
  if (t->ARRAY_EXP.ELEMENTS->BTE_LIST.Elem->Kind == kDO_EXP) {
  if (t->ARRAY_EXP.ELEMENTS->BTE_LIST.Next->Kind == kBTE_EMPTY) {
/* line 285 "Accepted.puma" */
   return rtrue;

  }
  }
  }
  break;
  case kINDEXED_VAR:
/* line 288 "Accepted.puma" */
  {
/* line 290 "Accepted.puma" */
   if (! ((DoLoopExpression (t->INDEXED_VAR.IND_EXPS)))) goto yyL16;
  }
   return rtrue;
yyL16:;

  break;
  case kBTE_LIST:
/* line 293 "Accepted.puma" */
  {
/* line 295 "Accepted.puma" */
   if (! ((DoLoopExpression (t->BTE_LIST.Elem)))) goto yyL17;
  {
/* line 296 "Accepted.puma" */
   if (! ((DoLoopExpression (t->BTE_LIST.Next)))) goto yyL17;
  }
  }
   return rtrue;
yyL17:;

  break;
  case kBTE_EMPTY:
/* line 299 "Accepted.puma" */
   return rtrue;

  case kBTV_LIST:
/* line 302 "Accepted.puma" */
  {
/* line 304 "Accepted.puma" */
   if (! ((DoLoopExpression (t->BTV_LIST.Elem)))) goto yyL19;
  {
/* line 305 "Accepted.puma" */
   if (! ((DoLoopExpression (t->BTV_LIST.Next)))) goto yyL19;
  }
  }
   return rtrue;
yyL19:;

  break;
  case kBTV_EMPTY:
/* line 308 "Accepted.puma" */
   return rtrue;

  case kDO_VAR:
/* line 311 "Accepted.puma" */
  {
/* line 313 "Accepted.puma" */
   if (! ((DoLoopExpression (t->DO_VAR.BODY)))) goto yyL21;
  }
   return rtrue;
yyL21:;

  break;
  case kDO_EXP:
/* line 316 "Accepted.puma" */
  {
/* line 318 "Accepted.puma" */
   if (! ((DoLoopExpression (t->DO_EXP.BODY)))) goto yyL22;
  }
   return rtrue;
yyL22:;

  break;
  case kFUNC_CALL_EXP:
/* line 325 "Accepted.puma" */
  {
/* line 327 "Accepted.puma" */
   if (! ((IsPureCall (t)))) goto yyL23;
  {
/* line 328 "Accepted.puma" */
   if (! ((IntrFuncElemental (t->FUNC_CALL_EXP.FUNC_ID->PROC_OBJ.Ident)))) goto yyL23;
  {
/* line 329 "Accepted.puma" */
   if (! ((DoLoopExpression (t->FUNC_CALL_EXP.FUNC_PARAMS)))) goto yyL23;
  }
  }
  }
   return rtrue;
yyL23:;

/* line 336 "Accepted.puma" */
  {
/* line 338 "Accepted.puma" */
   if (! ((IsIntrCall (t)))) goto yyL24;
  {
/* line 339 "Accepted.puma" */
   if (! ((IntrFuncInquiry (t->FUNC_CALL_EXP.FUNC_ID->PROC_OBJ.Ident)))) goto yyL24;
  {
/* line 340 "Accepted.puma" */
   if (! ((DoLoopExpression (t->FUNC_CALL_EXP.FUNC_PARAMS)))) goto yyL24;
  }
  }
  }
   return rtrue;
yyL24:;

  if (t->FUNC_CALL_EXP.FUNC_PARAMS->Kind == kBTP_LIST) {
  if (t->FUNC_CALL_EXP.FUNC_PARAMS->BTP_LIST.Next->Kind == kBTP_LIST) {
/* line 347 "Accepted.puma" */
 {
  rbool found;
  int val;
  {
/* line 349 "Accepted.puma" */
   if (! ((IsIntrCall (t)))) goto yyL25;
  {
/* line 350 "Accepted.puma" */
   if (! ((IsIdent ("SPREAD") == t->FUNC_CALL_EXP.FUNC_ID->PROC_OBJ.Ident))) goto yyL25;
  {
/* line 357 "Accepted.puma" */
   GetIntConstValue (t->FUNC_CALL_EXP.FUNC_PARAMS->BTP_LIST.Next->BTP_LIST.Elem, & found, & val);
/* line 358 "Accepted.puma" */
   if (! ((found))) goto yyL25;
  {
/* line 360 "Accepted.puma" */
   if (! ((DoLoopExpression (t->FUNC_CALL_EXP.FUNC_PARAMS->BTP_LIST.Elem)))) goto yyL25;
  }
  }
  }
  }
   return rtrue;
 }
yyL25:;

  if (t->FUNC_CALL_EXP.FUNC_PARAMS->BTP_LIST.Next->BTP_LIST.Elem->Kind == kNO_PARAM) {
/* line 367 "Accepted.puma" */
  {
/* line 370 "Accepted.puma" */
   if (! ((IsIntrCall (t)))) goto yyL26;
  {
/* line 371 "Accepted.puma" */
   if (! ((IsIdent ("TRANSPOSE") == t->FUNC_CALL_EXP.FUNC_ID->PROC_OBJ.Ident))) goto yyL26;
  {
/* line 373 "Accepted.puma" */
   if (! ((DoLoopExpression (t->FUNC_CALL_EXP.FUNC_PARAMS->BTP_LIST.Elem)))) goto yyL26;
  }
  }
  }
   return rtrue;
yyL26:;

  }
  }
  }
  break;
  case kBTP_LIST:
/* line 376 "Accepted.puma" */
  {
/* line 378 "Accepted.puma" */
   if (! ((DoLoopExpression (t->BTP_LIST.Elem)))) goto yyL27;
  {
/* line 379 "Accepted.puma" */
   if (! ((DoLoopExpression (t->BTP_LIST.Next)))) goto yyL27;
  }
  }
   return rtrue;
yyL27:;

  break;
  case kBTP_EMPTY:
/* line 382 "Accepted.puma" */
   return rtrue;

  case kNO_PARAM:
/* line 385 "Accepted.puma" */
   return rtrue;

  }

  return rfalse;
}

void BeginAccepted ARGS ((void))
{
}

void CloseAccepted ARGS ((void))
{
}
