# include "FArguments.h"
# ifdef __cplusplus
extern "C" {
# include "General.h"
# include "rSystem.h"
}
# else
# include "General.h"
# include "rSystem.h"
# endif
# include <stdio.h>
# include "Tree.h"
# include "Definitions.h"

# ifndef NULL
# define NULL 0L
# endif
# ifndef rfalse
# define rfalse 0
# endif
# ifndef rtrue
# define rtrue 1
# endif

# ifdef yyInline
# define yyALLOC(tree, free, start, alloc, type, make, ptr, kind, init) \
  ptr = (free -= yyAlignedSize (sizeof (type))) >= start ? \
   (tree) free : alloc (sizeof (type)); \
  init (ptr, kind);
# else
# define yyALLOC(tree, free, start, alloc, type, make, ptr, kind, init) \
  ptr = make (kind);
# endif

/* line 22 "FArguments.puma" */

 
# define  MODULE "FArguments"
 
# include "Idents.h"
# include "Rank.h"
# include "protocol.h"

# include "TreeOps.h"         /* IsVarAssumedSize */
# include "Distributions.h"
# include "Objects.h"
# include "Nesting.h"
 


# ifndef yyWrite
# define yyWrite(s) (void) fputs (s, yyf)
# endif
# ifndef yyWriteNl
# define yyWriteNl (void) fputc ('\n', yyf)
# endif

# include "yyFArguments.h"

static void yyExit ARGS ((void)) { rExit (1); }

void (* FArguments_Exit) ARGS ((void)) = yyExit;

# ifdef UNIX
static FILE * yyf = stdout;
# else
static FILE * yyf;
# endif
static rbool yyb;

static void yyAbort
# ifdef __cplusplus
 (char * yyFunction)
# else
 (yyFunction) char * yyFunction;
# endif
{
 (void) fprintf (stderr, "Error: module FArguments, routine %s failed\n",
  yyFunction);
 FArguments_Exit ();
}

rbool FixedSizeArray ARGS ((tDefinitions obj));
rbool IsPointerDummy ARGS ((tDefinitions dummy));
rbool IsOnlyReadParam ARGS ((tTree param));

rbool FixedSizeArray
# if defined __STDC__ | defined __cplusplus
(register tDefinitions obj)
# else
(obj)
 register tDefinitions obj;
# endif
{
  if (obj->Kind == kVarObject) {
/* line 46 "FArguments.puma" */
  {
/* line 48 "FArguments.puma" */
   if (! ((obj->VarObject.arr_kind == arr_fixed_size))) goto yyL1;
  {
/* line 49 "FArguments.puma" */
   if (! ((VarDistribution (obj) <= 0))) goto yyL1;
  {
/* line 50 "FArguments.puma" */
   if (! ((! IsHPFDynamic (obj)))) goto yyL1;
  }
  }
  }
   return rtrue;
yyL1:;

  if (obj->VarObject.Kind->Kind == kVarDummy) {
/* line 53 "FArguments.puma" */
  {
/* line 55 "FArguments.puma" */
   if (! ((IsPointerDummy (obj)))) goto yyL2;
  }
   return rtrue;
yyL2:;

  }
  if (obj->VarObject.Kind->Kind == kVarParameter) {
/* line 58 "FArguments.puma" */
   return rtrue;

  }
  }
  return rfalse;
}

rbool IsPointerDummy
# if defined __STDC__ | defined __cplusplus
(register tDefinitions dummy)
# else
(dummy)
 register tDefinitions dummy;
# endif
{
  if (dummy->Kind == kFuncObject) {
/* line 74 "FArguments.puma" */
   return rtrue;

  }
  if (dummy->Kind == kProcObject) {
/* line 77 "FArguments.puma" */
   return rtrue;

  }
  if (dummy->Kind == kVarObject) {
  if (dummy->VarObject.Kind->Kind == kVarDummy) {
/* line 82 "FArguments.puma" */
  {
/* line 84 "FArguments.puma" */
   if (! ((VarRank (dummy) == 0))) goto yyL3;
  }
   return rtrue;
yyL3:;

/* line 87 "FArguments.puma" */
  {
/* line 89 "FArguments.puma" */
   if (! ((IsAssumedSize (GetObjDimension (dummy))))) goto yyL4;
  }
   return rtrue;
yyL4:;

/* line 92 "FArguments.puma" */
  {
/* line 94 "FArguments.puma" */
   if (! ((! IsAssumedShape (GetObjDimension (dummy))))) goto yyL5;
  {
/* line 95 "FArguments.puma" */
   if (! ((GetCurrentModel () == HPF_SERIAL))) goto yyL5;
  }
  }
   return rtrue;
yyL5:;

/* line 98 "FArguments.puma" */
  {
/* line 99 "FArguments.puma" */
   return rfalse;
  }

  }
  }
  return rfalse;
}

rbool IsOnlyReadParam
# if defined __STDC__ | defined __cplusplus
(register tTree param)
# else
(param)
 register tTree param;
# endif
{
  if (param->Kind == kVAR_PARAM) {
  if (param->VAR_PARAM.V->Kind == kADDR) {
/* line 127 "FArguments.puma" */
   return rtrue;

  }
  if (param->VAR_PARAM.V->Kind == kUSED_VAR) {
/* line 130 "FArguments.puma" */
  {
/* line 132 "FArguments.puma" */
   if (! ((IsVarParameter (param->VAR_PARAM.V->USED_VAR.VARNAME->VAR_OBJ.Object)))) goto yyL2;
  }
   return rtrue;
yyL2:;

  }
/* line 135 "FArguments.puma" */
  {
/* line 137 "FArguments.puma" */
   if (! ((param->VAR_PARAM.intent == IntentIn))) goto yyL3;
  }
   return rtrue;
yyL3:;

  }
  return rfalse;
}

void BeginFArguments ARGS ((void))
{
}

void CloseFArguments ARGS ((void))
{
}
