# ifndef yyObjects
# define yyObjects

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifndef rbool
# define rbool char
# endif

# include "Tree.h"
# include "Definitions.h"


extern void (* Objects_Exit) ARGS ((void));

extern tDefinitions MakeNewObject ARGS ((tTree decl, tDefinitions unit));
extern tDefinitions MakeResultObject ARGS ((tTree decl, tDefinitions unit));
extern tTree GetObjDimension ARGS ((tDefinitions obj));
extern rbool IsVarAllocatable ARGS ((tDefinitions v));
extern rbool IsVarAssumedShape ARGS ((tDefinitions v));
extern rbool IsVarAssumedSize ARGS ((tDefinitions v));
extern rbool IsVarExplicitShape ARGS ((tDefinitions v));
extern rbool IsVarCommon ARGS ((tDefinitions v));
extern tIdent GetCommonBlockId ARGS ((tDefinitions v));
extern rbool IsVarDummy ARGS ((tDefinitions v));
extern rbool IsVarResult ARGS ((tDefinitions v));
extern rbool IsVarParameter ARGS ((tDefinitions v));
extern rbool IsVarLocal ARGS ((tDefinitions v));
extern rbool IsVarTraced ARGS ((tDefinitions v));
extern rbool IsVarSave ARGS ((tDefinitions v));
extern rbool IsPointerObject ARGS ((tDefinitions v));
extern rbool IsTreeObject ARGS ((tDefinitions v));
extern rbool IsRaggedVarObject ARGS ((tDefinitions v));
extern rbool IsTemplate ARGS ((tDefinitions v));
extern rbool IsTopology ARGS ((tDefinitions v));
extern rbool IsOptional ARGS ((tDefinitions v));
extern rbool IsHPFDynamic ARGS ((tDefinitions obj));
extern tTree GetVarShadow ARGS ((tDefinitions v));
extern int GetVarSharedKind ARGS ((tDefinitions v));
extern rbool IsFuncObj ARGS ((tDefinitions v));
extern rbool IsModuleObj ARGS ((tDefinitions v));
extern rbool IsTypeObj ARGS ((tDefinitions v));
extern rbool IsLocalCall ARGS ((tTree t));
extern rbool IsSerialCall ARGS ((tTree t));
extern rbool IsElementalCall ARGS ((tTree t));
extern rbool IsF77Call ARGS ((tTree t));
extern rbool IsUserCall ARGS ((tTree t));
extern rbool IsIntrCall ARGS ((tTree t));
extern rbool IsStmtCall ARGS ((tTree t));
extern rbool IsPureCall ARGS ((tTree t));
extern rbool IsPureUnit ARGS ((tTree t));
extern rbool IsLocalUnit ARGS ((tTree t));
extern rbool IsTaskUnit ARGS ((tTree t));
extern rbool IsSerialUnit ARGS ((tTree t));
extern rbool IsF77Unit ARGS ((tTree t));
extern rbool IsMainUnit ARGS ((tTree t));
extern rbool IsStmtFunction ARGS ((tDefinitions obj));
extern tDefinitions GetFuncVarObj ARGS ((tDefinitions f));
extern void GetDummies ARGS ((tDefinitions obj, tTree * yyP2, tDefinitions * yyP1));
extern tDefinitions GetReferenceObject ARGS ((tDefinitions obj));
extern rbool NoInterfaceObj ARGS ((tDefinitions v));
extern rbool IsGlobalVar ARGS ((tTree var, tDefinitions unit));
extern rbool FunctionBecomesSubroutine ARGS ((tTree f));
extern rbool IsUsedObject ARGS ((tDefinitions obj, tDefinitions unit));

extern void BeginObjects ARGS ((void));
extern void CloseObjects ARGS ((void));

# endif
