# ifndef yyTransform
# define yyTransform

# if defined __STDC__ | defined __cplusplus
# define ARGS(parameters)	parameters
# else
# define ARGS(parameters)	()
# endif

# ifndef rbool
# define rbool char
# endif

# include "Tree.h"
# include "Definitions.h"

/* line 71 "Transform.puma" */


#include "StrUnparse.h"     /* String */



extern void (* Transform_Exit) ARGS ((void));

extern tTree CombineACF ARGS ((tTree list1, tTree list2));
extern tTree CompleteACFs ARGS ((tTree list));
extern tTree CombineDECL ARGS ((tTree list1, tTree list2));
extern tTree CombineBTP ARGS ((tTree list1, tTree list2));
extern tTree CompleteBTPs ARGS ((tTree list));
extern tTree CombineBTV ARGS ((tTree list1, tTree list2));
extern tTree CompleteBTVs ARGS ((tTree list));
extern tTree CombineBTE ARGS ((tTree list1, tTree list2));
extern tTree ReplaceUNIT ARGS ((tTree old, tTree newelem, tTree newnext));
extern tTree ReplaceACF ARGS ((tTree old, tTree newelem, tTree newnext));
extern tTree ReplaceDECL ARGS ((tTree old, tTree newelem, tTree newnext));
extern tTree ReplaceBTP ARGS ((tTree old, tTree newelem, tTree newnext));
extern tTree AppendDECLS ARGS ((tTree t, tTree newlist));
extern tTree ExpToVarParam ARGS ((tTree exp));
extern tTree ExpListToVarParamList ARGS ((tTree explist));
extern tTree VarParamToExp ARGS ((tTree param));
extern tTree GetStringParams ARGS ((tIdent name));
extern void SetVarParamAttributes ARGS ((tTree p, int intent));
extern tTree AppendParam ARGS ((tTree param_list, tTree param));
extern tTree ConcatParams ARGS ((tTree list1, tTree list2));
extern tTree ConcatVars ARGS ((tTree list1, tTree list2));
extern tTree AppendBody ARGS ((tTree list1, tTree list2));
extern tTree ComposeNewACF ARGS ((tTree pre, tTree s, tTree post));
extern tTree MakeIntegerType ARGS ((int size));
extern tTree MakeRealType ARGS ((int size));
extern tTree MakeLogicalType ARGS ((int size));
extern tTree MakeStringType ARGS ((int size));
extern tTree MakeStmtList ARGS ((tTree stmt));
extern tIdent MakeNewId ARGS ((tIdent id, String n));
extern tTree MakeUsedVarA ARGS ((tIdent id, String n));
extern tTree MakeUsedVarAn ARGS ((tIdent id, String n, int no));
extern tTree MakeRecCompA ARGS ((tIdent id, String n));
extern tTree MakeRecCompAn ARGS ((tIdent id, String n, int no));
extern tTree MakeVarDeclA ARGS ((tIdent id, String n, tTree val));
extern tTree MakeVarDeclAn ARGS ((tIdent id, String n, int no, tTree val));
extern tTree MakeVarParamDeclA ARGS ((tIdent id, String n));
extern tTree MakeVarParamDeclAn ARGS ((tIdent id, String n, int no));
extern tTree MakeVarSuffixA ARGS ((tTree var, String n));
extern tTree MakeVarSuffixAn ARGS ((tTree var, String n, int no));
extern void SetVarObject ARGS ((tTree var));
extern void LineACFNode ARGS ((tTree node, int line));
extern void LabelACFNode ARGS ((tTree node, int label));

extern void BeginTransform ARGS ((void));
extern void CloseTransform ARGS ((void));

# endif
