/* $Id: Scanner.c,v 2.48 1998/03/13 19:34:14 grosch rel $ */

# define rbool		char
# define rtrue		1
# define rfalse		0
# define StdIn		0

# include "Scanner.h"

# ifdef __cplusplus
extern "C" {
#    include "Source.h"
#    include "rSystem.h"
#    include "General.h"
#    include "DynArray.h"
#    include "Position.h"
}
# else
#    include "Source.h"
#    include "rSystem.h"
#    include "General.h"
#    include "DynArray.h"
#    include "Position.h"
# endif

# include <stdio.h>
# if defined __STDC__ | defined __cplusplus
#  include <stdlib.h>
# endif

# define yyStart(State)	{ yyPreviousStart = yyStartState; yyStartState = State;}
# define yyPrevious	{ yyStateRange s = yyStartState; \
			yyStartState = yyPreviousStart; yyPreviousStart = s; }
# define yyEcho		{ (void) fwrite (TokenPtr, 1, \
			TokenLength, stdout); }
# define yyEol(Column)	{ yyLineCount ++; \
			yyLineStart = (unsigned char *) TokenPtr + \
			TokenLength - 1 - (Column); }
# define output(c)	(void) putchar ((int) c)
# define yyColumn(Ptr)	((int) ((Ptr) - (char *) yyLineStart))
# define yyOffset(Ptr)	(yyFileOffset + ((Ptr) - yyChBufferStart2))

# define yyDNoState		0
# define yyFirstCh	(unsigned char) '\0'
# define yyLastCh	(unsigned char) '\177'
# define yyEolCh	(unsigned char) '\12'
# define yyEobCh	(unsigned char) '\177'
# define yyDStateCount	1321
# define yyTableSize	8244
# define yyEobState	378
# define yyDefaultState	379
# define STD	1
# define BEG	3
# define NAMED	5
# define DIST	7
# define ASS	9
# define String1	11
# define String2	13
# define FORMAT	15
# define FORMAT1	17
# define FLAGS	19
# define ENDS	21
# define Incl1	23
# define Incl2	25
# define HPF	27
# define ADP	29

static void yyExit ARGS ((void))
{ rExit (1); }

typedef unsigned short	yyStateRange;
typedef struct { yyStateRange yyCheck, yyNext; } yyCombType;

	char *		TokenPtr	;
	int		TokenLength	;
	tScanAttribute	Attribute	;
	void		(* Scanner_Exit)	ARGS ((void)) = yyExit;

static	void		yyInitialize	ARGS ((void));
static	void		yyErrorMessage	ARGS ((int yyErrorCode));
# ifdef xxinput
static	char		input		ARGS ((void));
# endif
static	void		unput		ARGS ((char));
static	void		yyLess		ARGS ((int));

static	yyCombType	yyComb		[yyTableSize   + 1] = {
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  389}, 
{   0,    0}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,   94}, {   1,  195}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  195}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,   95}, {   1,   95}, 
{   1,   95}, {   1,   95}, {   1,   95}, {   1,   95}, {   1,   95}, 
{   1,   95}, {   1,   95}, {   1,   95}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  195}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  195}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, {   1,  162}, 
{   1,  162}, {   1,  162}, {   3, 1321}, {   3,  381}, {  33,  378}, 
{  34,  222}, {   3,   76}, {  37,   37}, {  37,   37}, {  37,   37}, 
{  37,   37}, {  37,   37}, {  37,   37}, {  37,   37}, {  37,   37}, 
{  37,   37}, {  37,   37}, {  44,  378}, {  62,   64}, {  74,  342}, 
{  75,  149}, { 100,   70}, {  95,   95}, { 103,  372}, { 103,  100}, 
{   3,  396}, { 108,  256}, { 108,  256}, { 108,  256}, { 108,  256}, 
{ 108,  256}, { 108,  256}, { 108,  256}, { 108,  256}, { 108,  256}, 
{ 108,  256}, { 120,  378}, {  34,  222}, {  95,   95}, {  95,   95}, 
{  95,   95}, {  95,   95}, {  95,   95}, {  95,   95}, {  95,   95}, 
{  95,   95}, {  95,   95}, {  95,   95}, { 162,  378}, { 182,   97}, 
{ 187,   39}, {  74,  342}, {  75,  149}, { 100,   70}, { 118,  178}, 
{ 103,  372}, { 103,  100}, { 133,   83}, {   3, 1028}, {   3,  376}, 
{   3, 1064}, {   3,  375}, {   3,  298}, {   3, 1036}, {   3,  351}, 
{   3,  374}, {   3,  373}, {   3,  374}, {   3,  374}, {   3, 1153}, 
{   3, 1141}, {   3, 1012}, {   3, 1069}, {   3, 1073}, {   3,  374}, 
{   3, 1042}, {   3,  348}, {   3,  362}, {   3, 1127}, {   3,  374}, 
{   3, 1078}, {   3,  374}, {   3,  374}, {   3,  374}, { 104,  366}, 
{ 251,   41}, { 118,  178}, { 112,  112}, { 115,  115}, { 133,   83}, 
{   3, 1028}, {   3,  376}, {   3, 1064}, {   3,  375}, {   3,  298}, 
{   3, 1036}, {   3,  351}, {   3,  374}, {   3,  373}, {   3,  374}, 
{   3,  374}, {   3, 1153}, {   3, 1141}, {   3, 1012}, {   3, 1069}, 
{   3, 1073}, {   3,  374}, {   3, 1042}, {   3,  348}, {   3,  362}, 
{   3, 1127}, {   3,  374}, {   3, 1078}, {   3,  374}, {   3,  374}, 
{   3,  374}, {   5,  390}, {   5,  380}, {  98,   68}, { 101,   45}, 
{ 102,   69}, { 105,  272}, { 112,  368}, { 115,  316}, { 119,   49}, 
{ 102,  372}, { 105,  279}, { 119,   49}, { 135,   84}, { 136,   82}, 
{ 127,   85}, { 137,   80}, { 138,  131}, { 254,   50}, { 101,  372}, 
{ 112,  224}, { 104,  372}, {  98,  372}, { 127,  358}, {   5,  396}, 
{ 271,   43}, { 276,   40}, { 278,   42}, { 279,  276}, { 279,  276}, 
{ 377,  378}, { 119,  203}, { 457,  458}, { 571,  572}, { 624,  625}, 
{  98,   68}, { 101,   45}, { 102,   69}, { 629,  630}, { 112,  368}, 
{ 115,  316}, { 634,  635}, { 102,  372}, { 253,   96}, { 637,  638}, 
{ 135,   84}, { 136,   82}, { 127,   85}, { 137,   80}, { 138,  131}, 
{   5, 1007}, { 101,  372}, { 112,  224}, { 104,  372}, {  98,  372}, 
{ 127,  358}, { 105,  372}, {   5,  342}, {   5,  342}, {   5,  342}, 
{   5, 1005}, {   5,  342}, {   5,  997}, {   5,  342}, {   5,  342}, 
{   5, 1003}, {   5,  342}, {   5,  342}, {   5,  342}, {   5,  342}, 
{   5,  342}, {   5,  342}, {   5,  342}, {   5,  342}, {   5,  342}, 
{   5,  369}, {   5,  342}, {   5,  342}, {   5,  342}, {   5,  342}, 
{   5,  342}, {   5,  342}, {   5,  342}, { 640,  641}, { 644,  645}, 
{ 139,   77}, { 647,  648}, { 651,  652}, { 105,  372}, {   5,  342}, 
{   5,  342}, {   5,  342}, {   5, 1005}, {   5,  342}, {   5,  997}, 
{   5,  342}, {   5,  342}, {   5, 1003}, {   5,  342}, {   5,  342}, 
{   5,  342}, {   5,  342}, {   5,  342}, {   5,  342}, {   5,  342}, 
{   5,  342}, {   5,  342}, {   5,  369}, {   5,  342}, {   5,  342}, 
{   5,  342}, {   5,  342}, {   5,  342}, {   5,  342}, {   5,  342}, 
{   7, 1009}, {   7,  382}, { 139,   77}, { 106,  180}, {   7,   65}, 
{ 106,  106}, { 106,  106}, { 106,  106}, { 106,  106}, { 106,  106}, 
{ 106,  106}, { 106,  106}, { 106,  106}, { 106,  106}, { 106,  106}, 
{ 655,  656}, { 114,  114}, { 114,  197}, { 662,  663}, { 253,  378}, 
{ 149,  112}, { 659,  660}, { 659,  679}, { 141,  136}, {   7,   66}, 
{   7,  696}, { 114,  197}, { 664,  665}, { 666,  667}, {   7,  202}, 
{   7,  697}, { 128,   81}, { 669,  670}, { 116,  116}, { 116,  116}, 
{ 116,  116}, { 116,  116}, { 116,  116}, { 116,  116}, { 116,  116}, 
{ 116,  116}, { 116,  116}, { 116,  116}, { 671,  672}, { 144,   87}, 
{ 128,  374}, { 677,  678}, { 129,   78}, { 682,  683}, { 146,  139}, 
{   7, 1008}, { 114,  197}, { 106,  110}, { 116,  201}, { 116,  183}, 
{ 141,  136}, {   7,  790}, {   7,  365}, {   7,  740}, {   7,  356}, 
{   7,  720}, {   7,  933}, {   7,  325}, { 128,   81}, {   7,  284}, 
{ 169,  265}, { 129,  374}, {   7,  903}, {   7,  892}, {   7,  372}, 
{   7,  745}, {   7,  749}, { 149,  374}, {   7,  714}, {   7,  771}, 
{   7,  698}, { 144,   87}, { 128,  374}, {   7,  700}, { 129,   78}, 
{ 116,  109}, { 146,  139}, { 685,  686}, { 114,  197}, { 692,  693}, 
{ 116,  201}, { 116,  183}, { 694,  695}, {   7,  790}, {   7,  365}, 
{   7,  740}, {   7,  356}, {   7,  720}, {   7,  933}, {   7,  325}, 
{ 894,  895}, {   7,  284}, { 169,  265}, { 129,  374}, {   7,  903}, 
{   7,  892}, {   7,  372}, {   7,  745}, {   7,  749}, { 149,  374}, 
{   7,  714}, {   7,  771}, {   7,  698}, { 673,  674}, { 673,  681}, 
{   7,  700}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  391}, {   9,  383}, {   9,  120}, {   9,  120}, {   9,   61}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  190}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,   60}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,   62}, 
{   9,  120}, {   9,  120}, {   9,   63}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, {   9,  120}, 
{   9,  120}, {   9,  120}, {   9,  120}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, { 899,  900}, {  11,  384}, {  11,   58}, 
{  11,   58}, {  11,   59}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,  397}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,  694}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, {  11,   58}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {1143, 1144}, 
{  13,  385}, {  13,   56}, {  13,   56}, {  13,   57}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,  398}, {  13,   56}, {  13,  692}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, {  13,   56}, 
{  13,   56}, {  13,   56}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,  392}, {  15,   55}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,  399}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, 
{  15,   54}, {  15,   54}, {  15,   54}, {  15,   54}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,  393}, {1149, 1150}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,  400}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, {  17,   53}, 
{  17,   53}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,  394}, {  19,   52}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,  401}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, {  19,   51}, 
{  19,   51}, {  19,   51}, {  19,   51}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,  395}, {  21,  386}, {  21,   48}, 
{  21,   48}, {  21,   49}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,  119}, {  21,  118}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,  118}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,  118}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,  118}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, {  21,   48}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {   0,    0}, 
{   0,    0}, {  23,   47}, {  23,   47}, {   0,    0}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,  402}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23, 1011}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, {  23,   47}, 
{  23,   47}, {  23,   47}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {   0,    0}, {   0,    0}, {  25,   46}, {  25,   46}, 
{   0,    0}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,  403}, 
{  25,   46}, {  25, 1010}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, 
{  25,   46}, {  25,   46}, {  25,   46}, {  25,   46}, {  27,  387}, 
{   0,    0}, {   0,    0}, {  27,   44}, { 167,  167}, { 167,  167}, 
{ 167,  167}, { 167,  167}, { 167,  167}, { 167,  167}, { 167,  167}, 
{ 167,  167}, { 167,  167}, { 167,  167}, {   0,    0}, {   0,    0}, 
{   0,    0}, { 170,  254}, { 147,  367}, {   0,    0}, { 277,  277}, 
{   0,    0}, { 171,  253}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {  27,  691}, { 277,   89}, {   0,    0}, {  27,  685}, 
{  27,  690}, {  27,  655}, {  27,  658}, {  27,  689}, {  27,  657}, 
{  27,  186}, {  27,  653}, {  27,  106}, {  27,  106}, {  27,  106}, 
{  27,  106}, {  27,  106}, {  27,  106}, {  27,  106}, {  27,  106}, 
{  27,  106}, {  27,  106}, {  27,  682}, { 170,  254}, {  27,  659}, 
{  27,  673}, {  27,  666}, { 147,  296}, { 171,  253}, {  27,  479}, 
{  27,  474}, {  27,  578}, {  27,  532}, {  27,  471}, {  27,  372}, 
{  27,  569}, {  27,  510}, {  27,  487}, {  27,  372}, {  27,  372}, 
{  27,  372}, {  27,  372}, {  27,  326}, {  27,  514}, {  27,  610}, 
{  27,  372}, {  27,  482}, {  27,  465}, {  27,  404}, {  27,  372}, 
{  27,  372}, {  27,  598}, {  27,  372}, {  27,  372}, {  27,  166}, 
{  27,  688}, {  27,  677}, {  27,  687}, {   0,    0}, { 147,  296}, 
{ 173,  154}, {  27,  479}, {  27,  474}, {  27,  578}, {  27,  532}, 
{  27,  471}, {  27,  372}, {  27,  569}, {  27,  510}, {  27,  487}, 
{  27,  372}, {  27,  372}, {  27,  372}, {  27,  372}, {  27,  326}, 
{  27,  514}, {  27,  610}, {  27,  372}, {  27,  482}, {  27,  465}, 
{  27,  404}, {  27,  372}, {  27,  372}, {  27,  598}, {  27,  372}, 
{  27,  372}, {  27,  166}, {  29,  388}, { 202,   67}, { 277,  378}, 
{  29,   33}, { 202,   67}, { 173,  154}, { 181,   37}, { 181,   37}, 
{ 181,   37}, { 181,   37}, { 181,   37}, { 181,   37}, { 181,   37}, 
{ 181,   37}, { 181,   37}, { 181,   37}, {   0,    0}, { 148,  319}, 
{   0,    0}, { 252,  252}, {   0,    0}, { 252,   90}, { 174,  231}, 
{ 202,  202}, {   0,    0}, {   0,    0}, { 252,   91}, {  29,  691}, 
{   0,    0}, {   0,    0}, {  29,  685}, {  29,  690}, {  29,  655}, 
{  29,  658}, {  29,  689}, {  29,  657}, {  29,  186}, {  29,  653}, 
{  29,  106}, {  29,  106}, {  29,  106}, {  29,  106}, {  29,  106}, 
{  29,  106}, {  29,  106}, {  29,  106}, {  29,  106}, {  29,  106}, 
{  29,  682}, {   0,    0}, {  29,  659}, {  29,  673}, {  29,  666}, 
{ 148,  295}, { 174,  231}, {  29,  417}, {  29,  105}, {  29,  372}, 
{  29,  372}, {  29,  372}, {  29,  412}, {  29,  372}, {  29,  372}, 
{  29,  372}, {  29,  372}, {  29,  372}, {  29,  372}, {  29,  372}, 
{  29,  423}, {  29,  306}, {  29,  372}, {  29,  372}, {  29,  372}, 
{  29,  445}, {  29,  435}, {  29,  372}, {  29,  372}, {  29,  372}, 
{  29,  372}, {  29,  372}, {  29,  166}, {  29,  688}, {  29,  677}, 
{  29,  687}, { 175,  122}, { 148,  295}, { 165,  245}, {  29,  417}, 
{  29,  105}, {  29,  372}, {  29,  372}, {  29,  372}, {  29,  412}, 
{  29,  372}, {  29,  372}, {  29,  372}, {  29,  372}, {  29,  372}, 
{  29,  372}, {  29,  372}, {  29,  423}, {  29,  306}, {  29,  372}, 
{  29,  372}, {  29,  372}, {  29,  445}, {  29,  435}, {  29,  372}, 
{  29,  372}, {  29,  372}, {  29,  372}, {  29,  372}, {  29,  166}, 
{  31,  372}, { 252,  378}, { 653,  684}, { 175,  122}, {   0,    0}, 
{ 202,  378}, {   0,    0}, {   0,    0}, { 653,  654}, {   0,    0}, 
{   0,    0}, {   0,    0}, {  31,  372}, {  31,  372}, {  31,  372}, 
{  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, 
{  31,  372}, {  31,  372}, { 653,  676}, { 176,  151}, { 165,  357}, 
{ 165,  372}, { 177,  289}, {   0,    0}, { 178,  170}, {  31,  372}, 
{  31,  372}, {  31,  372}, {  31,  372}, {  31,  104}, {  31,  372}, 
{  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, 
{  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, 
{  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, 
{  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, 
{ 176,  151}, { 165,  357}, { 165,  372}, { 177,  289}, {  31,  372}, 
{ 178,  170}, {  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, 
{  31,  104}, {  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, 
{  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, 
{  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, 
{  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, {  31,  372}, 
{  31,  372}, {  31,  372}, {  32,   32}, {  32,   32}, {  32,   32}, 
{  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, 
{  32,   32}, {  32,   32}, {   0,    0}, { 195,  318}, { 197,  198}, 
{ 198,  171}, { 199,  177}, { 207,   71}, { 208,   34}, {  32,   32}, 
{  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, 
{  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, 
{  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, 
{  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, 
{  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, 
{ 195,  318}, { 197,  198}, { 198,  171}, { 199,  177}, { 207,   71}, 
{ 208,   34}, {  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, 
{  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, 
{  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, 
{  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, 
{  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, {  32,   32}, 
{  32,   32}, {  32,   32}, {  35,   35}, {  35,   35}, {  35,   35}, 
{  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, 
{  35,   35}, {  35,   35}, { 179,  179}, { 210,  266}, { 211,  124}, 
{   0,    0}, {   0,    0}, { 212,  176}, {   0,    0}, {  35,   35}, 
{  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, 
{  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, 
{  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, 
{  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, 
{  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, 
{ 210,  266}, { 211,  124}, { 204,  239}, { 179,  317}, { 212,  176}, 
{ 206,   92}, {  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, 
{  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, 
{  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, 
{  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, 
{  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, {  35,   35}, 
{  35,   35}, {  35,   35}, {  45,  372}, { 203,   49}, { 204,  239}, 
{ 179,  317}, { 203,   49}, { 206,   92}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {  45,  372}, 
{  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, 
{  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, { 206,  378}, 
{ 203,  203}, { 204,  378}, { 213,  156}, { 215,  287}, {   0,    0}, 
{ 216,  159}, {  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, 
{  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, 
{  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, 
{  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, 
{  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, 
{  45,  372}, {  45,  372}, {   0,    0}, {   0,    0}, { 213,  156}, 
{ 215,  287}, {  45,  372}, { 216,  159}, {  45,  372}, {  45,  372}, 
{  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, 
{  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, 
{  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, 
{  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, 
{  45,  372}, {  45,  372}, {  45,  372}, {  45,  372}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {   0,    0}, {   0,    0}, 
{  46,   46}, {  46,   46}, {   0,    0}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {   0,    0}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, {  46,   46}, 
{  46,   46}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{   0,    0}, {   0,    0}, {  47,   47}, {  47,   47}, {   0,    0}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{   0,    0}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, {  47,   47}, 
{  47,   47}, {  47,   47}, {  47,   47}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {   0,    0}, {   0,    0}, {  56,   56}, 
{  56,   56}, {   0,    0}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {   0,    0}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, {  56,   56}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {   0,    0}, 
{   0,    0}, {  58,   58}, {  58,   58}, {   0,    0}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {   0,    0}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, {  58,   58}, 
{  58,   58}, {  58,   58}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {   0,    0}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  168}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, 
{  60,  107}, {  60,  107}, {  60,  107}, {  60,  107}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {   0,    0}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, {  66,   66}, 
{  66,   66}, {  73,  342}, { 189,  189}, { 189,  189}, { 189,  189}, 
{ 189,  189}, { 189,  189}, { 189,  189}, { 189,  189}, { 189,  189}, 
{ 189,  189}, { 189,  189}, {   0,    0}, {  73,  342}, {  73,  342}, 
{  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, 
{  73,  342}, {  73,  342}, {  73,  342}, {   0,    0}, { 217,  157}, 
{   0,    0}, { 218,  155}, { 219,  153}, {   0,    0}, { 220,  150}, 
{  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, {  73,   74}, 
{  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, 
{  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, 
{  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, 
{  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, 
{  73,  342}, { 217,  157}, { 214,  250}, { 218,  155}, { 219,  153}, 
{  73,  342}, { 220,  150}, {  73,  342}, {  73,  342}, {  73,  342}, 
{  73,  342}, {  73,   74}, {  73,  342}, {  73,  342}, {  73,  342}, 
{  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, 
{  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, 
{  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, {  73,  342}, 
{  73,  342}, {  73,  342}, {  73,  342}, {  77,  374}, { 214,  250}, 
{   0,    0}, {   0,    0}, { 194,  252}, {   0,    0}, { 194,   90}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, { 194,   91}, 
{  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, 
{  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, 
{   0,    0}, { 221,  126}, {   0,    0}, { 222,  117}, { 223,  208}, 
{ 214,  378}, { 225,  219}, {  77,  374}, {  77,  374}, {  77,  374}, 
{  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, 
{  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, 
{  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, 
{  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, 
{  77,  374}, {  77,  374}, {  77,  374}, { 221,  126}, { 194,  374}, 
{ 222,  117}, { 223,  208}, {  77,  374}, { 225,  219}, {  77,  374}, 
{  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, 
{  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, 
{  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, 
{  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, 
{  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, {  77,  374}, 
{  81,  374}, { 194,  374}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, { 272,  251}, 
{ 272,  251}, {   0,    0}, {  81,  374}, {  81,  374}, {  81,  374}, 
{  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, 
{  81,  374}, {  81,  374}, {   0,    0}, { 226,  218}, { 227,  199}, 
{ 228,  174}, {   0,    0}, {   0,    0}, { 230,  161}, {  81,  374}, 
{  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, 
{  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, 
{  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, 
{  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, 
{  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, 
{ 226,  218}, { 227,  199}, { 228,  174}, { 229,  262}, {  81,  374}, 
{ 230,  161}, {  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, 
{  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, 
{  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, 
{  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, 
{  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, {  81,  374}, 
{  81,  374}, {  81,  374}, {  99,  372}, { 272,  378}, {   0,    0}, 
{ 229,  262}, { 275,  271}, { 275,  271}, { 275,  271}, { 275,  271}, 
{ 275,  271}, { 275,  271}, { 275,  271}, { 275,  271}, {  99,  372}, 
{  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, 
{  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, { 229,  378}, 
{ 231,  230}, { 232,  320}, { 234,  240}, { 235,  207}, {   0,    0}, 
{ 236,  152}, {  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, 
{  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, 
{  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, 
{  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, 
{  99,   98}, {  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, 
{  99,  372}, {  99,  372}, { 231,  230}, { 232,  320}, { 234,  240}, 
{ 235,  207}, {  99,  372}, { 236,  152}, {  99,  372}, {  99,  372}, 
{  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, 
{  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, 
{  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, 
{  99,  372}, {  99,  372}, {  99,   98}, {  99,  372}, {  99,  372}, 
{  99,  372}, {  99,  372}, {  99,  372}, {  99,  372}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, {   0,    0}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  168}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, { 107,  107}, 
{ 107,  107}, { 109,  189}, { 109,  189}, { 109,  189}, { 109,  189}, 
{ 109,  189}, { 109,  189}, { 109,  189}, { 109,  189}, { 109,  189}, 
{ 109,  189}, {   0,    0}, { 237,  228}, { 238,  160}, { 239,  206}, 
{ 242,   93}, { 244,  223}, { 247,  221}, { 109,   35}, { 109,   35}, 
{ 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, 
{ 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, 
{ 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, 
{ 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, 
{ 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, { 237,  228}, 
{ 238,  160}, { 239,  206}, { 242,   93}, { 244,  223}, { 247,  221}, 
{ 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, 
{ 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, 
{ 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, 
{ 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, 
{ 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, { 109,   35}, 
{ 109,   35}, { 110,  167}, { 110,  167}, { 110,  167}, { 110,  167}, 
{ 110,  167}, { 110,  167}, { 110,  167}, { 110,  167}, { 110,  167}, 
{ 110,  167}, {   0,    0}, {   0,    0}, {   0,    0}, { 248,  220}, 
{ 259,  235}, {   0,    0}, {   0,    0}, { 110,   32}, { 110,   32}, 
{ 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, 
{ 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, 
{ 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, 
{ 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, 
{ 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, { 245,  245}, 
{ 164,  269}, { 248,  220}, { 259,  235}, { 209,  175}, { 241,   72}, 
{ 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, 
{ 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, 
{ 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, 
{ 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, 
{ 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, { 110,   32}, 
{ 110,   32}, { 111,  108}, {   0,    0}, { 111,  108}, { 111,   36}, 
{ 209,  175}, { 241,   72}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, { 241,  378}, {   0,    0}, 
{   0,    0}, { 209,  378}, { 164,  103}, {   0,    0}, { 164,  735}, 
{ 245,  214}, { 263,  225}, { 164,  823}, { 111,  184}, { 111,  184}, 
{ 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, 
{ 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, 
{ 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, { 111,  636}, 
{ 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, 
{ 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, { 164,  103}, 
{ 192,  115}, { 164,  735}, { 245,  214}, { 263,  225}, { 164,  823}, 
{ 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, 
{ 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, 
{ 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, 
{ 111,  184}, { 111,  636}, { 111,  184}, { 111,  184}, { 111,  184}, 
{ 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, { 111,  184}, 
{ 111,  184}, { 113,   38}, {   0,    0}, {   0,    0}, { 224,  321}, 
{ 192,  307}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{ 113,  113}, { 113,  113}, { 113,  113}, { 113,  113}, { 113,  113}, 
{ 113,  113}, { 113,  113}, { 113,  113}, { 113,  113}, { 113,  113}, 
{   0,    0}, { 192,  342}, { 264,  232}, {   0,    0}, { 265,  226}, 
{ 240,  310}, { 190,  273}, { 113,  113}, { 113,  113}, { 113,  113}, 
{ 113,  113}, { 113,  113}, { 113,  113}, { 183,  108}, { 190,  107}, 
{ 183,  108}, { 224,  321}, { 192,  307}, { 183,  256}, { 183,  256}, 
{ 183,  256}, { 183,  256}, { 183,  256}, { 183,  256}, { 183,  256}, 
{ 183,  256}, { 183,  256}, { 183,  256}, {   0,    0}, { 224,  378}, 
{   0,    0}, {   0,    0}, { 190,   62}, { 192,  342}, { 264,  232}, 
{ 190,   63}, { 265,  226}, { 240,  310}, {   0,    0}, { 113,  113}, 
{ 113,  113}, { 113,  113}, { 113,  113}, { 113,  113}, { 113,  113}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 240,  378}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  168}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, { 121,  107}, 
{ 121,  107}, { 121,  107}, { 125,  342}, { 280,  278}, { 280,  278}, 
{ 280,  278}, { 280,  278}, { 280,  278}, { 280,  278}, { 280,  278}, 
{ 280,  278}, {   0,    0}, {   0,    0}, {   0,    0}, { 125,  342}, 
{ 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, 
{ 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, { 266,  227}, {   0,    0}, 
{   0,    0}, { 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, 
{ 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, 
{ 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, 
{ 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, 
{ 125,  192}, { 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, 
{ 125,  342}, { 125,  342}, { 130,  200}, { 131,  205}, { 233,  123}, 
{ 266,  227}, { 125,  342}, { 243,  211}, { 125,  342}, { 125,  342}, 
{ 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, 
{ 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, 
{ 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, 
{ 125,  342}, { 125,  342}, { 125,  192}, { 125,  342}, { 125,  342}, 
{ 125,  342}, { 125,  342}, { 125,  342}, { 125,  342}, { 142,   88}, 
{ 249,  311}, { 233,  123}, { 172,  158}, { 130,  144}, { 243,  211}, 
{ 130,  350}, {   0,    0}, { 142,  374}, { 130,  127}, { 131,  128}, 
{ 172,  210}, { 262,  241}, {   0,    0}, { 258,  270}, { 243,  378}, 
{ 267,  242}, { 261,  261}, { 233,  378}, { 130,  347}, { 130,  361}, 
{ 250,  244}, { 268,  267}, { 130,  330}, { 131,  331}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, { 142,   88}, { 249,  311}, {   0,    0}, { 172,  158}, 
{ 130,  144}, {   0,    0}, { 130,  350}, { 249,  378}, { 142,  374}, 
{ 130,  127}, { 131,  128}, { 172,  210}, { 262,  241}, { 132,  374}, 
{ 258,  270}, {   0,    0}, { 267,  242}, {   0,    0}, {   0,    0}, 
{ 130,  347}, { 130,  361}, { 250,  244}, { 268,  267}, { 130,  330}, 
{ 131,  331}, { 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, 
{ 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, 
{ 132,  374}, { 250,  378}, { 258,  378}, { 261,  233}, { 262,  378}, 
{ 270,  259}, {   0,    0}, { 268,  378}, { 132,  374}, { 132,  374}, 
{ 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, 
{ 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, 
{ 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, 
{ 132,  374}, { 132,  374}, { 132,  129}, { 132,  374}, { 132,  374}, 
{ 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, {   0,    0}, 
{ 261,  233}, { 274,  246}, { 270,  259}, { 132,  374}, { 284,  164}, 
{ 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, 
{ 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, 
{ 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, 
{ 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, { 132,  129}, 
{ 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, { 132,  374}, 
{ 132,  374}, { 134,  374}, {   0,    0}, { 274,  246}, {   0,    0}, 
{ 132,  378}, { 284,  164}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, { 134,  374}, { 134,  374}, 
{ 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, 
{ 134,  374}, { 134,  374}, { 134,  374}, {   0,    0}, { 288,  213}, 
{ 289,  216}, { 290,  274}, { 292,  133}, {   0,    0}, { 287,  258}, 
{ 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, { 134,   86}, 
{ 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, 
{ 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, 
{ 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, 
{ 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, 
{ 134,  374}, { 288,  213}, { 289,  216}, { 290,  274}, { 292,  133}, 
{ 134,  374}, { 287,  258}, { 134,  374}, { 134,  374}, { 134,  374}, 
{ 134,  374}, { 134,   86}, { 134,  374}, { 134,  374}, { 134,  374}, 
{ 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, 
{ 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, 
{ 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, { 134,  374}, 
{ 134,  374}, { 134,  374}, { 134,  374}, { 140,  374}, { 287,  378}, 
{   0,    0}, {   0,    0}, { 134,  378}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{ 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, 
{ 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, 
{   0,    0}, { 295,  132}, { 296,  146}, { 302,  257}, { 303,  292}, 
{   0,    0}, { 304,  141}, { 140,  374}, { 140,  374}, { 140,  374}, 
{ 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, 
{ 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, 
{ 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, { 140,  137}, 
{ 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, 
{ 140,  374}, { 140,  374}, { 140,  374}, { 295,  132}, { 296,  146}, 
{ 302,  257}, { 303,  292}, { 140,  374}, { 304,  141}, { 140,  374}, 
{ 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, 
{ 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, 
{ 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, 
{ 140,  374}, { 140,  137}, { 140,  374}, { 140,  374}, { 140,  374}, 
{ 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, { 140,  374}, 
{ 143,  374}, {   0,    0}, {   0,    0}, {   0,    0}, { 140,  378}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, { 143,  374}, { 143,  374}, { 143,  374}, 
{ 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, 
{ 143,  374}, { 143,  374}, {   0,    0}, { 305,  140}, { 308,  342}, 
{   0,    0}, { 311,  217}, {   0,    0}, { 308,  341}, { 143,  374}, 
{ 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, 
{ 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, 
{ 143,  374}, { 143,  374}, { 143,  374}, { 143,   79}, { 143,  374}, 
{ 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, 
{ 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, 
{ 305,  140}, { 308,  342}, { 309,  263}, { 311,  217}, { 143,  374}, 
{ 308,  341}, { 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, 
{ 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, 
{ 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, 
{ 143,   79}, { 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, 
{ 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, { 143,  374}, 
{ 143,  374}, { 143,  374}, { 145,  374}, {   0,    0}, { 309,  263}, 
{   0,    0}, { 143,  378}, { 260,  260}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, { 145,  374}, 
{ 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, 
{ 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, {   0,    0}, 
{   0,    0}, { 312,  268}, { 309,  378}, { 313,  182}, {   0,    0}, 
{ 315,  248}, { 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, 
{ 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, 
{ 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, 
{ 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, { 145,  138}, 
{ 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, 
{ 145,  374}, { 145,  374}, { 246,  204}, { 312,  268}, { 260,  236}, 
{ 313,  182}, { 145,  374}, { 315,  248}, { 145,  374}, { 145,  374}, 
{ 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, 
{ 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, 
{ 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, 
{ 145,  374}, { 145,  138}, { 145,  374}, { 145,  374}, { 145,  374}, 
{ 145,  374}, { 145,  374}, { 145,  374}, { 145,  374}, { 246,  204}, 
{ 163,  261}, { 260,  236}, { 273,  273}, { 145,  378}, { 163,  372}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{ 273,  107}, { 246,  378}, { 260,  378}, {   0,    0}, {   0,    0}, 
{   0,    0}, { 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, 
{ 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, 
{ 163,  372}, {   0,    0}, { 316,  247}, { 273,   62}, { 317,  209}, 
{ 314,  212}, { 273,   63}, { 331,  305}, { 163,  372}, { 163,  372}, 
{ 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, 
{ 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, 
{ 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, 
{ 163,  372}, { 163,  372}, { 163,  102}, { 163,  372}, { 163,  372}, 
{ 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, { 316,  247}, 
{   0,    0}, { 317,  209}, { 314,  212}, { 163,  372}, { 331,  305}, 
{ 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, 
{ 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, 
{ 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, 
{ 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, { 163,  102}, 
{ 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, { 163,  372}, 
{ 163,  372}, { 166,  188}, { 314,  378}, { 166,  372}, {   0,    0}, 
{   0,    0}, { 166,  255}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{ 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, 
{ 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, 
{   0,    0}, { 324,   31}, { 328,  196}, { 339,  303}, { 324,  372}, 
{   0,    0}, { 328,  372}, { 166,  372}, { 166,  372}, { 166,  372}, 
{ 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, 
{ 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, 
{ 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, 
{ 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, 
{ 166,  372}, { 166,  372}, { 166,  372}, { 324,   31}, { 328,  196}, 
{ 339,  303}, { 324,  372}, { 166,  372}, { 328,  372}, { 166,  372}, 
{ 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, 
{ 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, 
{ 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, 
{ 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, 
{ 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, { 166,  372}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{   0,    0}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  168}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{   0,    0}, { 168,  168}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  121}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, { 168,  107}, 
{ 168,  107}, { 168,  107}, { 180,  116}, { 180,  116}, { 180,  116}, 
{ 180,  116}, { 180,  116}, { 180,  116}, { 180,  116}, { 180,  116}, 
{ 180,  116}, { 180,  116}, {   0,    0}, {   0,    0}, { 319,  319}, 
{   0,    0}, { 334,  301}, { 341,  125}, {   0,    0}, { 185,  181}, 
{ 334,  374}, { 185,  181}, { 180,  201}, { 180,  183}, { 185,   37}, 
{ 185,   37}, { 185,   37}, { 185,   37}, { 185,   37}, { 185,   37}, 
{ 185,   37}, { 185,   37}, { 185,   37}, { 185,   37}, {   0,    0}, 
{   0,    0}, {   0,    0}, { 184,   36}, { 256,  256}, { 256,  256}, 
{ 256,  256}, { 256,  256}, { 256,  256}, { 256,  256}, { 256,  256}, 
{ 256,  256}, { 256,  256}, { 256,  256}, { 334,  301}, { 341,  125}, 
{ 319,  314}, { 343,  285}, { 334,  374}, {   0,    0}, { 180,  201}, 
{ 180,  183}, { 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, 
{ 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, 
{ 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, 
{ 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, 
{ 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, 
{ 184,  184}, { 184,  184}, { 319,  314}, { 343,  285}, {   0,    0}, 
{ 256,  109}, {   0,    0}, {   0,    0}, { 184,  184}, { 184,  184}, 
{ 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, 
{ 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, 
{ 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, 
{ 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, 
{ 184,  184}, { 184,  184}, { 184,  184}, { 184,  184}, { 186,  649}, 
{ 186,  184}, { 186,  184}, { 186,  185}, { 186,  111}, { 186,  620}, 
{ 186,  668}, { 186,  184}, { 186,  184}, { 186,  184}, { 186,  184}, 
{ 186,  661}, { 186,  184}, { 186,  631}, { 186,  646}, { 186,  184}, 
{ 186,  184}, { 186,  184}, { 186,  184}, { 186,  626}, { 186,  184}, 
{ 186,  184}, { 186,  184}, { 186,  642}, { 186,  184}, { 186,  184}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, { 186,  649}, { 186,  184}, { 186,  184}, { 186,  185}, 
{ 186,  111}, { 186,  620}, { 186,  668}, { 186,  184}, { 186,  184}, 
{ 186,  184}, { 186,  184}, { 186,  661}, { 186,  184}, { 186,  631}, 
{ 186,  646}, { 186,  184}, { 186,  184}, { 186,  184}, { 186,  184}, 
{ 186,  626}, { 186,  184}, { 186,  184}, { 186,  184}, { 186,  642}, 
{ 186,  184}, { 186,  184}, { 188,  187}, { 188,  187}, { 188,  187}, 
{ 188,  187}, { 188,  187}, { 188,  187}, { 188,  187}, { 188,  187}, 
{ 188,  187}, { 188,  187}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, { 344,  355}, { 188,  187}, 
{ 188,  187}, { 188,  187}, { 188,  187}, { 188,  187}, { 188,  187}, 
{   0,    0}, {   0,    0}, {   0,    0}, { 191,  342}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{ 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, 
{ 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, 
{ 344,  355}, { 188,  187}, { 188,  187}, { 188,  187}, { 188,  187}, 
{ 188,  187}, { 188,  187}, { 191,  342}, { 191,  342}, { 191,  342}, 
{ 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, 
{ 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, 
{ 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, 
{ 191,   73}, { 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, 
{ 191,  342}, { 191,  342}, { 191,  342}, {   0,    0}, { 318,  313}, 
{ 322,  215}, { 320,  288}, { 191,  342}, { 321,  290}, { 191,  342}, 
{ 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, 
{ 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, 
{ 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, 
{ 191,  342}, { 191,  342}, { 191,   73}, { 191,  342}, { 191,  342}, 
{ 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, { 191,  342}, 
{ 193,  260}, { 318,  313}, { 322,  215}, { 320,  288}, { 193,  374}, 
{ 321,  290}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, { 269,  269}, {   0,    0}, 
{ 322,  378}, { 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, 
{ 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, 
{ 193,  374}, {   0,    0}, {   0,    0}, { 318,  378}, { 320,  378}, 
{ 346,  336}, { 321,  378}, {   0,    0}, { 193,  374}, { 193,  374}, 
{ 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, 
{ 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, 
{ 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, 
{ 193,  374}, { 193,  374}, { 193,  143}, { 193,  374}, { 193,  374}, 
{ 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, { 196,  179}, 
{ 269,  243}, { 200,  200}, { 346,  336}, { 193,  374}, { 205,  205}, 
{ 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, 
{ 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, 
{ 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, 
{ 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, { 193,  143}, 
{ 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, { 193,  374}, 
{ 193,  374}, { 285,  324}, { 269,  243}, { 281,  101}, { 282,   99}, 
{ 196,  282}, { 326,  502}, { 200,  238}, { 347,  339}, { 200,  237}, 
{ 286,  283}, { 293,  374}, { 200,  172}, { 285,  372}, { 281,  372}, 
{ 205,  173}, { 326,  165}, { 282,  372}, { 269,  378}, { 286,  372}, 
{   0,    0}, { 196,  372}, { 200,  264}, { 200,  249}, { 293,  135}, 
{   0,    0}, { 200,  169}, {   0,    0}, { 349,  345}, { 205,  309}, 
{   0,    0}, {   0,    0}, {   0,    0}, { 285,  324}, {   0,    0}, 
{ 281,  101}, { 282,   99}, { 196,  282}, { 326,  502}, { 200,  238}, 
{ 347,  339}, { 200,  237}, { 286,  283}, { 293,  374}, { 200,  172}, 
{ 285,  372}, { 281,  372}, { 205,  173}, { 326,  165}, { 282,  372}, 
{ 310,  229}, { 286,  372}, { 323,  312}, { 196,  372}, { 200,  264}, 
{ 200,  249}, { 293,  135}, { 201,  181}, { 200,  169}, { 201,  181}, 
{ 349,  345}, { 205,  309}, { 201,   37}, { 201,   37}, { 201,   37}, 
{ 201,   37}, { 201,   37}, { 201,   37}, { 201,   37}, { 201,   37}, 
{ 201,   37}, { 201,   37}, { 255,  113}, { 255,  113}, { 255,  113}, 
{ 255,  113}, { 255,  113}, { 255,  113}, { 255,  113}, { 255,  113}, 
{ 255,  113}, { 255,  113}, { 310,  229}, {   0,    0}, { 323,  312}, 
{ 333,  294}, { 354,  308}, { 333,  374}, { 299,  374}, { 255,  113}, 
{ 255,  113}, { 255,  113}, { 255,  113}, { 255,  113}, { 255,  113}, 
{ 306,  275}, {   0,    0}, { 310,  378}, {   0,    0}, {   0,    0}, 
{ 306,  280}, {   0,    0}, { 323,  378}, {   0,    0}, {   0,    0}, 
{ 299,  147}, { 329,  299}, {   0,    0}, { 359,  352}, {   0,    0}, 
{ 360,  337}, { 329,  374}, {   0,    0}, {   0,    0}, {   0,    0}, 
{ 257,  374}, {   0,    0}, { 333,  294}, { 354,  308}, { 333,  374}, 
{ 299,  374}, { 255,  113}, { 255,  113}, { 255,  113}, { 255,  113}, 
{ 255,  113}, { 255,  113}, { 257,  374}, { 257,  374}, { 257,  374}, 
{ 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, 
{ 257,  374}, { 257,  374}, { 299,  147}, { 329,  299}, { 306,  372}, 
{ 359,  352}, { 201,  378}, { 360,  337}, { 329,  374}, { 257,  374}, 
{ 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, 
{ 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, 
{ 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, 
{ 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, 
{ 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, 
{   0,    0}, { 306,  372}, { 361,  293}, { 363,  148}, { 257,  374}, 
{ 364,  327}, { 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, 
{ 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, 
{ 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, 
{ 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, 
{ 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, { 257,  374}, 
{ 257,  374}, { 257,  374}, { 283,  372}, {   0,    0}, { 361,  293}, 
{ 363,  148}, {   0,    0}, { 364,  327}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, { 283,  372}, 
{ 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, 
{ 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, { 367,  367}, 
{ 340,  335}, { 368,  323}, {   0,    0}, { 370,  363}, {   0,    0}, 
{ 340, 1197}, { 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, 
{ 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, 
{ 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, { 283,  281}, 
{ 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, 
{ 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, 
{ 283,  372}, { 283,  372}, { 340,  335}, { 368,  323}, { 367,  315}, 
{ 370,  363}, { 283,  372}, { 340, 1197}, { 283,  372}, { 283,  372}, 
{ 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, 
{ 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, 
{ 283,  372}, { 283,  281}, { 283,  372}, { 283,  372}, { 283,  372}, 
{ 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, 
{ 283,  372}, { 283,  372}, { 283,  372}, { 283,  372}, { 291,  374}, 
{   0,    0}, { 367,  315}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, { 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, 
{ 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, 
{ 291,  374}, {   0,    0}, { 371,  370}, { 404,  455}, { 405,  406}, 
{ 406,  407}, {   0,    0}, { 404,  405}, { 291,  374}, { 291,  374}, 
{ 291,  134}, { 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, 
{ 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, 
{ 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, 
{ 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, 
{ 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, { 371,  370}, 
{ 404,  455}, { 405,  406}, { 406,  407}, { 291,  374}, { 404,  405}, 
{ 291,  374}, { 291,  374}, { 291,  134}, { 291,  374}, { 291,  374}, 
{ 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, 
{ 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, 
{ 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, 
{ 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, { 291,  374}, 
{ 291,  374}, { 294,  374}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, { 294,  374}, { 294,  374}, 
{ 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, 
{ 294,  374}, { 294,  374}, { 294,  374}, {   0,    0}, { 407,  408}, 
{ 408,  409}, { 409,  410}, { 410,  411}, {   0,    0}, { 412,  413}, 
{ 294,  291}, { 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, 
{ 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, 
{ 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, 
{ 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, 
{ 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, 
{ 294,  374}, { 407,  408}, { 408,  409}, { 409,  410}, { 410,  411}, 
{ 294,  374}, { 412,  413}, { 294,  291}, { 294,  374}, { 294,  374}, 
{ 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, 
{ 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, 
{ 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, 
{ 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, { 294,  374}, 
{ 294,  374}, { 294,  374}, { 294,  374}, { 297,  130}, { 298,  145}, 
{ 300,  374}, { 298,  297}, { 332,  374}, {   0,    0}, { 298, 1166}, 
{ 362, 1212}, { 337,  300}, { 350, 1048}, { 413,  414}, { 300,   75}, 
{ 332,  302}, { 298, 1085}, { 337,  374}, { 350,  349}, { 297, 1114}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{ 414,  415}, { 415,  416}, { 418,  419}, { 419,  420}, { 362,  332}, 
{ 297,  130}, { 298,  145}, { 300,  374}, { 298,  297}, { 332,  374}, 
{ 301,  374}, { 298, 1166}, { 362, 1212}, { 337,  300}, { 350, 1048}, 
{ 413,  414}, { 300,   75}, { 332,  302}, { 298, 1085}, { 337,  374}, 
{ 350,  349}, { 297, 1114}, { 301,  374}, { 301,  374}, { 301,  374}, 
{ 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, 
{ 301,  374}, { 301,  374}, { 414,  415}, { 415,  416}, { 418,  419}, 
{ 419,  420}, { 362,  332}, {   0,    0}, { 420,  421}, { 301,  374}, 
{ 301,  374}, { 301,  374}, { 301,  374}, { 301,  194}, { 301,  374}, 
{ 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, 
{ 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, 
{ 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, 
{ 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, 
{   0,    0}, { 421,  422}, { 423,  424}, { 424,  425}, { 301,  374}, 
{ 420,  421}, { 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, 
{ 301,  194}, { 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, 
{ 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, 
{ 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, 
{ 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, { 301,  374}, 
{ 301,  374}, { 301,  374}, { 307,  342}, { 421,  422}, { 423,  424}, 
{ 424,  425}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, { 307,  342}, 
{ 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, 
{ 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, {   0,    0}, 
{ 425,  426}, { 426,  427}, { 427,  428}, { 428,  429}, {   0,    0}, 
{ 429,  430}, { 307,  191}, { 307,  342}, { 307,  342}, { 307,  342}, 
{ 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, 
{ 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, 
{ 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, 
{ 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, 
{ 307,  342}, { 307,  342}, { 425,  426}, { 426,  427}, { 427,  428}, 
{ 428,  429}, { 307,  342}, { 429,  430}, { 307,  191}, { 307,  342}, 
{ 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, 
{ 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, 
{ 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, 
{ 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, 
{ 307,  342}, { 307,  342}, { 307,  342}, { 307,  342}, { 325,  372}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, { 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, 
{ 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, 
{ 325,  372}, {   0,    0}, { 430,  431}, { 431,  432}, { 432,  433}, 
{ 433,  434}, {   0,    0}, { 437,  438}, { 325,  372}, { 325,  372}, 
{ 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, 
{ 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, 
{ 325,  372}, { 325,  372}, { 325,  163}, { 325,  372}, { 325,  372}, 
{ 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, 
{ 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, { 430,  431}, 
{ 431,  432}, { 432,  433}, { 433,  434}, { 325,  372}, { 437,  438}, 
{ 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, 
{ 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, 
{ 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, { 325,  163}, 
{ 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, 
{ 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, { 325,  372}, 
{ 325,  372}, { 327,  372}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, { 327,  372}, { 327,  372}, 
{ 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, 
{ 327,  372}, { 327,  372}, { 327,  372}, {   0,    0}, { 435,  436}, 
{ 438,  439}, { 439,  440}, { 435,  449}, {   0,    0}, { 440,  441}, 
{ 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, 
{ 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, 
{ 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, 
{ 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, 
{ 327,  286}, { 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, 
{ 327,  372}, { 435,  436}, { 438,  439}, { 439,  440}, { 435,  449}, 
{ 327,  372}, { 440,  441}, { 327,  372}, { 327,  372}, { 327,  372}, 
{ 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, 
{ 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, 
{ 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, { 327,  372}, 
{ 327,  372}, { 327,  372}, { 327,  286}, { 327,  372}, { 327,  372}, 
{ 327,  372}, { 327,  372}, { 327,  372}, { 330,  374}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{ 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, 
{ 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, 
{   0,    0}, { 441,  442}, { 442,  443}, { 443,  444}, { 445,  446}, 
{   0,    0}, { 446,  447}, { 330,  374}, { 330,  374}, { 330,  374}, 
{ 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, { 330,  304}, 
{ 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, 
{ 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, 
{ 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, 
{ 330,  374}, { 330,  374}, { 330,  374}, { 441,  442}, { 442,  443}, 
{ 443,  444}, { 445,  446}, { 330,  374}, { 446,  447}, { 330,  374}, 
{ 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, 
{ 330,  374}, { 330,  304}, { 330,  374}, { 330,  374}, { 330,  374}, 
{ 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, 
{ 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, 
{ 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, { 330,  374}, 
{ 335,  374}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, { 335,  374}, { 335,  374}, { 335,  374}, 
{ 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, 
{ 335,  374}, { 335,  374}, {   0,    0}, { 447,  448}, { 449,  452}, 
{ 450,  451}, { 452,  453}, {   0,    0}, { 449,  450}, { 335,  374}, 
{ 335,  374}, { 335,  374}, { 335,  374}, { 335,  329}, { 335,  374}, 
{ 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, 
{ 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, 
{ 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, 
{ 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, 
{ 447,  448}, { 449,  452}, { 450,  451}, { 452,  453}, { 335,  374}, 
{ 449,  450}, { 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, 
{ 335,  329}, { 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, 
{ 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, 
{ 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, 
{ 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, { 335,  374}, 
{ 335,  374}, { 335,  374}, { 336,  374}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, { 336,  374}, 
{ 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, 
{ 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, {   0,    0}, 
{ 453,  454}, { 455,  456}, { 456,  457}, { 458,  459}, {   0,    0}, 
{ 459,  460}, { 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, 
{ 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, 
{ 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, 
{ 336,  374}, { 336,  374}, { 336,  374}, { 336,  333}, { 336,  374}, 
{ 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, 
{ 336,  374}, { 336,  374}, { 453,  454}, { 455,  456}, { 456,  457}, 
{ 458,  459}, { 336,  374}, { 459,  460}, { 336,  374}, { 336,  374}, 
{ 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, 
{ 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, 
{ 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, 
{ 336,  333}, { 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, 
{ 336,  374}, { 336,  374}, { 336,  374}, { 336,  374}, { 338,  374}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, { 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, 
{ 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, 
{ 338,  374}, {   0,    0}, { 460,  461}, { 461,  462}, { 462,  463}, 
{ 463,  464}, {   0,    0}, { 466,  467}, { 338,  374}, { 338,  374}, 
{ 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, 
{ 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, { 338,  142}, 
{ 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, 
{ 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, 
{ 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, { 460,  461}, 
{ 461,  462}, { 462,  463}, { 463,  464}, { 338,  374}, { 466,  467}, 
{ 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, 
{ 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, 
{ 338,  374}, { 338,  142}, { 338,  374}, { 338,  374}, { 338,  374}, 
{ 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, 
{ 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, { 338,  374}, 
{ 338,  374}, { 342,  342}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, { 342,  342}, { 342,  342}, 
{ 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, 
{ 342,  342}, { 342,  342}, { 342,  342}, {   0,    0}, { 465,  525}, 
{ 467,  468}, { 468,  469}, { 465,  466}, {   0,    0}, { 469,  470}, 
{ 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, 
{ 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, 
{ 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, 
{ 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, 
{ 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, 
{ 342,  342}, { 465,  525}, { 467,  468}, { 468,  469}, { 465,  466}, 
{ 342,  342}, { 469,  470}, { 342,  342}, { 342,  342}, { 342,  342}, 
{ 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, 
{ 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, 
{ 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, 
{ 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, { 342,  342}, 
{ 342,  342}, { 342,  342}, { 342,  342}, { 345,  338}, { 348, 1227}, 
{ 351,  374}, { 471,  472}, { 472,  473}, { 348,  340}, { 475,  476}, 
{ 345,  374}, { 353,  359}, { 351,  193}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, { 348, 1096}, { 348, 1270}, 
{ 353, 1059}, { 476,  477}, { 477,  478}, { 353, 1134}, { 483,  484}, 
{   0,    0}, {   0,    0}, {   0,    0}, { 352,  374}, {   0,    0}, 
{ 345,  338}, { 348, 1227}, { 351,  374}, { 471,  472}, { 472,  473}, 
{ 348,  340}, { 475,  476}, { 345,  374}, { 353,  359}, { 351,  193}, 
{ 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, 
{ 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, 
{ 348, 1096}, { 348, 1270}, { 353, 1059}, { 476,  477}, { 477,  478}, 
{ 353, 1134}, { 483,  484}, { 352,  374}, { 352,  374}, { 352,  374}, 
{ 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, 
{ 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, 
{ 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, 
{ 352,  374}, { 352,  374}, { 352,  334}, { 352,  374}, { 352,  374}, 
{ 352,  374}, { 352,  374}, { 352,  374}, {   0,    0}, { 366,  366}, 
{   0,    0}, {   0,    0}, { 352,  374}, {   0,    0}, { 352,  374}, 
{ 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, 
{ 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, 
{ 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, 
{ 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, { 352,  334}, 
{ 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, { 352,  374}, 
{ 355,  328}, { 356,  827}, { 358,  374}, { 357,  364}, { 366,  234}, 
{ 356,  705}, { 484,  485}, { 485,  486}, { 376, 1051}, { 356,  850}, 
{   0,    0}, { 365,  272}, { 355,  372}, { 357,  372}, { 358,  346}, 
{ 356,  343}, { 365,  279}, { 366,  322}, { 373, 1123}, { 376,  371}, 
{ 417,  437}, {   0,    0}, { 474,  475}, { 482,  483}, { 479,  480}, 
{ 373, 1159}, { 373,  353}, { 482,  494}, { 417,  418}, { 474,  584}, 
{ 479,  556}, {   0,    0}, { 355,  328}, { 356,  827}, { 358,  374}, 
{ 357,  364}, { 366,  234}, { 356,  705}, { 484,  485}, { 485,  486}, 
{ 376, 1051}, { 356,  850}, { 365,  727}, {   0,    0}, { 355,  372}, 
{ 357,  372}, { 358,  346}, { 356,  343}, {   0,    0}, { 366,  322}, 
{ 373, 1123}, { 376,  371}, { 417,  437}, { 365,  344}, { 474,  475}, 
{ 482,  483}, { 479,  480}, { 373, 1159}, { 373,  353}, { 482,  494}, 
{ 417,  418}, { 474,  584}, { 479,  556}, { 369,  342}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, { 365,  727}, 
{ 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, 
{ 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, 
{ 365,  344}, { 480,  607}, { 487,  488}, { 489,  490}, { 480,  481}, 
{   0,    0}, { 490,  491}, { 369,  342}, { 369,  342}, { 369,  342}, 
{ 369,  342}, { 369,  354}, { 369,  342}, { 369,  342}, { 369,  342}, 
{ 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, 
{ 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, 
{ 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, 
{ 369,  342}, { 369,  342}, { 369,  342}, { 480,  607}, { 487,  488}, 
{ 489,  490}, { 480,  481}, { 369,  342}, { 490,  491}, { 369,  342}, 
{ 369,  342}, { 369,  342}, { 369,  342}, { 369,  354}, { 369,  342}, 
{ 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, 
{ 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, 
{ 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, 
{ 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, { 369,  342}, 
{ 372,  372}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, { 372,  372}, { 372,  372}, { 372,  372}, 
{ 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, 
{ 372,  372}, { 372,  372}, {   0,    0}, { 491,  492}, { 488,  516}, 
{ 492,  493}, { 496,  497}, {   0,    0}, { 488,  489}, { 372,  372}, 
{ 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, 
{ 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, 
{ 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, 
{ 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, 
{ 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, 
{ 491,  492}, { 488,  516}, { 492,  493}, { 496,  497}, { 372,  372}, 
{ 488,  489}, { 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, 
{ 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, 
{ 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, 
{ 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, 
{ 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, { 372,  372}, 
{ 372,  372}, { 372,  372}, { 374,  374}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, { 374,  374}, 
{ 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, 
{ 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, {   0,    0}, 
{ 497,  498}, { 498,  499}, { 499,  500}, { 500,  501}, {   0,    0}, 
{ 502,  503}, { 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, 
{ 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, 
{ 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, 
{ 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, 
{ 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, 
{ 374,  374}, { 374,  374}, { 497,  498}, { 498,  499}, { 499,  500}, 
{ 500,  501}, { 374,  374}, { 502,  503}, { 374,  374}, { 374,  374}, 
{ 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, 
{ 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, 
{ 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, 
{ 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, 
{ 374,  374}, { 374,  374}, { 374,  374}, { 374,  374}, { 375, 1255}, 
{ 495,  547}, { 494,  602}, { 504,  505}, { 375, 1019}, { 494,  495}, 
{ 505,  506}, { 506,  507}, { 375, 1219}, { 507,  508}, { 508,  509}, 
{ 510,  511}, { 511,  512}, { 495,  496}, { 375,  360}, { 512,  513}, 
{ 514,  515}, { 515,  588}, { 516,  517}, { 517,  518}, { 494,  504}, 
{ 518,  519}, { 516,  564}, { 519,  520}, { 520,  521}, { 521,  522}, 
{ 522,  523}, { 523,  524}, { 525,  526}, { 526,  527}, { 527,  528}, 
{ 528,  529}, { 375, 1255}, { 495,  547}, { 494,  602}, { 504,  505}, 
{ 375, 1019}, { 494,  495}, { 505,  506}, { 506,  507}, { 375, 1219}, 
{ 507,  508}, { 508,  509}, { 510,  511}, { 511,  512}, { 495,  496}, 
{ 375,  360}, { 512,  513}, { 514,  515}, { 515,  588}, { 516,  517}, 
{ 517,  518}, { 494,  504}, { 518,  519}, { 516,  564}, { 519,  520}, 
{ 520,  521}, { 521,  522}, { 522,  523}, { 523,  524}, { 525,  526}, 
{ 526,  527}, { 527,  528}, { 528,  529}, { 529,  530}, { 530,  531}, 
{ 532,  533}, { 533,  534}, { 534,  535}, { 535,  536}, { 536,  537}, 
{ 537,  538}, { 538,  539}, { 533,  590}, { 539,  540}, { 541,  542}, 
{ 542,  543}, { 543,  544}, { 544,  545}, { 545,  546}, { 547,  548}, 
{ 548,  549}, { 532,  541}, { 549,  550}, { 550,  551}, { 551,  552}, 
{ 552,  553}, { 553,  554}, { 554,  555}, { 556,  557}, { 557,  558}, 
{ 558,  559}, { 559,  560}, { 560,  561}, { 561,  562}, { 562,  563}, 
{ 529,  530}, { 530,  531}, { 532,  533}, { 533,  534}, { 534,  535}, 
{ 535,  536}, { 536,  537}, { 537,  538}, { 538,  539}, { 533,  590}, 
{ 539,  540}, { 541,  542}, { 542,  543}, { 543,  544}, { 544,  545}, 
{ 545,  546}, { 547,  548}, { 548,  549}, { 532,  541}, { 549,  550}, 
{ 550,  551}, { 551,  552}, { 552,  553}, { 553,  554}, { 554,  555}, 
{ 556,  557}, { 557,  558}, { 558,  559}, { 559,  560}, { 560,  561}, 
{ 561,  562}, { 562,  563}, { 564,  565}, { 565,  566}, { 566,  567}, 
{ 567,  568}, { 569,  570}, { 570,  571}, { 572,  573}, { 573,  574}, 
{ 574,  575}, { 575,  576}, { 576,  577}, { 578,  579}, { 579,  580}, 
{ 580,  581}, { 581,  582}, { 582,  583}, { 584,  585}, { 585,  586}, 
{ 586,  587}, { 588,  589}, { 590,  591}, { 591,  592}, { 592,  593}, 
{ 593,  594}, { 594,  595}, { 595,  596}, { 596,  597}, { 598,  599}, 
{ 599,  600}, { 600,  601}, { 602,  603}, { 603,  604}, { 564,  565}, 
{ 565,  566}, { 566,  567}, { 567,  568}, { 569,  570}, { 570,  571}, 
{ 572,  573}, { 573,  574}, { 574,  575}, { 575,  576}, { 576,  577}, 
{ 578,  579}, { 579,  580}, { 580,  581}, { 581,  582}, { 582,  583}, 
{ 584,  585}, { 585,  586}, { 586,  587}, { 588,  589}, { 590,  591}, 
{ 591,  592}, { 592,  593}, { 593,  594}, { 594,  595}, { 595,  596}, 
{ 596,  597}, { 598,  599}, { 599,  600}, { 600,  601}, { 602,  603}, 
{ 603,  604}, { 604,  605}, { 605,  606}, { 607,  608}, { 608,  609}, 
{ 610,  611}, { 611,  612}, { 612,  613}, { 613,  614}, { 614,  615}, 
{ 615,  616}, { 616,  617}, { 617,  618}, { 618,  619}, { 620,  621}, 
{ 621,  622}, { 622,  623}, { 623,  624}, { 626,  627}, { 627,  628}, 
{ 628,  629}, { 631,  632}, { 632,  680}, { 633,  634}, { 636,  675}, 
{   0,    0}, { 639,  640}, { 642,  643}, { 643,  644}, { 646,  647}, 
{ 649,  650}, { 631,  639}, {   0,    0}, { 604,  605}, { 605,  606}, 
{ 607,  608}, { 608,  609}, { 610,  611}, { 611,  612}, { 612,  613}, 
{ 613,  614}, { 614,  615}, { 615,  616}, { 616,  617}, { 617,  618}, 
{ 618,  619}, { 620,  621}, { 621,  622}, { 622,  623}, { 623,  624}, 
{ 626,  627}, { 627,  628}, { 628,  629}, { 631,  632}, { 650,  651}, 
{ 633,  634}, { 661,  662}, { 632,  633}, { 639,  640}, { 642,  643}, 
{ 643,  644}, { 646,  647}, { 649,  650}, { 631,  639}, { 636,  637}, 
{ 668,  669}, { 700,  701}, { 698,  881}, { 701,  711}, { 702,  703}, 
{ 703,  704}, { 661,  664}, { 701,  702}, { 705,  782}, { 698,  801}, 
{ 706,  707}, { 700,  754}, { 707,  708}, { 705,  706}, { 708,  709}, 
{ 668,  671}, { 698,  699}, { 709,  710}, { 711,  712}, { 712,  713}, 
{ 714,  715}, { 650,  651}, { 716,  717}, { 661,  662}, { 632,  633}, 
{ 717,  718}, { 698,  969}, { 718,  719}, { 721,  722}, { 722,  723}, 
{ 723,  724}, { 636,  637}, { 668,  669}, { 700,  701}, { 698,  881}, 
{ 701,  711}, { 702,  703}, { 703,  704}, { 661,  664}, { 701,  702}, 
{ 705,  782}, { 698,  801}, { 706,  707}, { 700,  754}, { 707,  708}, 
{ 705,  706}, { 708,  709}, { 668,  671}, { 698,  699}, { 709,  710}, 
{ 711,  712}, { 712,  713}, { 714,  715}, { 715,  758}, { 716,  717}, 
{ 715,  956}, { 720,  721}, { 717,  718}, { 698,  969}, { 718,  719}, 
{ 721,  722}, { 722,  723}, { 723,  724}, { 724,  725}, { 725,  726}, 
{ 727,  728}, { 720,  760}, { 728,  729}, { 729,  730}, { 730,  731}, 
{ 731,  732}, { 715,  919}, { 715,  767}, { 732,  733}, { 733,  734}, 
{ 715,  716}, { 735,  736}, { 736,  737}, { 737,  738}, { 738,  739}, 
{   0,    0}, { 741,  742}, { 742,  743}, { 743,  744}, {   0,    0}, 
{ 715,  758}, {   0,    0}, { 715,  956}, { 720,  721}, {   0,    0}, 
{   0,    0}, {   0,    0}, { 752,  753}, {   0,    0}, {   0,    0}, 
{ 724,  725}, { 725,  726}, { 727,  728}, { 720,  760}, { 728,  729}, 
{ 729,  730}, { 730,  731}, { 731,  732}, { 715,  919}, { 715,  767}, 
{ 732,  733}, { 733,  734}, { 715,  716}, { 735,  736}, { 736,  737}, 
{ 737,  738}, { 738,  739}, { 740,  798}, { 741,  742}, { 742,  743}, 
{ 743,  744}, { 746,  747}, { 747,  748}, { 745,  818}, { 740,  985}, 
{ 745,  746}, { 747,  813}, { 750,  751}, { 740,  741}, { 752,  753}, 
{ 745,  821}, { 740,  775}, {   0,    0}, { 750,  928}, { 751,  752}, 
{   0,    0}, { 746,  909}, { 754,  755}, { 755,  756}, { 756,  757}, 
{ 758,  759}, { 740,  763}, { 751,  872}, {   0,    0}, { 761,  762}, 
{ 763,  764}, { 764,  765}, { 749,  842}, { 758,  996}, { 740,  798}, 
{ 765,  766}, { 767,  768}, { 768,  769}, { 746,  747}, { 747,  748}, 
{ 745,  818}, { 740,  985}, { 745,  746}, { 747,  813}, { 750,  751}, 
{ 740,  741}, { 749,  886}, { 745,  821}, { 740,  775}, { 749,  750}, 
{ 750,  928}, { 751,  752}, { 749,  876}, { 746,  909}, { 754,  755}, 
{ 755,  756}, { 756,  757}, { 758,  759}, { 740,  763}, { 751,  872}, 
{ 760,  761}, { 761,  762}, { 763,  764}, { 764,  765}, { 749,  842}, 
{ 758,  996}, { 769,  770}, { 765,  766}, { 767,  768}, { 768,  769}, 
{ 771,  862}, { 760,  830}, { 772,  773}, { 773,  774}, { 771,  865}, 
{ 775,  974}, { 775,  776}, { 776,  777}, { 749,  886}, { 777,  778}, 
{ 778,  779}, { 749,  750}, { 779,  780}, { 780,  781}, { 749,  876}, 
{ 782,  783}, { 783,  784}, { 784,  785}, { 785,  786}, { 771,  772}, 
{ 771,  941}, { 786,  787}, { 760,  761}, { 787,  788}, { 788,  789}, 
{ 791,  792}, { 792,  793}, { 793,  794}, { 769,  770}, {   0,    0}, 
{ 794,  795}, { 795,  796}, { 771,  862}, { 760,  830}, { 772,  773}, 
{ 773,  774}, { 771,  865}, { 775,  974}, { 775,  776}, { 776,  777}, 
{ 798,  799}, { 777,  778}, { 778,  779}, { 799,  800}, { 779,  780}, 
{ 780,  781}, { 801,  802}, { 782,  783}, { 783,  784}, { 784,  785}, 
{ 785,  786}, { 771,  772}, { 771,  941}, { 786,  787}, { 790,  791}, 
{ 787,  788}, { 788,  789}, { 791,  792}, { 792,  793}, { 793,  794}, 
{ 790,  858}, { 790,  804}, { 794,  795}, { 795,  796}, { 796,  915}, 
{ 802,  803}, { 804,  805}, { 805,  806}, { 796,  797}, { 806,  807}, 
{ 807,  808}, { 808,  809}, { 798,  799}, { 809,  810}, { 810,  811}, 
{ 799,  800}, { 811,  812}, { 813,  814}, { 801,  802}, { 814,  815}, 
{ 815,  816}, { 816,  817}, { 818,  819}, { 819,  820}, { 821,  822}, 
{ 825,  826}, { 790,  791}, { 824,  993}, { 827,  828}, { 828,  829}, 
{ 831,  832}, { 823,  824}, { 790,  858}, { 790,  804}, { 824,  825}, 
{ 832,  833}, { 796,  915}, { 802,  803}, { 804,  805}, { 805,  806}, 
{ 796,  797}, { 806,  807}, { 807,  808}, { 808,  809}, { 823,  836}, 
{ 809,  810}, { 810,  811}, { 833,  834}, { 811,  812}, { 813,  814}, 
{ 834,  835}, { 814,  815}, { 815,  816}, { 816,  817}, { 818,  819}, 
{ 819,  820}, { 821,  822}, { 825,  826}, { 830,  831}, { 824,  993}, 
{ 827,  828}, { 828,  829}, { 831,  832}, { 823,  824}, { 836,  837}, 
{ 837,  838}, { 824,  825}, { 832,  833}, { 838,  839}, { 839,  840}, 
{ 840,  841}, { 830,  963}, { 842,  843}, { 842,  898}, { 843,  844}, 
{ 844,  845}, { 823,  836}, { 845,  846}, { 846,  847}, { 833,  834}, 
{ 847,  848}, { 848,  849}, { 834,  835}, { 850,  851}, { 851,  852}, 
{ 852,  853}, { 853,  854}, { 854,  855}, { 855,  856}, { 856,  857}, 
{ 830,  831}, { 858,  859}, { 859,  860}, { 860,  861}, { 862,  863}, 
{ 863,  864}, { 836,  837}, { 837,  838}, { 865,  866}, { 866,  867}, 
{ 838,  839}, { 839,  840}, { 840,  841}, { 830,  963}, { 842,  843}, 
{ 842,  898}, { 843,  844}, { 844,  845}, { 867,  868}, { 845,  846}, 
{ 846,  847}, { 868,  869}, { 847,  848}, { 848,  849}, { 869,  870}, 
{ 850,  851}, { 851,  852}, { 852,  853}, { 853,  854}, { 854,  855}, 
{ 855,  856}, { 856,  857}, { 870,  871}, { 858,  859}, { 859,  860}, 
{ 860,  861}, { 862,  863}, { 863,  864}, { 872,  873}, { 873,  874}, 
{ 865,  866}, { 866,  867}, { 874,  875}, { 876,  877}, { 877,  878}, 
{ 878,  879}, { 879,  880}, { 881,  882}, { 882,  883}, { 883,  884}, 
{ 867,  868}, { 884,  885}, { 886,  887}, { 868,  869}, { 887,  888}, 
{ 888,  889}, { 869,  870}, { 889,  890}, { 890,  891}, { 876,  972}, 
{ 893,  894}, { 895,  896}, { 896,  897}, { 898,  899}, { 870,  871}, 
{ 900,  901}, { 901,  902}, {   0,    0}, { 892,  893}, { 904,  905}, 
{ 872,  873}, { 873,  874}, { 905,  906}, { 906,  907}, { 874,  875}, 
{ 876,  877}, { 877,  878}, { 878,  879}, { 879,  880}, { 881,  882}, 
{ 882,  883}, { 883,  884}, { 892,  923}, { 884,  885}, { 886,  887}, 
{ 903,  904}, { 887,  888}, { 888,  889}, { 907,  908}, { 889,  890}, 
{ 890,  891}, { 876,  972}, { 893,  894}, { 895,  896}, { 896,  897}, 
{ 898,  899}, { 909,  910}, { 900,  901}, { 901,  902}, { 903,  979}, 
{ 892,  893}, { 904,  905}, { 910,  911}, { 911,  912}, { 905,  906}, 
{ 906,  907}, { 912,  913}, { 913,  914}, { 915,  916}, { 916,  917}, 
{ 917,  918}, { 919,  920}, { 920,  921}, { 921,  922}, { 892,  923}, 
{ 923,  924}, { 924,  925}, { 903,  904}, { 925,  926}, { 926,  927}, 
{ 907,  908}, { 928,  950}, { 929,  930}, { 930,  931}, { 931,  932}, 
{ 928,  929}, { 933,  934}, { 934,  935}, { 909,  910}, { 935,  936}, 
{ 936,  937}, { 903,  979}, { 937,  938}, { 938,  939}, { 910,  911}, 
{ 911,  912}, { 939,  940}, { 941,  942}, { 912,  913}, { 913,  914}, 
{ 915,  916}, { 916,  917}, { 917,  918}, { 919,  920}, { 920,  921}, 
{ 921,  922}, { 942,  943}, { 923,  924}, { 924,  925}, { 943,  944}, 
{ 925,  926}, { 926,  927}, { 944,  945}, { 928,  950}, { 929,  930}, 
{ 930,  931}, { 931,  932}, { 928,  929}, { 933,  934}, { 934,  935}, 
{ 945,  946}, { 935,  936}, { 936,  937}, { 946,  947}, { 937,  938}, 
{ 938,  939}, { 947,  948}, { 948,  949}, { 939,  940}, { 941,  942}, 
{ 950,  951}, { 951,  952}, { 952,  953}, { 953,  954}, { 954,  955}, 
{ 956,  957}, { 957,  958}, { 958,  959}, { 942,  943}, { 959,  960}, 
{ 960,  961}, { 943,  944}, { 961,  962}, { 963,  964}, { 944,  945}, 
{ 964,  965}, { 965,  966}, { 966,  967}, { 967,  968}, { 969,  970}, 
{ 970,  971}, { 972,  973}, { 945,  946}, { 974,  975}, { 975,  976}, 
{ 946,  947}, { 976,  977}, { 977,  978}, { 947,  948}, { 948,  949}, 
{ 979,  980}, { 980,  981}, { 950,  951}, { 951,  952}, { 952,  953}, 
{ 953,  954}, { 954,  955}, { 956,  957}, { 957,  958}, { 958,  959}, 
{ 981,  982}, { 959,  960}, { 960,  961}, { 982,  983}, { 961,  962}, 
{ 963,  964}, { 983,  984}, { 964,  965}, { 965,  966}, { 966,  967}, 
{ 967,  968}, { 969,  970}, { 970,  971}, { 972,  973}, { 985,  986}, 
{ 974,  975}, { 975,  976}, { 986,  987}, { 976,  977}, { 977,  978}, 
{ 987,  988}, { 988,  989}, { 979,  980}, { 980,  981}, { 989,  990}, 
{ 990,  991}, { 991,  992}, { 993,  994}, { 994,  995}, { 997,  998}, 
{ 998,  999}, { 999, 1000}, { 981,  982}, {1000, 1001}, {1001, 1002}, 
{ 982,  983}, {1003, 1004}, {1005, 1006}, { 983,  984}, {1013, 1014}, 
{1014, 1015}, {1015, 1016}, {1016, 1017}, {1017, 1018}, {1012, 1176}, 
{1019, 1020}, { 985,  986}, {1020, 1021}, {1021, 1022}, { 986,  987}, 
{1022, 1023}, {1023, 1024}, { 987,  988}, { 988,  989}, {1024, 1025}, 
{1025, 1026}, { 989,  990}, { 990,  991}, { 991,  992}, { 993,  994}, 
{ 994,  995}, { 997,  998}, { 998,  999}, { 999, 1000}, {1012, 1013}, 
{1000, 1001}, {1001, 1002}, {1026, 1027}, {1003, 1004}, {1005, 1006}, 
{1029, 1030}, {1013, 1014}, {1014, 1015}, {1015, 1016}, {1016, 1017}, 
{1017, 1018}, {1012, 1176}, {1019, 1020}, {1028, 1029}, {1020, 1021}, 
{1021, 1022}, {1030, 1031}, {1022, 1023}, {1023, 1024}, {1031, 1032}, 
{1028, 1109}, {1024, 1025}, {1025, 1026}, {1032, 1033}, {1033, 1034}, 
{1034, 1187}, {1036, 1037}, {1037, 1038}, {1038, 1124}, {1034, 1035}, 
{1039, 1040}, {1012, 1013}, {1036, 1263}, {1040, 1041}, {1026, 1027}, 
{1042, 1043}, {1044, 1045}, {1029, 1030}, {1045, 1046}, {1046, 1047}, 
{1038, 1039}, {1048, 1049}, {1049, 1050}, {1051, 1052}, {1043, 1083}, 
{1028, 1029}, {1043, 1279}, {1052, 1053}, {1030, 1031}, {1053, 1054}, 
{1054, 1055}, {1031, 1032}, {1028, 1109}, {1055, 1056}, {1056, 1057}, 
{1032, 1033}, {1033, 1034}, {1034, 1187}, {1036, 1037}, {1037, 1038}, 
{1038, 1124}, {1034, 1035}, {1039, 1040}, {1043, 1092}, {1036, 1263}, 
{1040, 1041}, {1043, 1044}, {1042, 1043}, {1044, 1045}, {1057, 1058}, 
{1045, 1046}, {1046, 1047}, {1038, 1039}, {1048, 1049}, {1049, 1050}, 
{1051, 1052}, {1043, 1083}, {1059, 1060}, {1043, 1279}, {1052, 1053}, 
{1060, 1061}, {1053, 1054}, {1054, 1055}, {1061, 1062}, {1062, 1063}, 
{1055, 1056}, {1056, 1057}, {1065, 1066}, {1066, 1067}, {1064, 1106}, 
{1067, 1068}, {1069, 1070}, {1070, 1071}, {1071, 1072}, {1073, 1147}, 
{1043, 1092}, {1064, 1299}, {1076, 1077}, {1043, 1044}, {1074, 1075}, 
{1064, 1065}, {1057, 1058}, {1075, 1076}, {1064, 1099}, {1079, 1080}, 
{1074, 1294}, {1080, 1081}, {1070, 1242}, {1073, 1191}, {1059, 1060}, 
{1075, 1203}, {1073, 1074}, {1060, 1061}, {1064, 1088}, {1073, 1207}, 
{1061, 1062}, {1062, 1063}, {1078, 1119}, {1081, 1082}, {1065, 1066}, 
{1066, 1067}, {1064, 1106}, {1067, 1068}, {1069, 1070}, {1070, 1071}, 
{1071, 1072}, {1073, 1147}, {1078, 1079}, {1064, 1299}, {1076, 1077}, 
{1086, 1087}, {1074, 1075}, {1064, 1065}, {1083, 1084}, {1075, 1076}, 
{1064, 1099}, {1079, 1080}, {1074, 1294}, {1080, 1081}, {1070, 1242}, 
{1073, 1191}, {1083, 1317}, {1075, 1203}, {1073, 1074}, {1085, 1086}, 
{1064, 1088}, {1073, 1207}, {1088, 1089}, {1089, 1090}, {1078, 1119}, 
{1081, 1082}, {1090, 1091}, {1092, 1093}, {1093, 1094}, {1094, 1095}, 
{1085, 1236}, {1096, 1097}, {1097, 1098}, {1100, 1101}, {1078, 1079}, 
{1099, 1183}, {1099, 1100}, {1086, 1087}, {1101, 1130}, {1102, 1103}, 
{1083, 1084}, {1103, 1104}, {1104, 1105}, {1106, 1107}, {1107, 1108}, 
{1109, 1110}, {1101, 1102}, {1110, 1111}, {1083, 1317}, {1111, 1112}, 
{1106, 1117}, {1085, 1086}, {1112, 1113}, {1114, 1115}, {1088, 1089}, 
{1089, 1090}, {1115, 1116}, {1117, 1118}, {1090, 1091}, {1092, 1093}, 
{1093, 1094}, {1094, 1095}, {1085, 1236}, {1096, 1097}, {1097, 1098}, 
{1100, 1101}, {1119, 1120}, {1099, 1183}, {1099, 1100}, {1120, 1121}, 
{1101, 1130}, {1102, 1103}, {1121, 1122}, {1103, 1104}, {1104, 1105}, 
{1106, 1107}, {1107, 1108}, {1109, 1110}, {1101, 1102}, {1110, 1111}, 
{1124, 1125}, {1111, 1112}, {1106, 1117}, {1125, 1126}, {1112, 1113}, 
{1114, 1115}, {1127, 1128}, {1128, 1129}, {1115, 1116}, {1117, 1118}, 
{1130, 1131}, {1131, 1132}, {1132, 1133}, {1134, 1135}, {1136, 1137}, 
{1137, 1138}, {1135, 1318}, {1138, 1139}, {1119, 1120}, {1139, 1140}, 
{1141, 1142}, {1120, 1121}, {1142, 1143}, {1135, 1217}, {1121, 1122}, 
{1144, 1145}, {1134, 1230}, {1135, 1136}, {1145, 1146}, {1147, 1248}, 
{1147, 1148}, {1148, 1149}, {1124, 1125}, {1150, 1151}, {1141, 1258}, 
{1125, 1126}, {1151, 1152}, {1154, 1155}, {1127, 1128}, {1128, 1129}, 
{1155, 1156}, {1156, 1157}, {1130, 1131}, {1131, 1132}, {1132, 1133}, 
{1134, 1135}, {1136, 1137}, {1137, 1138}, {1135, 1318}, {1138, 1139}, 
{1153, 1154}, {1139, 1140}, {1141, 1142}, {1157, 1158}, {1142, 1143}, 
{1135, 1217}, {1159, 1160}, {1144, 1145}, {1134, 1230}, {1135, 1136}, 
{1145, 1146}, {1147, 1248}, {1147, 1148}, {1148, 1149}, {1153, 1307}, 
{1150, 1151}, {1141, 1258}, {1160, 1161}, {1151, 1152}, {1154, 1155}, 
{1161, 1162}, {1162, 1163}, {1155, 1156}, {1156, 1157}, {1163, 1164}, 
{1164, 1165}, {1166, 1167}, {1167, 1168}, {1168, 1169}, {1169, 1170}, 
{1170, 1171}, {1171, 1172}, {1153, 1154}, {1172, 1173}, {1173, 1174}, 
{1157, 1158}, {1174, 1175}, {1176, 1177}, {1159, 1160}, {1177, 1178}, 
{1178, 1179}, {1179, 1180}, {1180, 1181}, {1181, 1182}, {1183, 1184}, 
{1184, 1185}, {1153, 1307}, {1183, 1313}, {1185, 1186}, {1160, 1161}, 
{1187, 1188}, {1188, 1189}, {1161, 1162}, {1162, 1163}, {1189, 1190}, 
{1191, 1192}, {1163, 1164}, {1164, 1165}, {1166, 1167}, {1167, 1168}, 
{1168, 1169}, {1169, 1170}, {1170, 1171}, {1171, 1172}, {1192, 1193}, 
{1172, 1173}, {1173, 1174}, {1193, 1194}, {1174, 1175}, {1176, 1177}, 
{1194, 1195}, {1177, 1178}, {1178, 1179}, {1179, 1180}, {1180, 1181}, 
{1181, 1182}, {1183, 1184}, {1184, 1185}, {1195, 1196}, {1183, 1313}, 
{1185, 1186}, {1197, 1198}, {1187, 1188}, {1188, 1189}, {1198, 1199}, 
{1199, 1200}, {1189, 1190}, {1191, 1192}, {1200, 1201}, {1201, 1202}, 
{1203, 1204}, {1204, 1205}, {1205, 1206}, {1207, 1208}, {1208, 1209}, 
{1209, 1210}, {1192, 1193}, {1210, 1211}, {1212, 1213}, {1193, 1194}, 
{1213, 1214}, {1214, 1215}, {1194, 1195}, {1215, 1216}, {1217, 1218}, 
{1219, 1220}, {1220, 1221}, {1221, 1222}, {1222, 1223}, {1207, 1292}, 
{1195, 1196}, {1223, 1224}, {1224, 1225}, {1197, 1198}, {1225, 1226}, 
{1227, 1228}, {1198, 1199}, {1199, 1200}, {1228, 1229}, {1230, 1231}, 
{1200, 1201}, {1201, 1202}, {1203, 1204}, {1204, 1205}, {1205, 1206}, 
{1207, 1208}, {1208, 1209}, {1209, 1210}, {1231, 1232}, {1210, 1211}, 
{1212, 1213}, {1232, 1233}, {1213, 1214}, {1214, 1215}, {1233, 1234}, 
{1215, 1216}, {1217, 1218}, {1219, 1220}, {1220, 1221}, {1221, 1222}, 
{1222, 1223}, {1207, 1292}, {1234, 1235}, {1223, 1224}, {1224, 1225}, 
{1236, 1237}, {1225, 1226}, {1227, 1228}, {1237, 1238}, {1238, 1239}, 
{1228, 1229}, {1230, 1231}, {1239, 1240}, {1240, 1241}, {1242, 1243}, 
{1243, 1244}, {1244, 1245}, {1245, 1246}, {1236, 1286}, {1246, 1247}, 
{1231, 1232}, {1248, 1249}, {1249, 1250}, {1232, 1233}, {1250, 1251}, 
{1251, 1252}, {1233, 1234}, {1252, 1253}, {1253, 1254}, {1255, 1256}, 
{1256, 1257}, {1258, 1259}, {1259, 1260}, {1260, 1261}, {1234, 1235}, 
{1261, 1262}, {1263, 1264}, {1236, 1237}, {1264, 1265}, {1265, 1266}, 
{1237, 1238}, {1238, 1239}, {1266, 1267}, {1267, 1268}, {1239, 1240}, 
{1240, 1241}, {1242, 1243}, {1243, 1244}, {1244, 1245}, {1245, 1246}, 
{1236, 1286}, {1246, 1247}, {1268, 1269}, {1248, 1249}, {1249, 1250}, 
{1270, 1271}, {1250, 1251}, {1251, 1252}, {1271, 1272}, {1252, 1253}, 
{1253, 1254}, {1255, 1256}, {1256, 1257}, {1258, 1259}, {1259, 1260}, 
{1260, 1261}, {1272, 1273}, {1261, 1262}, {1263, 1264}, {1273, 1274}, 
{1264, 1265}, {1265, 1266}, {1274, 1275}, {1275, 1276}, {1266, 1267}, 
{1267, 1268}, {1276, 1277}, {1277, 1278}, {1279, 1280}, {1280, 1281}, 
{1281, 1282}, {1282, 1283}, {1283, 1284}, {1284, 1285}, {1268, 1269}, 
{1286, 1287}, {1287, 1288}, {1270, 1271}, {1288, 1289}, {1289, 1290}, 
{1271, 1272}, {1290, 1291}, {1292, 1293}, {1294, 1295}, {1295, 1296}, 
{1296, 1297}, {1297, 1298}, {1299, 1300}, {1272, 1273}, {1300, 1301}, 
{1301, 1302}, {1273, 1274}, {1302, 1303}, {1303, 1304}, {1274, 1275}, 
{1275, 1276}, {1304, 1305}, {1305, 1306}, {1276, 1277}, {1277, 1278}, 
{1279, 1280}, {1280, 1281}, {1281, 1282}, {1282, 1283}, {1283, 1284}, 
{1284, 1285}, {1307, 1308}, {1286, 1287}, {1287, 1288}, {1308, 1309}, 
{1288, 1289}, {1289, 1290}, {1309, 1310}, {1290, 1291}, {1292, 1293}, 
{1294, 1295}, {1295, 1296}, {1296, 1297}, {1297, 1298}, {1299, 1300}, 
{1310, 1311}, {1300, 1301}, {1301, 1302}, {1311, 1312}, {1302, 1303}, 
{1303, 1304}, {1313, 1314}, {1314, 1315}, {1304, 1305}, {1305, 1306}, 
{1315, 1316}, {1318, 1319}, {1319, 1320}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {1307, 1308}, {   0,    0}, 
{   0,    0}, {1308, 1309}, {   0,    0}, {   0,    0}, {1309, 1310}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {1310, 1311}, {   0,    0}, {   0,    0}, 
{1311, 1312}, {   0,    0}, {   0,    0}, {1313, 1314}, {1314, 1315}, 
{   0,    0}, {   0,    0}, {1315, 1316}, {1318, 1319}, {1319, 1320}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
{   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, {   0,    0}, 
};
static	yyCombType *	yyBasePtr	[yyDStateCount + 1] = { 0,
& yyComb [   0], & yyComb [   0], & yyComb [ 118], & yyComb [   0], 
& yyComb [ 232], & yyComb [   0], & yyComb [ 346], & yyComb [   0], 
& yyComb [ 466], & yyComb [   0], & yyComb [ 593], & yyComb [   0], 
& yyComb [ 720], & yyComb [   0], & yyComb [ 847], & yyComb [   0], 
& yyComb [ 974], & yyComb [   0], & yyComb [1101], & yyComb [   0], 
& yyComb [1228], & yyComb [   0], & yyComb [1355], & yyComb [   0], 
& yyComb [1482], & yyComb [   0], & yyComb [1599], & yyComb [   0], 
& yyComb [1712], & yyComb [   0], & yyComb [1799], & yyComb [1874], 
& yyComb [   2], & yyComb [  63], & yyComb [1949], & yyComb [   0], 
& yyComb [  84], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [  15], 
& yyComb [2036], & yyComb [2159], & yyComb [2286], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [2413], 
& yyComb [   0], & yyComb [2540], & yyComb [   0], & yyComb [2667], 
& yyComb [   0], & yyComb [  85], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [2794], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [2885], & yyComb [  75], & yyComb [  76], & yyComb [   0], 
& yyComb [2972], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [3059], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [ 115], & yyComb [   0], 
& yyComb [   0], & yyComb [ 178], & yyComb [3146], & yyComb [  62], 
& yyComb [ 175], & yyComb [ 166], & yyComb [  64], & yyComb [ 177], 
& yyComb [ 212], & yyComb [ 312], & yyComb [3269], & yyComb [ 103], 
& yyComb [3348], & yyComb [3423], & yyComb [3503], & yyComb [ 180], 
& yyComb [3587], & yyComb [ 339], & yyComb [ 181], & yyComb [ 340], 
& yyComb [   0], & yyComb [ 114], & yyComb [ 239], & yyComb [  34], 
& yyComb [3690], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [3781], & yyComb [   0], & yyComb [ 185], & yyComb [ 316], 
& yyComb [ 337], & yyComb [3840], & yyComb [3841], & yyComb [3913], 
& yyComb [  98], & yyComb [4000], & yyComb [ 184], & yyComb [ 185], 
& yyComb [ 187], & yyComb [ 188], & yyComb [ 256], & yyComb [4087], 
& yyComb [ 296], & yyComb [3828], & yyComb [4174], & yyComb [ 320], 
& yyComb [4261], & yyComb [ 321], & yyComb [1595], & yyComb [1707], 
& yyComb [ 343], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [  46], & yyComb [4353], & yyComb [3483], 
& yyComb [1776], & yyComb [4442], & yyComb [1565], & yyComb [4565], 
& yyComb [ 348], & yyComb [1546], & yyComb [1561], & yyComb [3837], 
& yyComb [1625], & yyComb [1679], & yyComb [1741], & yyComb [1793], 
& yyComb [1796], & yyComb [1795], & yyComb [1975], & yyComb [4644], 
& yyComb [1680], & yyComb [ 138], & yyComb [3615], & yyComb [4681], 
& yyComb [4666], & yyComb [4739], & yyComb [ 141], & yyComb [4814], 
& yyComb [2874], & yyComb [3619], & yyComb [4852], & yyComb [3563], 
& yyComb [4943], & yyComb [2980], & yyComb [1868], & yyComb [5002], 
& yyComb [1862], & yyComb [1855], & yyComb [1866], & yyComb [5004], 
& yyComb [5079], & yyComb [1713], & yyComb [2063], & yyComb [1969], 
& yyComb [5007], & yyComb [1967], & yyComb [1859], & yyComb [1860], 
& yyComb [3434], & yyComb [1924], & yyComb [1925], & yyComb [1928], 
& yyComb [2013], & yyComb [2908], & yyComb [2029], & yyComb [2031], 
& yyComb [2875], & yyComb [2877], & yyComb [2878], & yyComb [2880], 
& yyComb [2962], & yyComb [2964], & yyComb [2965], & yyComb [3547], 
& yyComb [2954], & yyComb [3036], & yyComb [3037], & yyComb [3038], 
& yyComb [3077], & yyComb [3047], & yyComb [3129], & yyComb [3130], 
& yyComb [3795], & yyComb [3128], & yyComb [3129], & yyComb [3131], 
& yyComb [3328], & yyComb [3329], & yyComb [3330], & yyComb [3573], 
& yyComb [3431], & yyComb [3322], & yyComb [3792], & yyComb [3326], 
& yyComb [3482], & yyComb [4269], & yyComb [3329], & yyComb [3401], 
& yyComb [3816], & yyComb [3844], & yyComb [ 176], & yyComb [1709], 
& yyComb [ 247], & yyComb [ 222], & yyComb [5089], & yyComb [4680], 
& yyComb [5144], & yyComb [3845], & yyComb [3412], & yyComb [4270], 
& yyComb [3889], & yyComb [3847], & yyComb [3497], & yyComb [3578], 
& yyComb [3580], & yyComb [3774], & yyComb [3851], & yyComb [3850], 
& yyComb [4956], & yyComb [3892], & yyComb [ 231], & yyComb [3056], 
& yyComb [4355], & yyComb [3933], & yyComb [3138], & yyComb [ 227], 
& yyComb [1597], & yyComb [ 228], & yyComb [ 220], & yyComb [3770], 
& yyComb [5001], & yyComb [5004], & yyComb [5231], & yyComb [3931], 
& yyComb [5000], & yyComb [5006], & yyComb [3997], & yyComb [3992], 
& yyComb [3993], & yyComb [3994], & yyComb [5318], & yyComb [3995], 
& yyComb [5009], & yyComb [5405], & yyComb [4081], & yyComb [4082], 
& yyComb [5460], & yyComb [5453], & yyComb [5086], & yyComb [5463], 
& yyComb [5529], & yyComb [4079], & yyComb [4080], & yyComb [4082], 
& yyComb [4164], & yyComb [5126], & yyComb [5616], & yyComb [4169], 
& yyComb [4195], & yyComb [5035], & yyComb [4156], & yyComb [4241], 
& yyComb [4243], & yyComb [4350], & yyComb [4260], & yyComb [4347], 
& yyComb [4349], & yyComb [4876], & yyComb [4672], & yyComb [4877], 
& yyComb [4879], & yyComb [4863], & yyComb [5040], & yyComb [4425], 
& yyComb [5703], & yyComb [5002], & yyComb [5790], & yyComb [4427], 
& yyComb [5104], & yyComb [5877], & yyComb [4345], & yyComb [5460], 
& yyComb [5080], & yyComb [4638], & yyComb [5964], & yyComb [6051], 
& yyComb [5470], & yyComb [6138], & yyComb [4427], & yyComb [5214], 
& yyComb [4640], & yyComb [6225], & yyComb [4656], & yyComb [4799], 
& yyComb [6283], & yyComb [4936], & yyComb [5004], & yyComb [6284], 
& yyComb [5011], & yyComb [5464], & yyComb [6278], & yyComb [6342], 
& yyComb [6289], & yyComb [5075], & yyComb [6398], & yyComb [6401], 
& yyComb [6399], & yyComb [6395], & yyComb [5097], & yyComb [5090], 
& yyComb [5148], & yyComb [5470], & yyComb [5163], & yyComb [5159], 
& yyComb [6442], & yyComb [6402], & yyComb [5257], & yyComb [5212], 
& yyComb [6492], & yyComb [5226], & yyComb [5298], & yyComb [6579], 
& yyComb [6413], & yyComb [6666], & yyComb [6724], & yyComb [6408], 
& yyComb [ 143], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [5313], 
& yyComb [5302], & yyComb [5300], & yyComb [5388], & yyComb [5400], 
& yyComb [5382], & yyComb [5398], & yyComb [   0], & yyComb [5393], 
& yyComb [5473], & yyComb [5484], & yyComb [5473], & yyComb [   0], 
& yyComb [6409], & yyComb [5478], & yyComb [5481], & yyComb [5520], 
& yyComb [5554], & yyComb [   0], & yyComb [5543], & yyComb [5555], 
& yyComb [5606], & yyComb [5593], & yyComb [5610], & yyComb [5596], 
& yyComb [5607], & yyComb [5682], & yyComb [5679], & yyComb [5685], 
& yyComb [5683], & yyComb [   0], & yyComb [5770], & yyComb [   0], 
& yyComb [5691], & yyComb [5771], & yyComb [5784], & yyComb [5789], 
& yyComb [5852], & yyComb [5868], & yyComb [5870], & yyComb [   0], 
& yyComb [5864], & yyComb [5868], & yyComb [5943], & yyComb [   0], 
& yyComb [5959], & yyComb [5956], & yyComb [   0], & yyComb [5959], 
& yyComb [6041], & yyComb [   0], & yyComb [6028], & yyComb [6037], 
& yyComb [ 177], & yyComb [6031], & yyComb [6046], & yyComb [6126], 
& yyComb [6125], & yyComb [6120], & yyComb [6122], & yyComb [   0], 
& yyComb [6215], & yyComb [6137], & yyComb [6217], & yyComb [6207], 
& yyComb [6202], & yyComb [   0], & yyComb [6273], & yyComb [6284], 
& yyComb [   0], & yyComb [6418], & yyComb [6283], & yyComb [6298], 
& yyComb [6294], & yyComb [   0], & yyComb [6413], & yyComb [6478], 
& yyComb [   0], & yyComb [6423], & yyComb [6296], & yyComb [6400], 
& yyComb [6403], & yyComb [   0], & yyComb [6474], & yyComb [6571], 
& yyComb [6484], & yyComb [6474], & yyComb [6565], & yyComb [6556], 
& yyComb [   0], & yyComb [6726], & yyComb [6717], & yyComb [6574], 
& yyComb [6641], & yyComb [6653], & yyComb [6648], & yyComb [6650], 
& yyComb [   0], & yyComb [6643], & yyComb [   0], & yyComb [6719], 
& yyComb [6727], & yyComb [6727], & yyComb [6720], & yyComb [6715], 
& yyComb [   0], & yyComb [6721], & yyComb [6724], & yyComb [6735], 
& yyComb [   0], & yyComb [6727], & yyComb [6722], & yyComb [6738], 
& yyComb [6728], & yyComb [6741], & yyComb [6734], & yyComb [6745], 
& yyComb [6745], & yyComb [6737], & yyComb [6732], & yyComb [   0], 
& yyComb [6736], & yyComb [6733], & yyComb [6750], & yyComb [6742], 
& yyComb [6786], & yyComb [6785], & yyComb [   0], & yyComb [6782], 
& yyComb [6779], & yyComb [6788], & yyComb [6780], & yyComb [6776], 
& yyComb [6787], & yyComb [6782], & yyComb [6785], & yyComb [   0], 
& yyComb [6786], & yyComb [6800], & yyComb [6789], & yyComb [6794], 
& yyComb [6801], & yyComb [   0], & yyComb [6786], & yyComb [6786], 
& yyComb [6790], & yyComb [6800], & yyComb [6808], & yyComb [6790], 
& yyComb [6792], & yyComb [6808], & yyComb [   0], & yyComb [6812], 
& yyComb [6806], & yyComb [6796], & yyComb [6799], & yyComb [6817], 
& yyComb [6801], & yyComb [6795], & yyComb [   0], & yyComb [6835], 
& yyComb [6849], & yyComb [6852], & yyComb [6836], & yyComb [   0], 
& yyComb [6852], & yyComb [6844], & yyComb [ 178], & yyComb [6857], 
& yyComb [6848], & yyComb [6846], & yyComb [6859], & yyComb [6852], 
& yyComb [   0], & yyComb [6839], & yyComb [6862], & yyComb [6854], 
& yyComb [6858], & yyComb [6865], & yyComb [   0], & yyComb [6854], 
& yyComb [6867], & yyComb [6860], & yyComb [   0], & yyComb [6857], 
& yyComb [   0], & yyComb [6853], & yyComb [6856], & yyComb [6866], 
& yyComb [6874], & yyComb [6856], & yyComb [6858], & yyComb [6874], 
& yyComb [   0], & yyComb [6871], & yyComb [6861], & yyComb [6874], 
& yyComb [   0], & yyComb [6871], & yyComb [6875], & yyComb [6910], 
& yyComb [6904], & yyComb [   0], & yyComb [6912], & yyComb [6906], 
& yyComb [   0], & yyComb [6903], & yyComb [6907], & yyComb [6920], 
& yyComb [6919], & yyComb [6906], & yyComb [6907], & yyComb [6912], 
& yyComb [6910], & yyComb [6910], & yyComb [   0], & yyComb [6929], 
& yyComb [6919], & yyComb [6913], & yyComb [6928], & yyComb [ 228], 
& yyComb [   0], & yyComb [6916], & yyComb [6914], & yyComb [6931], 
& yyComb [ 232], & yyComb [   0], & yyComb [6932], & yyComb [6956], 
& yyComb [6917], & yyComb [ 235], & yyComb [   0], & yyComb [6958], 
& yyComb [ 238], & yyComb [   0], & yyComb [6922], & yyComb [ 277], 
& yyComb [   0], & yyComb [6928], & yyComb [6926], & yyComb [ 278], 
& yyComb [   0], & yyComb [6927], & yyComb [ 280], & yyComb [   0], 
& yyComb [6932], & yyComb [6966], & yyComb [ 281], & yyComb [   0], 
& yyComb [1796], & yyComb [   0], & yyComb [ 328], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [ 315], & yyComb [   0], 
& yyComb [6967], & yyComb [ 327], & yyComb [   0], & yyComb [ 336], 
& yyComb [   0], & yyComb [ 322], & yyComb [   0], & yyComb [6976], 
& yyComb [ 341], & yyComb [   0], & yyComb [ 352], & yyComb [   0], 
& yyComb [ 402], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [ 340], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [ 345], & yyComb [   0], & yyComb [   0], 
& yyComb [ 390], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [ 405], 
& yyComb [   0], & yyComb [ 403], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [6982], & yyComb [   0], & yyComb [6974], 
& yyComb [6979], & yyComb [6973], & yyComb [6981], & yyComb [   0], 
& yyComb [6988], & yyComb [6990], & yyComb [6972], & yyComb [6983], 
& yyComb [6978], & yyComb [   0], & yyComb [6981], & yyComb [6995], 
& yyComb [   0], & yyComb [6996], & yyComb [7033], & yyComb [6994], 
& yyComb [6992], & yyComb [7004], & yyComb [   0], & yyComb [7023], 
& yyComb [7005], & yyComb [7004], & yyComb [7002], & yyComb [7032], 
& yyComb [7040], & yyComb [   0], & yyComb [7043], & yyComb [7037], 
& yyComb [7030], & yyComb [7034], & yyComb [7050], & yyComb [7051], 
& yyComb [7050], & yyComb [   0], & yyComb [7036], & yyComb [7049], 
& yyComb [7041], & yyComb [7055], & yyComb [   0], & yyComb [7092], 
& yyComb [7047], & yyComb [7044], & yyComb [7059], & yyComb [   0], 
& yyComb [7085], & yyComb [7092], & yyComb [7084], & yyComb [   0], 
& yyComb [7122], & yyComb [7094], & yyComb [7096], & yyComb [7053], 
& yyComb [   0], & yyComb [7104], & yyComb [7094], & yyComb [7110], 
& yyComb [   0], & yyComb [7112], & yyComb [   0], & yyComb [7142], 
& yyComb [7100], & yyComb [   0], & yyComb [7118], & yyComb [7110], 
& yyComb [7121], & yyComb [   0], & yyComb [7106], & yyComb [7110], 
& yyComb [7143], & yyComb [   0], & yyComb [7160], & yyComb [7148], 
& yyComb [7148], & yyComb [   0], & yyComb [7153], & yyComb [7148], 
& yyComb [7161], & yyComb [7157], & yyComb [7152], & yyComb [7169], 
& yyComb [   0], & yyComb [7164], & yyComb [7165], & yyComb [7163], 
& yyComb [7176], & yyComb [7181], & yyComb [7164], & yyComb [7180], 
& yyComb [   0], & yyComb [7203], & yyComb [7174], & yyComb [7172], 
& yyComb [7185], & yyComb [7190], & yyComb [7172], & yyComb [7224], 
& yyComb [   0], & yyComb [7189], & yyComb [7192], & yyComb [   0], 
& yyComb [7202], & yyComb [7212], & yyComb [   0], & yyComb [7208], 
& yyComb [7219], & yyComb [7223], & yyComb [7217], & yyComb [7219], 
& yyComb [7229], & yyComb [7221], & yyComb [7217], & yyComb [   0], 
& yyComb [7237], & yyComb [7220], & yyComb [7226], & yyComb [7224], 
& yyComb [   0], & yyComb [7231], & yyComb [7219], & yyComb [   0], 
& yyComb [7225], & yyComb [   0], & yyComb [7247], & yyComb [7241], 
& yyComb [7226], & yyComb [   0], & yyComb [7229], & yyComb [7249], 
& yyComb [   0], & yyComb [7274], & yyComb [7233], & yyComb [7242], 
& yyComb [7267], & yyComb [7259], & yyComb [   0], & yyComb [7276], 
& yyComb [7272], & yyComb [7270], & yyComb [7281], & yyComb [7288], 
& yyComb [   0], & yyComb [7275], & yyComb [7294], & yyComb [7283], 
& yyComb [7293], & yyComb [7279], & yyComb [7296], & yyComb [7284], 
& yyComb [   0], & yyComb [7291], & yyComb [7300], & yyComb [7292], 
& yyComb [7288], & yyComb [7299], & yyComb [7294], & yyComb [7296], 
& yyComb [   0], & yyComb [7294], & yyComb [7312], & yyComb [7289], 
& yyComb [   0], & yyComb [7293], & yyComb [7311], & yyComb [   0], 
& yyComb [7302], & yyComb [7299], & yyComb [7324], & yyComb [7318], 
& yyComb [7332], & yyComb [7338], & yyComb [   0], & yyComb [7348], 
& yyComb [7330], & yyComb [7348], & yyComb [   0], & yyComb [7352], 
& yyComb [7343], & yyComb [7347], & yyComb [7354], & yyComb [   0], 
& yyComb [7340], & yyComb [7352], & yyComb [7355], & yyComb [7342], 
& yyComb [   0], & yyComb [7354], & yyComb [7351], & yyComb [7346], 
& yyComb [7363], & yyComb [7351], & yyComb [   0], & yyComb [7378], 
& yyComb [7355], & yyComb [ 355], & yyComb [7352], & yyComb [7358], 
& yyComb [   0], & yyComb [7355], & yyComb [ 507], & yyComb [7374], 
& yyComb [7352], & yyComb [   0], & yyComb [7395], & yyComb [7355], 
& yyComb [7368], & yyComb [7363], & yyComb [7379], & yyComb [   0], 
& yyComb [7398], & yyComb [7398], & yyComb [7400], & yyComb [7416], 
& yyComb [7406], & yyComb [   0], & yyComb [7417], & yyComb [7408], 
& yyComb [7416], & yyComb [   0], & yyComb [7401], & yyComb [7411], 
& yyComb [7404], & yyComb [   0], & yyComb [7422], & yyComb [7406], 
& yyComb [7417], & yyComb [7425], & yyComb [   0], & yyComb [7429], 
& yyComb [7415], & yyComb [7433], & yyComb [7422], & yyComb [   0], 
& yyComb [7416], & yyComb [7424], & yyComb [7437], & yyComb [7421], 
& yyComb [7434], & yyComb [7429], & yyComb [7433], & yyComb [   0], 
& yyComb [7446], & yyComb [7439], & yyComb [7445], & yyComb [7442], 
& yyComb [7451], & yyComb [7465], & yyComb [7463], & yyComb [7473], 
& yyComb [   0], & yyComb [7476], & yyComb [7478], & yyComb [7462], 
& yyComb [7466], & yyComb [7480], & yyComb [   0], & yyComb [7465], 
& yyComb [7469], & yyComb [7469], & yyComb [7481], & yyComb [7469], 
& yyComb [7488], & yyComb [   0], & yyComb [7485], & yyComb [7482], 
& yyComb [7478], & yyComb [7489], & yyComb [7496], & yyComb [   0], 
& yyComb [7484], & yyComb [7496], & yyComb [   0], & yyComb [7497], 
& yyComb [   0], & yyComb [7488], & yyComb [7493], & yyComb [7502], 
& yyComb [7484], & yyComb [   0], & yyComb [7504], & yyComb [7503], 
& yyComb [7518], & yyComb [7523], & yyComb [7515], & yyComb [   0], 
& yyComb [7534], & yyComb [7520], & yyComb [7540], & yyComb [7539], 
& yyComb [7525], & yyComb [7541], & yyComb [7529], & yyComb [   0], 
& yyComb [7543], & yyComb [7531], & yyComb [   0], & yyComb [   0], 
& yyComb [7535], & yyComb [7533], & yyComb [7551], & yyComb [7542], 
& yyComb [7543], & yyComb [   0], & yyComb [7551], & yyComb [   0], 
& yyComb [7543], & yyComb [   0], & yyComb [   0], & yyComb [   0], 
& yyComb [   0], & yyComb [   0], & yyComb [   0], & yyComb [7564], 
& yyComb [7548], & yyComb [7549], & yyComb [7553], & yyComb [7557], 
& yyComb [7539], & yyComb [   0], & yyComb [7565], & yyComb [7556], 
& yyComb [7557], & yyComb [7556], & yyComb [7569], & yyComb [7574], 
& yyComb [7556], & yyComb [7583], & yyComb [   0], & yyComb [7587], 
& yyComb [7579], & yyComb [7587], & yyComb [7602], & yyComb [7608], 
& yyComb [7590], & yyComb [7610], & yyComb [   0], & yyComb [7597], 
& yyComb [7595], & yyComb [7613], & yyComb [7615], & yyComb [7599], 
& yyComb [   0], & yyComb [7616], & yyComb [7629], & yyComb [7613], 
& yyComb [7610], & yyComb [7621], & yyComb [   0], & yyComb [7615], 
& yyComb [7623], & yyComb [   0], & yyComb [7626], & yyComb [7622], 
& yyComb [7616], & yyComb [7620], & yyComb [7638], & yyComb [7637], 
& yyComb [7650], & yyComb [   0], & yyComb [7642], & yyComb [7657], 
& yyComb [7651], & yyComb [7665], & yyComb [   0], & yyComb [7674], 
& yyComb [7658], & yyComb [7655], & yyComb [7671], & yyComb [   0], 
& yyComb [7661], & yyComb [7673], & yyComb [7665], & yyComb [   0], 
& yyComb [7679], & yyComb [7676], & yyComb [7674], & yyComb [7663], 
& yyComb [   0], & yyComb [7695], & yyComb [7681], & yyComb [7672], 
& yyComb [7699], & yyComb [   0], & yyComb [7715], & yyComb [   0], 
& yyComb [7721], & yyComb [7696], & yyComb [   0], & yyComb [7730], 
& yyComb [7722], & yyComb [7732], & yyComb [   0], & yyComb [7717], 
& yyComb [7721], & yyComb [7726], & yyComb [   0], & yyComb [7727], 
& yyComb [7727], & yyComb [   0], & yyComb [7733], & yyComb [7724], 
& yyComb [7748], & yyComb [7736], & yyComb [7731], & yyComb [7748], 
& yyComb [   0], & yyComb [7742], & yyComb [7743], & yyComb [   0], 
& yyComb [7737], & yyComb [7749], & yyComb [7753], & yyComb [7749], 
& yyComb [   0], & yyComb [7746], & yyComb [7742], & yyComb [   0], 
& yyComb [7763], & yyComb [   0], & yyComb [7772], & yyComb [7762], 
& yyComb [7778], & yyComb [   0], & yyComb [   0], & yyComb [7779], 
& yyComb [7782], & yyComb [   0], & yyComb [7778], & yyComb [7793], 
& yyComb [   0], & yyComb [7792], & yyComb [7788], & yyComb [7784], 
& yyComb [   0], & yyComb [7799], & yyComb [7800], & yyComb [7799], 
& yyComb [7805], & yyComb [7805], & yyComb [7805], & yyComb [   0], 
& yyComb [7810], & yyComb [7797], & yyComb [ 634], & yyComb [7796], 
& yyComb [7804], & yyComb [   0], & yyComb [7802], & yyComb [7803], 
& yyComb [ 889], & yyComb [7822], & yyComb [7802], & yyComb [   0], 
& yyComb [7840], & yyComb [7803], & yyComb [7816], & yyComb [7811], 
& yyComb [7824], & yyComb [   0], & yyComb [7831], & yyComb [7846], 
& yyComb [7852], & yyComb [7859], & yyComb [7856], & yyComb [7846], 
& yyComb [   0], & yyComb [7846], & yyComb [7859], & yyComb [7847], 
& yyComb [7869], & yyComb [7859], & yyComb [7867], & yyComb [7860], 
& yyComb [7872], & yyComb [7872], & yyComb [   0], & yyComb [7865], 
& yyComb [7875], & yyComb [7869], & yyComb [7873], & yyComb [7864], 
& yyComb [7864], & yyComb [   0], & yyComb [7872], & yyComb [7871], 
& yyComb [7875], & yyComb [   0], & yyComb [7889], & yyComb [7880], 
& yyComb [7890], & yyComb [   0], & yyComb [7887], & yyComb [7891], 
& yyComb [7888], & yyComb [7906], & yyComb [7901], & yyComb [   0], 
& yyComb [7901], & yyComb [7920], & yyComb [7912], & yyComb [7926], 
& yyComb [7925], & yyComb [   0], & yyComb [7930], & yyComb [7912], 
& yyComb [7928], & yyComb [   0], & yyComb [7932], & yyComb [7923], 
& yyComb [7927], & yyComb [7935], & yyComb [   0], & yyComb [7921], 
& yyComb [7934], & yyComb [7937], & yyComb [7924], & yyComb [   0], 
& yyComb [7925], & yyComb [   0], & yyComb [7933], & yyComb [7942], 
& yyComb [7934], & yyComb [7930], & yyComb [7943], & yyComb [7938], 
& yyComb [7941], & yyComb [   0], & yyComb [7934], & yyComb [7954], 
& yyComb [   0], & yyComb [7951], & yyComb [7955], & yyComb [7953], 
& yyComb [7966], & yyComb [7980], & yyComb [   0], & yyComb [7981], 
& yyComb [7971], & yyComb [7976], & yyComb [7992], & yyComb [7982], 
& yyComb [   0], & yyComb [7986], & yyComb [7981], & yyComb [7983], 
& yyComb [7997], & yyComb [7988], & yyComb [   0], & yyComb [8001], 
& yyComb [7990], & yyComb [8000], & yyComb [7986], & yyComb [8003], 
& yyComb [7991], & yyComb [   0], & yyComb [7990], & yyComb [8010], 
& yyComb [   0], & yyComb [8008], & yyComb [7992], & yyComb [8002], 
& yyComb [8011], & yyComb [   0], & yyComb [8003], & yyComb [8016], 
& yyComb [8000], & yyComb [8014], & yyComb [8009], & yyComb [8019], 
& yyComb [   0], & yyComb [8034], & yyComb [8021], & yyComb [8032], 
& yyComb [8029], & yyComb [8033], & yyComb [8045], & yyComb [8043], 
& yyComb [8053], & yyComb [   0], & yyComb [8038], & yyComb [8042], 
& yyComb [8042], & yyComb [8053], & yyComb [8041], & yyComb [8059], 
& yyComb [   0], & yyComb [8057], & yyComb [8053], & yyComb [8050], 
& yyComb [8061], & yyComb [8069], & yyComb [   0], & yyComb [8068], 
& yyComb [   0], & yyComb [8067], & yyComb [8057], & yyComb [8075], 
& yyComb [8064], & yyComb [   0], & yyComb [8077], & yyComb [8062], 
& yyComb [8080], & yyComb [8080], & yyComb [8064], & yyComb [8082], 
& yyComb [8070], & yyComb [   0], & yyComb [8090], & yyComb [8091], 
& yyComb [8100], & yyComb [8110], & yyComb [8102], & yyComb [   0], 
& yyComb [8105], & yyComb [8113], & yyComb [8097], & yyComb [   0], 
& yyComb [   0], & yyComb [8117], & yyComb [8105], & yyComb [   0], 
& yyComb [   0], 
};
static	yyStateRange	yyDefault	[yyDStateCount + 1] = { 0,
    5,     1,    33,     3,    33,     5,    29,     7,    32,     9, 
    5,    11,     5,    13,    32,    15,     5,    17,    32,    19, 
   32,    21,     5,    23,     5,    25,     5,    27,     5,    29, 
   33,    33,     0,    33,    33,    33,    33,     0,     0,     0, 
    0,     0,     0,     0,    44,    44,    44,    44,    44,     0, 
   44,     0,    44,    44,     0,    44,    44,    44,    44,    44, 
   44,    44,     0,     0,    44,    44,     0,    45,    45,    45, 
    0,     0,    44,    73,    77,    44,    44,    77,    77,    77, 
  116,    81,    81,    81,    81,    81,    81,    81,     0,     0, 
    0,     0,     0,   114,   120,     0,     0,    99,   116,    99, 
   99,    99,    99,    99,    99,   116,    81,   120,   120,   120, 
  108,   120,   120,    95,   120,   120,     0,   120,   120,     0, 
  132,     0,     0,     0,   132,     0,   128,   132,   132,   132, 
  149,     0,   132,     0,   134,   134,   134,   134,   134,     0, 
  140,   132,     0,   143,     0,   145,   149,   149,   132,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,   167,   163,   163,   162,   162,   190,   162,   162, 
  162,   162,   162,   162,   162,   162,   162,   162,   162,   162, 
  162,   162,   162,   162,   184,   180,   188,   162,   162,   162, 
  162,   191,   162,   193,   197,   163,   162,   162,   162,   162, 
    0,     0,   202,     0,   204,     0,   206,   206,     0,   209, 
  209,   209,   209,     0,   214,   214,   214,   214,   214,   214, 
  214,   214,   214,     0,   224,   224,   224,   224,     0,   229, 
  229,   229,     0,   233,   233,   233,   233,   233,   233,     0, 
    0,   241,     0,   243,   246,     0,   246,   246,     0,     0, 
  272,     0,     0,   253,   272,   272,   277,     0,   258,     0, 
  260,     0,   262,   262,   262,   262,   262,     0,     0,   246, 
  275,     0,   277,   258,   272,   279,     0,   280,   272,   272, 
  283,   283,   287,   283,   283,   283,     0,   287,   287,   287, 
  287,   291,   291,   287,   294,   294,   299,   300,   291,   291, 
  287,   301,   301,   301,   301,   283,   287,   307,     0,     0, 
  310,   310,   310,     0,   314,   314,   314,     0,   318,     0, 
    0,     0,     0,   325,   321,   325,   321,   325,   330,   321, 
  330,   330,   330,   330,   321,   321,   330,   321,   338,   338, 
  342,   321,   327,   325,   330,   335,   335,   345,   336,   351, 
  330,   321,   329,   342,   325,   325,   325,   330,   338,   352, 
  374,   374,   374,   372,   372,   377,   377,   377,   377,   374, 
  374,   377,   374,   377,   374,   374,     0,     0,     0,     0, 
   76,    65,    61,    59,    57,    49,    44,    33,   162,   377, 
  120,    54,    53,    51,    48,     0,    58,    56,    54,    53, 
   51,    47,    46,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   105,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   306,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   184, 
  184,   184,   184,   184,    36,   184,   184,   184,   184,    36, 
  184,   184,   184,   184,    36,   184,   184,    36,   184,   184, 
   36,   184,   184,   184,    36,   184,   184,    36,   184,   184, 
  184,    36,   377,     0,   377,     0,     0,     0,   377,     0, 
  184,   184,    36,   184,    36,   377,     0,   184,   184,    36, 
  184,    36,   377,     0,    36,     0,   377,     0,     0,    36, 
    0,   377,     0,     0,   377,     0,     0,     0,     0,     0, 
    0,   377,     0,   377,     0,     0,     0,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   306,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   372,   372,   372,   372, 
  372,   372,   372,   372,   372,   372,   342,   342,   342,   342, 
  342,   342,   342,   342,   342,   342,     0,     0,   390,     0, 
    0,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  374,   374,   374,   374,   374,   374,   374,   374,   374,   374, 
  390, 
};
static	yyStateRange	yyEobTrans	[yyDStateCount + 1] = { 0,
  162,   162,     0,     0,     0,     0,     0,     0,   120,   120, 
   58,    58,    56,    56,    54,    54,    53,    53,    51,    51, 
   48,    48,    47,    47,    46,    46,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,    46,    47,     0,     0,     0, 
    0,     0,     0,     0,     0,    56,     0,    58,     0,   107, 
    0,     0,     0,     0,     0,    66,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,   107,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
  107,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,   107,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,    58,    56,     0,     0, 
    0,    47,    46,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0,     0,     0,     0,     0,     0,     0,     0,     0,     0, 
    0, 
};

static	yyStateRange	yyStartState	= STD;
static	yyStateRange	yyPreviousStart	= STD;
static	short		yySourceFile	= StdIn;
static	rbool		yyEof		= rfalse;
static	long		yyBytesRead	= 0;
static	long		yyFileOffset	= 0;
static	unsigned int	yyLineCount	= 1;
static	unsigned char *	yyLineStart	;
static	char *		yyChBufferStart2;

					/* Start State Stack: StStSt	*/

# if defined xxyyPush | defined xxyyPop
# define		yyInitStStStackSize	16

static	yyStateRange *	yyStStStackPtr	;
static	unsigned long	yyStStStackSize	= 0;
static	unsigned int	yyStStStackIdx	= 0;
# endif

# ifdef xxyyPush
static void yyPush
# if defined __STDC__ | defined __cplusplus
   (yyStateRange yyState)
# else
   (yyState) yyStateRange yyState;
# endif
{
   if (yyStStStackIdx == yyStStStackSize) {
      if (yyStStStackSize == 0) {
	 yyStStStackSize = yyInitStStStackSize;
	 MakeArray ((char * *) & yyStStStackPtr, & yyStStStackSize,
			(unsigned long) sizeof (yyStateRange));
      } else {
	 ExtendArray ((char * *) & yyStStStackPtr, & yyStStStackSize,
			(unsigned long) sizeof (yyStateRange));
      }
      if (yyStStStackPtr == NULL) yyErrorMessage (1);
   }
   yyStStStackPtr [yyStStStackIdx ++] = yyStartState;
   yyStart (yyState);
}
# endif

# ifdef xxyyPop
static void yyPop ARGS ((void))
{
   yyPreviousStart = yyStartState;
   if (yyStStStackIdx > 0)
      yyStartState = yyStStStackPtr [-- yyStStStackIdx];
   else
      yyErrorMessage (4);
}
# endif

# ifdef xxGetLower
static	unsigned char	yyToLower	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '[', '\\', ']', '^', '_',
'`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}','~','\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};
# endif

# ifdef xxGetUpper
static	unsigned char	yyToUpper	[] = {
'\0', '\1', '\2', '\3', '\4', '\5', '\6', '\7',
'\10', '\11', '\12', '\13', '\14', '\15', '\16', '\17',
'\20', '\21', '\22', '\23', '\24', '\25', '\26', '\27',
'\30', '\31', '\32', '\33', '\34', '\35', '\36', '\37',
' ', '!', '"', '#', '$', '%', '&', '\'', '(', ')', '*', '+', ',', '-', '.', '/',
'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ':', ';', '<', '=', '>', '?',
'@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']', '^', '_',
'`', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '{', '|', '}','~','\177',
'\200', '\201', '\202', '\203', '\204', '\205', '\206', '\207',
'\210', '\211', '\212', '\213', '\214', '\215', '\216', '\217',
'\220', '\221', '\222', '\223', '\224', '\225', '\226', '\227',
'\230', '\231', '\232', '\233', '\234', '\235', '\236', '\237',
'\240', '\241', '\242', '\243', '\244', '\245', '\246', '\247',
'\250', '\251', '\252', '\253', '\254', '\255', '\256', '\257',
'\260', '\261', '\262', '\263', '\264', '\265', '\266', '\267',
'\270', '\271', '\272', '\273', '\274', '\275', '\276', '\277',
'\300', '\301', '\302', '\303', '\304', '\305', '\306', '\307',
'\310', '\311', '\312', '\313', '\314', '\315', '\316', '\317',
'\320', '\321', '\322', '\323', '\324', '\325', '\326', '\327',
'\330', '\331', '\332', '\333', '\334', '\335', '\336', '\337',
'\340', '\341', '\342', '\343', '\344', '\345', '\346', '\347',
'\350', '\351', '\352', '\353', '\354', '\355', '\356', '\357',
'\360', '\361', '\362', '\363', '\364', '\365', '\366', '\367',
'\370', '\371', '\372', '\373', '\374', '\375', '\376', '\377',
};
# endif

static void yyTab1	ARGS ((int yya));

# define yyTab		yyTab1 (0)
# define yyTab2(a,b)	yyTab1 (a)

# line 58 "fortran.rex"


#include <math.h>
#include "global.h"             /* verbose_flag */

# ifdef WIN32
# include <io.h>             /* for testing file access */
# else
# include <unistd.h>             /* for testing file access */
# endif

#include "rMemory.h"
#include "StringM.h"
#include "Idents.h"
#include "labels.h"              /* InitLabels, LabelDefine */

int MakeEndDos, EndDoSwitch;

extern double   atof(/* const char *nptr */);  /* import from stdlib.h */

extern int is_assignment;   /* is 1 if there was a = in the line */

/**************************************************************************
*                                                                         *
*  Global variables for options                                           *
*                                                                         *
**************************************************************************/

static tStringRef option_string;

/**************************************************************************
*                                                                         *
*  ReservedWordState:  helps to find out if some identifiers are          *
*                      reserved words or not (in state DIST)              *
*                                                                         *
*  0      :  usual state                                                  *
*  1      :  TO can be reserved word after ASSIGN (ASSIGN label TO var)   *
*  2      :  REAL, DOUBLE, INTEGER, CHARACTER, COMPLEX, TYPE              *
*            after IMPLICIT, RECURSIVE                                    *
*  3      :  DATA, INTRINSIC, .... after type specification               *
*  5      :  RESULT after FUNCTION                                        *
*  6      :  THEN, READ, GOTO, ... after IF                               *
*  7      :  OPERATOR, ASSIGNMENT after INTERFACE                         *
*  8      :  ONLY after USE                                               *
*  9      :  WHILE, !PARALLEL, TIMES after DO                             *
*                                                                         *
*  ReservedWordState will be set to 0 at the begin of a new line          *
*                                                                         *
**************************************************************************/

int ReservedWordState;  /* needed for context of parsing/scanner */

#define StateAssign 1
#define StateTypes  2 
#define StateFunc   5   /* RESULT (...) is valid  */
#define StateIf     6   /* after if_expression, then, basic statements */
#define StateInterf 7   /* after INTERFACE   */
#define StateUse    8   /* after USE */
#define StateDo     9   /* after DO */
#define StateElseIf 10  /* after ELSEIF is THEN valid */
#define StateModule 11  /* after MODULE */

void ErrorAttribute (Token, Attribute)
int Token;
tScanAttribute *Attribute;
{
  /* called if a token is inserted ? */

  fprintf (stderr, "ERROR in file %s\n", CurrentSourceName ());

  /* printf("ERROR line = %d, col = %d (HANDLING)\n",
          Attribute->Position.Line, Attribute->Position.Column); */
}

void SetIdentifier ()  /* set identifier representation in scan attribute */

{ int MyLength;
  char MyWord[WORD_LENGTH];
 
  MyLength = GetUpper(MyWord);
  Attribute.Ident=MakeIdent(MyWord,MyLength);
}

#define TokNL             255  /* Zeilenvorschub = Semikolon           */

#define TokIdentifier       1  /* Identifier                           */
#define TokInteger          2  /* Integer-Konstante                    */
#define TokRealLiteral      3  /* Real-Konstante                       */
#define TokDRealLiteral     4  /* Double Real-Konstante                */
#define TokCharLiteral      5  /* Char-Konstante                       */

#define TokLabel            6  /* Integer Label                        */
#define TokUserOp           7  /* User defined Operator                */

#define TokBecomes         10  /*  "="  Zuweisung                      */
#define TokConcatenation   11  /*  "//" Konkatenation                  */
#define TokPAssign         12  /*  "=>" Pointer-Assignment             */
#define TokLParanthesis    13  /*  "(" Klammer auf                     */
#define TokRParanthesis    14  /*  ")" Klammer zu                      */

#define TokAdd             15  /*  "+" numerische Addition             */
#define TokMinus           16  /*  "-" Subtraktion                     */
#define TokStar            17  /*  "*" Multiplikation                  */
#define TokDivide          18  /*  "/" Division                        */
#define TokPow             19  /*  "**" Potenzierung                   */

#define TokColon           20  /*  ":" Doppelpunkt                     */
#define TokComma           21  /*  "," Komma                           */
#define TokQuote           22  /*  Anfuehrungszeichen                  */

#define TokLBracket        23  /*  "["                                 */
#define TokRBracket        24  /*  "]"                                 */
#define TokLStrike         25  /*  "(/"                                */
#define TokRStrike         26  /*  "/)"                                */
#define TokDoubleColon     27  /*  "::"                                */
#define TokPoint           28  /*  "."                                 */
#define TokPercent         29  /*  "%"                                 */

#define TokNotEqual        30  /*  ".NE." ungleich                     */
#define TokEqual           31  /*  ".EQ." , == gleich                  */
#define TokGreater         32  /*  ".GT." groesser als                 */
#define TokGreaterEqual    33  /*  ".GE." groesser gleich              */
#define TokLess            34  /*  ".LT." kleiner                      */
#define TokLessEqual       35  /*  ".LE." kleiner gleich               */

#define TokAnd             36  /*  ".AND." logisches und               */
#define TokOr              37  /*  ".OR."  logisches oder              */
#define TokXor             44  /*  ".XOR." logisch excl.es oder        */
#define TokEquiv           39  /*  ".EQV." logische Aequivalenz        */
#define TokNotEquiv        40  /*  ".NEQV." logische Nicht-Aequivalenz */

#define TokTrue            41  /*  ".TRUE." logisch wahr               */
#define TokFalse           42  /*  ".FALSE." logisch falsch            */
#define TokNot             43  /*  ".NOT."  Negation                   */

#define TokBlockData       45  /*  " BLOCK DATA "                      */
#define TokData            46  /*  " DATA       "                      */
#define TokInclude         47  /*  " INCLUDE    "                      */
#define TokIntrinsic       48  /*  " INTRINSIC  "                      */

#define TokDeclInt         50  /*  "integer <>"                        */
#define TokDeclReal        51  /*  "real <>"                           */
#define TokDeclComplex     52  /*  "complex <>"                        */
#define TokDeclLogical     53  /*  "logical <>"                        */
#define TokDeclCharacter   54  /*  "character <>"                      */
#define TokDeclDouble      55  /*  "double precision"                  */
#define TokDeclCDouble     56  /*  "double complex"                    */

#define TokSave            57  /*  "SAVE"                              */
#define TokImplicit        58  /*  "IMPLICIT"                          */
#define TokExternal        59  /*  "EXTERNAL"                          */
#define TokParameter       60  /*  "PARAMETER"                         */
#define TokDimension       61  /*  "DIMENSION"                         */
#define TokCommon          62  /*  "COMMON"                            */
#define TokEquivalence     63  /*  "EQUIVALENCE"                       */
#define TokProgram         64  /*  "PROGRAM"                           */
#define TokRecursive       65  /*  "RECURSIVE"                         */
#define TokSubroutine      66  /*  "SUBROUTINE"                        */
#define TokFunction        67  /*  "FUNCTION"                          */
#define TokEnd             68  /*  "END"                               */
#define TokDo              69  /*  "DO"                                */
#define TokWhile           70  /*  "WHILE"                             */
#define TokIf              71  /*  "IF"                                */
#define TokThen            72  /*  "THEN"                              */
#define TokElse            73  /*  "ELSE"                              */
#define TokElseIf          74  /*  "ELSEIF"                            */
#define TokEndDo           75  /*  "ENDDO"                             */
#define TokEndIf           76  /*  "ENDIF"                             */
#define TokResult          77  /*  "RESULT"                            */

#define TokAssign          78  /*  "ASSIGN"                            */
#define TokTo              79  /*  "TO"                                */

#define TokCall            80  /*  "CALL"                              */
#define TokContinue        81  /*  "CONTINUE"                          */
#define TokStop            82  /*  "STOP"                              */
#define TokReturn          83  /*  "RETURN"                            */
#define TokFormat          85  /*  "FORMAT"                            */
#define TokFormatString    86  /*   Parameter for Format               */
#define TokGoto            87  /*  "GOTO" or "GO TO"                   */
  
#define TokEntry           88  /*  "ENTRY"                             */

#define TokRead            90  /*  "READ"                              */
#define TokWrite           91  /*  "WRITE"                             */
#define TokPrint           92  /*  "PRINT"                             */
#define TokOpen            93  /*  "OPEN"                              */
#define TokClose           94  /*  "CLOSE"                             */
#define TokInquire         95  /*  "INQUIRE"                           */
#define TokBackspace       96  /*  "BACKSPACE"                         */
#define TokEndfile         97  /*  "ENDFILE"                           */
#define TokRewind          98  /*  "REWIND"                            */

#define TokAllocate       100  /*  "ALLOCATE"                          */
#define TokDeallocate     101  /*  "DEALLOCATE"                        */
#define TokWhere          102  /*  "WHERE"                             */
#define TokEndWhere       103  /*  "ENDWHERE"                          */
#define TokElseWhere      104  /*  "ELSEWHERE"                         */
#define TokSelectCase     105  /*  "SELECT CASE"                       */
#define TokEndSelect      205  /*  "END SELECT"                        */
#define TokCase           106  /*  "CASE"                              */
#define TokDefault        107  /*  "DEFAULT"                           */
#define TokForall         109  /*  "FORALL"                            */
#define TokEndForall      114  /*  "END FORALL"                        */
#define TokIntent         110  /*  "INTENT"                            */
#define TokIn             111  /*  "IN"                                */
#define TokOut            112  /*  "OUT"                               */
#define TokInOut          113  /*  "INOUT"                             */
#define TokCycle          115  /*  "CYCLE"                             */
#define TokExit           116  /*  "EXIT"                              */

#define TokType           130  /*  "TYPE"                              */
#define TokEndType        131  /*  "END TYPE"                          */
#define TokInterface      132  /*  "INTERFACE"                         */
#define TokEndInterface   133  /*  "END INTERFACE"                     */
#define TokModule         134  /*  "MODULE"                            */
#define TokContains       136  /*  "CONTAINS"                          */
#define TokUse            137  /*  "USE"                               */
#define TokOnly           138  /*  "ONLY"                              */

#define TokProcedure      125  /*  "PROCEDURE"                         */
#define TokOperator       126  /*  "OPERATOR"                          */
#define TokAssignment     127  /*  "ASSIGNMENT"                        */

#define TokAllocatable    140  /*  "ALLOCATABLE"                       */
#define TokOptional       141  /*  "OPTIONAL"                          */
#define TokPointer        142  /*  "POINTER"                           */
#define TokTarget         143  /*  "TARGET"                            */
#define TokPublic         144  /*  "PUBLIC"                            */
#define TokPrivate        145  /*  "PRIVATE"                           */
#define TokNameList       147  /*  "NAMELIST"                          */
#define TokSequence       148  /*  "SEQUENCE"                          */

#define TokNullify        146  /*  "NULLIFY"                           */

#define TokPure           180  /*  "PURE"                              */
#define TokExtrinsic      181  /*  "EXTRINSIC (...)"                   */

#define TokDimension1     191  /*  "DIMENSION"                         */
#define TokParameter1     192  /*  "PARAMETER"                         */
#define TokIntent1        193  /*  "INTENT"                            */
#define TokExternal1      194  /*  "EXTERNAL"                          */
#define TokIntrinsic1     195  /*  "INTRINSIC"                         */
#define TokOptional1      196  /*  "OPTIONAL"                          */
#define TokPointer1       197  /*  "POINTER"                           */
#define TokSave1          198  /*  "SAVE"                              */
#define TokTarget1        199  /*  "TARGET"                            */
#define TokData1          200  /*  "DATA"                              */
#define TokPublic1        201  /*  "PUBLIC"                            */
#define TokPrivate1       202  /*  "PRIVATE"                           */
#define TokAllocatable1   203  /*  "ALLOCATABLE"                       */
#define TokArray1         204  /*  "ARRAY"                             */
#define TokSequence1      206  /*  "SEQUENCE"                          */
#define TokLayout1        240  /*  "LAYOUT"                            */
#define TokPassBy1        241  /*  "PASS_BY"                           */
#define TokMapTo1         242  /*  "MAP_TO"                            */

/***********************************************************************
*                                                                      *
*  New Tokens for HPF                                                  *
*                                                                      *
***********************************************************************/

#define TokAlign          151  /*  "ALIGN"                             */
#define TokWith           152  /*  "WITH"                              */
#define TokRealign        153  /*  "REALIGN"                           */
#define TokDistribute     154  /*  "DISTRIBUTE"                        */
#define TokRedistribute   155  /*  "REDISTRIBUTE"                      */
#define TokProcessors     156  /*  "PROCESSORS"                        */
#define TokTemplate       157  /*  "TEMPLATE"                          */
#define TokDynamic        158  /*  "DYNAMIC"                           */
#define TokOnto           159  /*  "ONTO"                              */
#define TokBlock          160  /*  "BLOCK"                             */
#define TokCyclic         161  /*  "CYCLIC"                            */
#define TokNoSequence     162  /*  "NO SEQUENCE"                       */
#define TokHPFSequence    163  /*  "SEQUENCE"                          */
#define TokIndependent    164  /*  "INDEPENDENT"                       */
#define TokResident       165  /*  "RESIDENT"                          */
#define TokOn             166  /*  "ON"                                */
#define TokNew            167  /*  "NEW"                               */
#define TokReduction      168  /*  "REDUCTION"                         */
#define TokInherit        169  /*  "INHERIT"                           */
#define TokHome           170  /*  "HOME"                              */

/***********************************************************************
*                                                                      *
*  New Tokens for HPF2.0                                               *
*                                                                      *
***********************************************************************/

#define TokGenBlock       208  /*  "GEN_BLOCK"                         */
#define TokIndirect       209  /*  "INDIRECT"                          */
#define TokArbitrary      219  /*  "ARBIRTRARY"                        */
#define TokHPFBegin       210  /*  "BEGIN"                             */
#define TokHPFEnd         211  /*  "END"                               */
#define TokTaskRegion     212  /*  "TASK REGION"                       */
#define TokRange          214  /*  "RANGE"                             */
#define TokAll            215  /*  "ALL"                               */
#define TokLayout         216  /*  "LAYOUT"                            */
#define TokPassBy         217  /*  "PASS_BY"                           */
#define TokMapTo          218  /*  "MAP_TO"                            */

/***********************************************************************
*                                                                      *
*  Tokens only needed for new ADP directives                           *
*                                                                      *
***********************************************************************/

#define TokShadow         221  /*  "SHADOW"                            */
#define TokShared         222  /*  "SHARED"                            */
#define TokRemote         223  /*  "REMOTE"                            */
#define TokDistributed    224  /*  "DISTRIBUTED"                       */
#define TokTrace          225  /*  "TRACE"                             */
#define TokTree           226  /*  "TREE"                              */
#define TokSelect         227  /*  "SELECT"                            */
#define TokNoVector       228  /*  "NOVECTOR"                          */
#define TokNoConcur       229  /*  "NOCONCUR"                          */
#define TokShort          230  /*  "SHORT"                             */
#define TokExpand         231  /*  "EXPAND"                            */
#define TokVector         232  /*  "VECTOR"                            */
#define TokConcur         233  /*  "CONCUR"                            */
#define TokSkip           234  /*  "SKIP"                              */
#define TokNoDescriptor   235  /*  "NODESCRIPTOR"                      */
#define TokAtomic         236  /*  "ATOMIC"                            */
#define TokFlags          237  /*  "FLAGS"                             */

/**************************************************************************
*                                                                         *
*  checking whether an identifier is a reserved word or not               *
*                                                                         *
**************************************************************************/

int NoAssign (Token)
int Token;

{ if (is_assignment == 1)

     { SetIdentifier ();
       return (TokIdentifier);
     }
   else
     return (Token);

} /* NoAssign */

int CheckReswd (State, Token)
int State, Token;
{ if (ReservedWordState == State)
     return (Token);
   else
     { SetIdentifier ();
       return (TokIdentifier);
     }
}

int CheckReswd2 (State1, State2, Token)
int State1, State2, Token;
{ if ((ReservedWordState == State1) || (ReservedWordState == State2))
     return (Token);
   else
     { SetIdentifier ();
       return (TokIdentifier);
     }
}

/**************************************************************************
*                                                                         *
*  C o n v e r t i n g  binary/octal/hexadezimal  C o n s t a n t s       *
*                                                                         *
*   Z'FF' -> 255   B"0101"  ->   5  O'777'  -> 511                        *
*   Z"00" ->   0   B"0111"  ->   7  O'333'  -> 219                        *
*                                                                         *
**************************************************************************/

int rep_convert (MyWord, MyLength, base)

char MyWord[];
int  MyLength, base;
{ int number, digit;
  char a;
  int i;

  number = 0;
  for (i=0; i<MyLength;i++)
   { digit = MyWord[i];
     if ((digit >= '0') && (digit <= '9'))
        digit = digit - '0';
      else if ((digit >= 'a') && (digit <= 'f'))
        digit = 10 + digit - 'a';
      else if ((digit >= 'A') && (digit <= 'F'))
        digit = 10 + digit - 'A';
     number = number*base + digit;
   }
  return (number);
}

/**************************************************************************
*                                                                         *
*  S A V I N G    Info on token from BEG                                  *
*                                                                         *
*  SaveBEGToken (token)                                                   *
*                                                                         *
*    - token has been first token of line                                 *
*    - in any case goto state ASS                                         *
*                                                                         *
**************************************************************************/

int BEGToken;
int BEGTokenLength;

void SaveBEGToken (t)
int t;

{ char MyWord[WORD_LENGTH];
  /* printf ("SaveBEGToken (%d)\n", t); */
  BEGToken = t;
  BEGTokenLength  = GetUpper (MyWord);
  Attribute.Ident = MakeIdent(MyWord, BEGTokenLength);
  yyStart (ASS);
}

int GetBEGToken ()
{ /* there was really a token from state BEG */
  if (BEGToken == TokImplicit)      ReservedWordState = StateTypes;
  if (BEGToken == TokRecursive)     ReservedWordState = StateTypes;
  if (BEGToken == TokPure)          ReservedWordState = StateTypes;
  if (BEGToken == TokExtrinsic)     ReservedWordState = StateTypes;
  if (BEGToken == TokAssign)        ReservedWordState = StateAssign;
  if (BEGToken == TokFunction)      ReservedWordState = StateFunc;
  if (BEGToken == TokIf)            ReservedWordState = StateIf;
  if (BEGToken == TokUse)           ReservedWordState = StateUse;
  if (BEGToken == TokDo)            ReservedWordState = StateDo;
  if (BEGToken == TokModule)        ReservedWordState = StateModule;
  return (BEGToken);
}

/**************************************************************************
*                                                                         *
*  IsParNesting                                                           *
*                                                                         *
*   IF (MINFA.LE.0) LFALL(1)=1                                            *
*       xxxxxxxxxxxxxxxxxxx          returns .false.                      *
*                                                                         *
*   IF (IFALL(1) == 0) THEN                                               *
*       xxxxxxxxxx                   returns .false.                      *
*                                                                         *
**************************************************************************/

static int IsParNesting ()

{ char MyWord [WORD_LENGTH];
  char c;
  int  i, MyLength;
  int  ParNest;

  ParNest = 0;

  MyLength = GetWord (MyWord) - 1;

  /* MyWord :  sparce* "=" |  space* "(" ANY* ")" space* "="   */

  for (i=0; i<MyLength; i++)

    { c = MyWord[i];
      if (c == ' ') ParNest = ParNest;  /* mothing to do */
      else if (c == ')') ParNest--;
      else if (c == '(') ParNest++;
      else if (ParNest == 0) return (0);
    }

   /* Myword can also be :  '( a(5) ='  from 'if (a(5) == 0) then ') */

   if (ParNest == 0) return (1);
   return (0);

} /* IsParNesting */

/**************************************************************************
*                                                                         *
*  GetKindIdent :  "123.54_dp"  -> MakeIdent ("dp")                       *
*                                                                         *
**************************************************************************/

static tIdent GetKindIdent (my_word, len)

char *my_word;
int  len;

{ int i, pos;

  pos = 0;
 
  for (i=0; i<len;i++)
     if (my_word[i] == '_') pos = i+1;

  if (pos == 0) return DefaultId();

  /* my_word+pos, ..., my_word+len is the kind string */

  return MakeIdent (my_word+pos, len-pos);

} /* GetKindIdent */

/**************************************************************************
*                                                                         *
*  END Handling                                                           *
*                                                                         *
**************************************************************************/

int EndToken()

{ if (EndDoSwitch == 1)
    { EndDoSwitch = 0;
      return (TokEndDo);
    }
  if (MakeEndDos > 0)
    { MakeEndDos   -= 1;
      EndDoSwitch  = 1;
      return (TokNL);
    }
  return (TokNL);
} /* EndToken */

/**************************************************************************
*                                                                         *
*  Label Handling                                                         *
*                                                                         *
**************************************************************************/

static int TheLabel = 0;

static void SetTheLabel (label)  

int label;

{ if (TheLabel != 0)
     printf ("label %d has been ignored\n", TheLabel);

  LabelDefine (label);  /* sets also MakeEndDos */

  TheLabel = label;

} /* SetTheLabel */

int GetTheLabel ()

{ int label;

  label    = TheLabel;
  TheLabel = 0;

  return (label);

} /* GetTheLabel */


# line 3022 "Scanner.c"

# ifndef yySetPosition
# define yySetPosition Attribute.Position.Line   = yyLineCount; \
Attribute.Position.Column = (int) ((unsigned char *) TokenPtr - yyLineStart);
# endif

# undef yyTab
# undef yyTab2

# ifndef yyInitBufferSize
# define yyInitBufferSize	1024 * 8 + 256
# endif
# ifndef yyInitFileStackSize
# define yyInitFileStackSize	8
# endif
# ifndef yyTabSpace
# define yyTabSpace		8
# endif

static void yyTab1
# if defined __STDC__ | defined __cplusplus
   (int yya)
# else
   (yya) int yya;
# endif
   { yyLineStart -= (yyTabSpace - 1 - ((unsigned char *) TokenPtr -
	yyLineStart + yya - 1)) & (yyTabSpace - 1); }

# define yyTab		yyLineStart -= (yyTabSpace - 1 - \
((unsigned char *) TokenPtr - yyLineStart - 1)) & (yyTabSpace - 1)
# define yyTab1(a)	yyLineStart -= (yyTabSpace - 1 - \
((unsigned char *) TokenPtr - yyLineStart + (a) - 1)) & (yyTabSpace - 1)
# define yyTab2(a,b)	yyLineStart -= (yyTabSpace - 1 - \
((unsigned char *) TokenPtr - yyLineStart + (a) - 1)) & (yyTabSpace - 1)

static	yyStateRange	yyInitStateStack [4] = { yyDefaultState };
static	yyStateRange *	yyStateStack	= yyInitStateStack;
static	unsigned long	yyStateStackSize= 0;

static	unsigned char	yyInitChBuffer [] = {
   '\0', '\0', '\0', '\0', '\0', '\0', '\0', '\0',
   '\0', '\0', '\0', '\0', '\0', '\0', '\0', yyEolCh, yyEobCh, '\0', };
static	unsigned char *	yyChBufferPtr	= yyInitChBuffer;
static	unsigned long	yyChBufferSize	= 0;
static	unsigned char *	yyChBufferStart	= & yyInitChBuffer [16];
static	unsigned char *	yyChBufferIndex	= & yyInitChBuffer [16];

typedef	struct {
	short		yySourceFile	;
	rbool		yyEof		;
	unsigned char *	yyChBufferPtr	;
	unsigned char *	yyChBufferStart	;
	unsigned long	yyChBufferSize	;
	unsigned char *	yyChBufferIndex	;
	long		yyBytesRead	;
	long		yyFileOffset	;
	unsigned int	yyLineCount	;
	unsigned char *	yyLineStart	;
	}		yytFileStack	;

static	yytFileStack *	yyFileStack	;
static	unsigned long	yyFileStackSize	= 0;
static	yytFileStack *	yyFileStackPtr	;

int GetToken ARGS ((void))
{
   register	yyStateRange	yyState;
   register	yyStateRange *	yyStatePtr;
   register	unsigned char * yyChBufferIndexReg;
   register	yyCombType * *	yyBasePtrReg = yyBasePtr;
# line 615 "fortran.rex"


  static char MyWord[WORD_LENGTH], 
              StringWord[STRING_LENGTH];
  static int  i, StringLength, MyLength;

# line 3100 "Scanner.c"

yyBegin:
   yyState		= yyStartState;		/* initialize */
   yyStatePtr		= & yyStateStack [1];
   yyChBufferIndexReg	= yyChBufferIndex;
   TokenPtr		= (char *) yyChBufferIndexReg;

   /* ASSERT yyChBuffer [yyChBufferIndex] == first character */

yyContinue:		/* continue after sentinel or skipping blanks */
   for (;;) {		/* execute as many state transitions as possible */
			/* determine next state and get next character */
      register yyCombType * yyTablePtr =
			(yyBasePtrReg [yyState] + * yyChBufferIndexReg ++);
      if (yyTablePtr->yyCheck == yyState) {
	 yyState = yyTablePtr->yyNext;
	 * yyStatePtr ++ = yyState;		/* push state */
	 goto yyContinue;
      }
      yyChBufferIndexReg --;			/* reconsider character */
      if ((yyState = yyDefault [yyState]) == yyDNoState) break;
   }

   for (;;) {				/* search for last final state */
      TokenLength =
	    (int) (yyChBufferIndexReg - (unsigned char *) TokenPtr);
      yyChBufferIndex = yyChBufferIndexReg;
switch (* -- yyStatePtr) {
case 96:;
yySetPosition
# line 722 "fortran.rex"
{ yyStart (HPF);              
} yyy1: goto yyBegin;
# line 3134 "Scanner.c"
case 97:;
yySetPosition
# line 724 "fortran.rex"
{ yyStart (ADP);              
} yyy2: goto yyBegin;
# line 3140 "Scanner.c"
case 95:;
yySetPosition
# line 726 "fortran.rex"
{ yyStart(BEG);
                              ReservedWordState = 0;
                              MyLength = GetWord(MyWord);
                              SetTheLabel (atoi((char *) MyWord));
                            
} yyy3: goto yyBegin;
# line 3150 "Scanner.c"
case 94:;
case 162:;
case 195:;
case 389:;
yySetPosition
# line 732 "fortran.rex"
{ yyStart(BEG);
                              ReservedWordState = 0;
                              yyLess (0);
                            
} yyy4: goto yyBegin;
# line 3162 "Scanner.c"
case 1321:;
yySetPosition
# line 743 "fortran.rex"
{
} yyy5: goto yyBegin;
# line 3168 "Scanner.c"
case 76:;
case 381:;
yySetPosition
# line 745 "fortran.rex"
{ yyStart(STD); yyEol(0); return(TokNL);    
} yyy6: goto yyBegin;
# line 3175 "Scanner.c"
case 1320:;
yySetPosition
# line 753 "fortran.rex"
{ SaveBEGToken (TokDeclInt);       
} yyy7: goto yyBegin;
# line 3181 "Scanner.c"
case 1317:;
yySetPosition
# line 754 "fortran.rex"
{ SaveBEGToken (TokDeclReal);      
} yyy8: goto yyBegin;
# line 3187 "Scanner.c"
case 1316:;
yySetPosition
# line 755 "fortran.rex"
{ SaveBEGToken (TokDeclComplex);   
} yyy9: goto yyBegin;
# line 3193 "Scanner.c"
case 1312:;
yySetPosition
# line 756 "fortran.rex"
{ SaveBEGToken (TokDeclLogical);   
} yyy10: goto yyBegin;
# line 3199 "Scanner.c"
case 1306:;
yySetPosition
# line 757 "fortran.rex"
{ SaveBEGToken (TokDeclCharacter); 
} yyy11: goto yyBegin;
# line 3205 "Scanner.c"
case 92:;
yySetPosition
# line 759 "fortran.rex"
{ yyStart (DIST);
                                      return(TokDeclDouble);           
} yyy12: goto yyBegin;
# line 3212 "Scanner.c"
case 93:;
yySetPosition
# line 762 "fortran.rex"
{ yyStart (DIST);
                                      return(TokDeclCDouble);          
} yyy13: goto yyBegin;
# line 3219 "Scanner.c"
case 89:;
yySetPosition
# line 764 "fortran.rex"
{ yyStart (DIST);
                                      yyLess (4); 
                                      return(TokType);                 
} yyy14: goto yyBegin;
# line 3227 "Scanner.c"
case 1298:;
yySetPosition
# line 774 "fortran.rex"
{ SaveBEGToken(TokProgram);        
} yyy15: goto yyBegin;
# line 3233 "Scanner.c"
case 1293:;
yySetPosition
# line 775 "fortran.rex"
{ SaveBEGToken(TokPure);           
} yyy16: goto yyBegin;
# line 3239 "Scanner.c"
case 1291:;
yySetPosition
# line 776 "fortran.rex"
{ SaveBEGToken(TokExtrinsic);      
} yyy17: goto yyBegin;
# line 3245 "Scanner.c"
case 1285:;
yySetPosition
# line 777 "fortran.rex"
{ SaveBEGToken(TokRecursive);      
} yyy18: goto yyBegin;
# line 3251 "Scanner.c"
case 1278:;
yySetPosition
# line 778 "fortran.rex"
{ SaveBEGToken(TokSubroutine);     
} yyy19: goto yyBegin;
# line 3257 "Scanner.c"
case 1269:;
yySetPosition
# line 779 "fortran.rex"
{ SaveBEGToken(TokFunction);       
} yyy20: goto yyBegin;
# line 3263 "Scanner.c"
case 78:;
case 151:;
yySetPosition
# line 780 "fortran.rex"
{ yyStart(DIST);
                                      return(TokBlockData);            
} yyy21: goto yyBegin;
# line 3271 "Scanner.c"
case 1262:;
yySetPosition
# line 782 "fortran.rex"
{ SaveBEGToken(TokModule);         
} yyy22: goto yyBegin;
# line 3277 "Scanner.c"
case 1257:;
yySetPosition
# line 790 "fortran.rex"
{ SaveBEGToken(TokData);           
} yyy23: goto yyBegin;
# line 3283 "Scanner.c"
case 1254:;
yySetPosition
# line 791 "fortran.rex"
{ SaveBEGToken(TokParameter);      
} yyy24: goto yyBegin;
# line 3289 "Scanner.c"
case 1247:;
yySetPosition
# line 792 "fortran.rex"
{ SaveBEGToken(TokOptional);       
} yyy25: goto yyBegin;
# line 3295 "Scanner.c"
case 1241:;
yySetPosition
# line 793 "fortran.rex"
{ SaveBEGToken (TokExternal);      
} yyy26: goto yyBegin;
# line 3301 "Scanner.c"
case 1235:;
yySetPosition
# line 794 "fortran.rex"
{ SaveBEGToken(TokIntrinsic);      
} yyy27: goto yyBegin;
# line 3307 "Scanner.c"
case 1229:;
yySetPosition
# line 795 "fortran.rex"
{ SaveBEGToken(TokSave);           
} yyy28: goto yyBegin;
# line 3313 "Scanner.c"
case 1226:;
yySetPosition
# line 796 "fortran.rex"
{ SaveBEGToken(TokDimension);      
} yyy29: goto yyBegin;
# line 3319 "Scanner.c"
case 1218:;
yySetPosition
# line 797 "fortran.rex"
{ SaveBEGToken(TokIntent);         
} yyy30: goto yyBegin;
# line 3325 "Scanner.c"
case 1216:;
yySetPosition
# line 798 "fortran.rex"
{ SaveBEGToken(TokTarget);         
} yyy31: goto yyBegin;
# line 3331 "Scanner.c"
case 1211:;
yySetPosition
# line 799 "fortran.rex"
{ SaveBEGToken(TokPublic);         
} yyy32: goto yyBegin;
# line 3337 "Scanner.c"
case 1206:;
yySetPosition
# line 800 "fortran.rex"
{ SaveBEGToken(TokPrivate);        
} yyy33: goto yyBegin;
# line 3343 "Scanner.c"
case 1202:;
yySetPosition
# line 801 "fortran.rex"
{ SaveBEGToken(TokSequence);       
} yyy34: goto yyBegin;
# line 3349 "Scanner.c"
case 1196:;
yySetPosition
# line 802 "fortran.rex"
{ SaveBEGToken(TokPointer);        
} yyy35: goto yyBegin;
# line 3355 "Scanner.c"
case 1190:;
yySetPosition
# line 803 "fortran.rex"
{ SaveBEGToken(TokAllocatable);    
} yyy36: goto yyBegin;
# line 3361 "Scanner.c"
case 1186:;
yySetPosition
# line 805 "fortran.rex"
{ SaveBEGToken(TokCommon);         
} yyy37: goto yyBegin;
# line 3367 "Scanner.c"
case 1182:;
yySetPosition
# line 806 "fortran.rex"
{ SaveBEGToken(TokNameList);       
} yyy38: goto yyBegin;
# line 3373 "Scanner.c"
case 1175:;
yySetPosition
# line 807 "fortran.rex"
{ SaveBEGToken(TokEquivalence);    
} yyy39: goto yyBegin;
# line 3379 "Scanner.c"
case 1165:;
yySetPosition
# line 808 "fortran.rex"
{ SaveBEGToken(TokImplicit);       
} yyy40: goto yyBegin;
# line 3385 "Scanner.c"
case 91:;
yySetPosition
# line 809 "fortran.rex"
{ yyStart (Incl1);                 
} yyy41: goto yyBegin;
# line 3391 "Scanner.c"
case 90:;
yySetPosition
# line 810 "fortran.rex"
{ yyStart (Incl2);                 
} yyy42: goto yyBegin;
# line 3397 "Scanner.c"
case 1158:;
yySetPosition
# line 812 "fortran.rex"
{ SaveBEGToken(TokLayout);         
} yyy43: goto yyBegin;
# line 3403 "Scanner.c"
case 1152:;
yySetPosition
# line 813 "fortran.rex"
{ SaveBEGToken(TokPassBy);         
} yyy44: goto yyBegin;
# line 3409 "Scanner.c"
case 1146:;
yySetPosition
# line 814 "fortran.rex"
{ SaveBEGToken(TokMapTo);          
} yyy45: goto yyBegin;
# line 3415 "Scanner.c"
case 257:;
yySetPosition
# line 822 "fortran.rex"
{ SaveBEGToken(TokType);           
} yyy46: goto yyBegin;
# line 3421 "Scanner.c"
case 84:;
case 157:;
yySetPosition
# line 823 "fortran.rex"
{ yyStart (DIST);
                                      return(TokEndType);              
} yyy47: goto yyBegin;
# line 3429 "Scanner.c"
case 1140:;
yySetPosition
# line 825 "fortran.rex"
{ SaveBEGToken(TokInterface);      
} yyy48: goto yyBegin;
# line 3435 "Scanner.c"
case 86:;
case 159:;
yySetPosition
# line 826 "fortran.rex"
{ yyStart (DIST);
                                      return(TokEndInterface);         
} yyy49: goto yyBegin;
# line 3443 "Scanner.c"
case 1133:;
yySetPosition
# line 828 "fortran.rex"
{ SaveBEGToken(TokContains);       
} yyy50: goto yyBegin;
# line 3449 "Scanner.c"
case 1129:;
yySetPosition
# line 829 "fortran.rex"
{ SaveBEGToken(TokUse);            
} yyy51: goto yyBegin;
# line 3455 "Scanner.c"
case 360:;
yySetPosition
# line 831 "fortran.rex"
{ SaveBEGToken(TokDo);              
} yyy52: goto yyBegin;
# line 3461 "Scanner.c"
case 87:;
case 160:;
yySetPosition
# line 833 "fortran.rex"
{ yyStart (DIST);
                                      if (MakeEndDos > 0)
                                         return (TokContinue);
                                       else
                                         return(TokEndDo);             
} yyy53: goto yyBegin;
# line 3472 "Scanner.c"
case 1126:;
yySetPosition
# line 839 "fortran.rex"
{ SaveBEGToken(TokForall);         
} yyy54: goto yyBegin;
# line 3478 "Scanner.c"
case 88:;
case 161:;
yySetPosition
# line 840 "fortran.rex"
{ yyStart (DIST);
                                      return(TokEndForall);            
} yyy55: goto yyBegin;
# line 3486 "Scanner.c"
case 1123:;
yySetPosition
# line 843 "fortran.rex"
{ SaveBEGToken(TokIf);             
} yyy56: goto yyBegin;
# line 3492 "Scanner.c"
case 131:;
yySetPosition
# line 844 "fortran.rex"
{ SaveBEGToken(TokElse);           
} yyy57: goto yyBegin;
# line 3498 "Scanner.c"
case 81:;
case 154:;
yySetPosition
# line 845 "fortran.rex"
{ yyStart (DIST);
                                      ReservedWordState = StateElseIf;
                                      return(TokElseIf);               
} yyy58: goto yyBegin;
# line 3507 "Scanner.c"
case 85:;
case 158:;
yySetPosition
# line 848 "fortran.rex"
{ yyStart (DIST);
                                      return(TokEndIf);                
} yyy59: goto yyBegin;
# line 3515 "Scanner.c"
case 1122:;
yySetPosition
# line 851 "fortran.rex"
{ SaveBEGToken(TokWhere);          
} yyy60: goto yyBegin;
# line 3521 "Scanner.c"
case 80:;
case 153:;
yySetPosition
# line 852 "fortran.rex"
{ yyStart (DIST);
                                      return(TokElseWhere);            
} yyy61: goto yyBegin;
# line 3529 "Scanner.c"
case 82:;
case 155:;
yySetPosition
# line 854 "fortran.rex"
{ yyStart (DIST);
                                      return(TokEndWhere);             
} yyy62: goto yyBegin;
# line 3537 "Scanner.c"
case 77:;
case 150:;
yySetPosition
# line 857 "fortran.rex"
{ SaveBEGToken(TokSelectCase);     
} yyy63: goto yyBegin;
# line 3544 "Scanner.c"
case 83:;
case 156:;
yySetPosition
# line 859 "fortran.rex"
{ yyStart (DIST);
                                      return(TokEndSelect);            
} yyy64: goto yyBegin;
# line 3552 "Scanner.c"
case 1118:;
yySetPosition
# line 862 "fortran.rex"
{ SaveBEGToken(TokCase);           
} yyy65: goto yyBegin;
# line 3558 "Scanner.c"
case 1116:;
yySetPosition
# line 864 "fortran.rex"
{ SaveBEGToken(TokEntry);          
} yyy66: goto yyBegin;
# line 3564 "Scanner.c"
case 130:;
yySetPosition
# line 866 "fortran.rex"
{ yyStart (DIST);
                                      return (NoAssign(TokEnd));       
} yyy67: goto yyBegin;
# line 3571 "Scanner.c"
case 1113:;
yySetPosition
# line 875 "fortran.rex"
{ SaveBEGToken(TokAssign);         
} yyy68: goto yyBegin;
# line 3577 "Scanner.c"
case 1108:;
yySetPosition
# line 876 "fortran.rex"
{ SaveBEGToken(TokCall);           
} yyy69: goto yyBegin;
# line 3583 "Scanner.c"
case 1105:;
yySetPosition
# line 877 "fortran.rex"
{ SaveBEGToken(TokContinue);       
} yyy70: goto yyBegin;
# line 3589 "Scanner.c"
case 1098:;
yySetPosition
# line 878 "fortran.rex"
{ SaveBEGToken(TokStop);           
} yyy71: goto yyBegin;
# line 3595 "Scanner.c"
case 1095:;
yySetPosition
# line 879 "fortran.rex"
{ SaveBEGToken(TokReturn);         
} yyy72: goto yyBegin;
# line 3601 "Scanner.c"
case 79:;
case 152:;
yySetPosition
# line 880 "fortran.rex"
{ yyStart (DIST);
                                      return(TokGoto);                 
} yyy73: goto yyBegin;
# line 3609 "Scanner.c"
case 1091:;
yySetPosition
# line 882 "fortran.rex"
{ SaveBEGToken(TokCycle);          
} yyy74: goto yyBegin;
# line 3615 "Scanner.c"
case 1087:;
yySetPosition
# line 883 "fortran.rex"
{ SaveBEGToken(TokExit);           
} yyy75: goto yyBegin;
# line 3621 "Scanner.c"
case 1084:;
yySetPosition
# line 885 "fortran.rex"
{ SaveBEGToken(TokRead);           
} yyy76: goto yyBegin;
# line 3627 "Scanner.c"
case 1082:;
yySetPosition
# line 886 "fortran.rex"
{ SaveBEGToken(TokWrite);          
} yyy77: goto yyBegin;
# line 3633 "Scanner.c"
case 1077:;
yySetPosition
# line 887 "fortran.rex"
{ SaveBEGToken(TokPrint);          
} yyy78: goto yyBegin;
# line 3639 "Scanner.c"
case 1072:;
yySetPosition
# line 888 "fortran.rex"
{ SaveBEGToken(TokOpen);           
} yyy79: goto yyBegin;
# line 3645 "Scanner.c"
case 1068:;
yySetPosition
# line 889 "fortran.rex"
{ SaveBEGToken(TokClose);          
} yyy80: goto yyBegin;
# line 3651 "Scanner.c"
case 1063:;
yySetPosition
# line 890 "fortran.rex"
{ SaveBEGToken(TokInquire);        
} yyy81: goto yyBegin;
# line 3657 "Scanner.c"
case 1058:;
yySetPosition
# line 891 "fortran.rex"
{ SaveBEGToken(TokBackspace);      
} yyy82: goto yyBegin;
# line 3663 "Scanner.c"
case 1050:;
yySetPosition
# line 892 "fortran.rex"
{ SaveBEGToken(TokEndfile);        
} yyy83: goto yyBegin;
# line 3669 "Scanner.c"
case 1047:;
yySetPosition
# line 893 "fortran.rex"
{ SaveBEGToken(TokRewind);         
} yyy84: goto yyBegin;
# line 3675 "Scanner.c"
case 1041:;
yySetPosition
# line 895 "fortran.rex"
{ yyStart (FORMAT);
                                      StringLength = 0;
                                      return (TokFormat);              
} yyy85: goto yyBegin;
# line 3683 "Scanner.c"
case 1035:;
yySetPosition
# line 898 "fortran.rex"
{ SaveBEGToken(TokAllocate);       
} yyy86: goto yyBegin;
# line 3689 "Scanner.c"
case 1027:;
yySetPosition
# line 899 "fortran.rex"
{ SaveBEGToken(TokDeallocate);     
} yyy87: goto yyBegin;
# line 3695 "Scanner.c"
case 1018:;
yySetPosition
# line 900 "fortran.rex"
{ SaveBEGToken(TokNullify);        
} yyy88: goto yyBegin;
# line 3701 "Scanner.c"
case 75:;
case 127:;
case 128:;
case 129:;
case 132:;
case 133:;
case 134:;
case 135:;
case 136:;
case 137:;
case 138:;
case 139:;
case 140:;
case 141:;
case 142:;
case 143:;
case 144:;
case 145:;
case 146:;
case 147:;
case 148:;
case 149:;
case 193:;
case 194:;
case 291:;
case 292:;
case 293:;
case 294:;
case 295:;
case 296:;
case 297:;
case 298:;
case 299:;
case 300:;
case 301:;
case 302:;
case 303:;
case 304:;
case 305:;
case 329:;
case 330:;
case 331:;
case 332:;
case 333:;
case 334:;
case 335:;
case 336:;
case 337:;
case 338:;
case 339:;
case 340:;
case 345:;
case 346:;
case 347:;
case 348:;
case 349:;
case 350:;
case 351:;
case 352:;
case 353:;
case 358:;
case 359:;
case 361:;
case 362:;
case 363:;
case 370:;
case 371:;
case 373:;
case 374:;
case 375:;
case 376:;
case 1012:;
case 1013:;
case 1014:;
case 1015:;
case 1016:;
case 1017:;
case 1019:;
case 1020:;
case 1021:;
case 1022:;
case 1023:;
case 1024:;
case 1025:;
case 1026:;
case 1028:;
case 1029:;
case 1030:;
case 1031:;
case 1032:;
case 1033:;
case 1034:;
case 1036:;
case 1037:;
case 1038:;
case 1039:;
case 1040:;
case 1042:;
case 1043:;
case 1044:;
case 1045:;
case 1046:;
case 1048:;
case 1049:;
case 1051:;
case 1052:;
case 1053:;
case 1054:;
case 1055:;
case 1056:;
case 1057:;
case 1059:;
case 1060:;
case 1061:;
case 1062:;
case 1064:;
case 1065:;
case 1066:;
case 1067:;
case 1069:;
case 1070:;
case 1071:;
case 1073:;
case 1074:;
case 1075:;
case 1076:;
case 1078:;
case 1079:;
case 1080:;
case 1081:;
case 1083:;
case 1085:;
case 1086:;
case 1088:;
case 1089:;
case 1090:;
case 1092:;
case 1093:;
case 1094:;
case 1096:;
case 1097:;
case 1099:;
case 1100:;
case 1101:;
case 1102:;
case 1103:;
case 1104:;
case 1106:;
case 1107:;
case 1109:;
case 1110:;
case 1111:;
case 1112:;
case 1114:;
case 1115:;
case 1117:;
case 1119:;
case 1120:;
case 1121:;
case 1124:;
case 1125:;
case 1127:;
case 1128:;
case 1130:;
case 1131:;
case 1132:;
case 1134:;
case 1135:;
case 1136:;
case 1137:;
case 1138:;
case 1139:;
case 1141:;
case 1142:;
case 1143:;
case 1144:;
case 1145:;
case 1147:;
case 1148:;
case 1149:;
case 1150:;
case 1151:;
case 1153:;
case 1154:;
case 1155:;
case 1156:;
case 1157:;
case 1159:;
case 1160:;
case 1161:;
case 1162:;
case 1163:;
case 1164:;
case 1166:;
case 1167:;
case 1168:;
case 1169:;
case 1170:;
case 1171:;
case 1172:;
case 1173:;
case 1174:;
case 1176:;
case 1177:;
case 1178:;
case 1179:;
case 1180:;
case 1181:;
case 1183:;
case 1184:;
case 1185:;
case 1187:;
case 1188:;
case 1189:;
case 1191:;
case 1192:;
case 1193:;
case 1194:;
case 1195:;
case 1197:;
case 1198:;
case 1199:;
case 1200:;
case 1201:;
case 1203:;
case 1204:;
case 1205:;
case 1207:;
case 1208:;
case 1209:;
case 1210:;
case 1212:;
case 1213:;
case 1214:;
case 1215:;
case 1217:;
case 1219:;
case 1220:;
case 1221:;
case 1222:;
case 1223:;
case 1224:;
case 1225:;
case 1227:;
case 1228:;
case 1230:;
case 1231:;
case 1232:;
case 1233:;
case 1234:;
case 1236:;
case 1237:;
case 1238:;
case 1239:;
case 1240:;
case 1242:;
case 1243:;
case 1244:;
case 1245:;
case 1246:;
case 1248:;
case 1249:;
case 1250:;
case 1251:;
case 1252:;
case 1253:;
case 1255:;
case 1256:;
case 1258:;
case 1259:;
case 1260:;
case 1261:;
case 1263:;
case 1264:;
case 1265:;
case 1266:;
case 1267:;
case 1268:;
case 1270:;
case 1271:;
case 1272:;
case 1273:;
case 1274:;
case 1275:;
case 1276:;
case 1277:;
case 1279:;
case 1280:;
case 1281:;
case 1282:;
case 1283:;
case 1284:;
case 1286:;
case 1287:;
case 1288:;
case 1289:;
case 1290:;
case 1292:;
case 1294:;
case 1295:;
case 1296:;
case 1297:;
case 1299:;
case 1300:;
case 1301:;
case 1302:;
case 1303:;
case 1304:;
case 1305:;
case 1307:;
case 1308:;
case 1309:;
case 1310:;
case 1311:;
case 1313:;
case 1314:;
case 1315:;
case 1318:;
case 1319:;
yySetPosition
# line 902 "fortran.rex"
{ SaveBEGToken(TokIdentifier);     
} yyy89: goto yyBegin;
# line 4025 "Scanner.c"
case 47:;
case 402:;
# line 910 "fortran.rex"
{ MyLength = GetWord (MyWord);
                         Attribute.StringConst =
                             PutString (MyWord, MyLength); 
} yyy90: goto yyBegin;
# line 4033 "Scanner.c"
case 1011:;
yySetPosition
# line 914 "fortran.rex"
{  BeginFile (MyWord);
                   yyStart (STD); 
                
} yyy91: goto yyBegin;
# line 4041 "Scanner.c"
case 46:;
case 403:;
# line 918 "fortran.rex"
{ MyLength = GetWord (MyWord);
                         Attribute.StringConst =
                             PutString (MyWord, MyLength); 
} yyy92: goto yyBegin;
# line 4049 "Scanner.c"
case 1010:;
yySetPosition
# line 922 "fortran.rex"
{  BeginFile (MyWord);
                   yyStart (STD); 
                
} yyy93: goto yyBegin;
# line 4057 "Scanner.c"
case 1009:;
yySetPosition
# line 932 "fortran.rex"
{
} yyy94: goto yyBegin;
# line 4063 "Scanner.c"
case 67:;
yySetPosition
# line 934 "fortran.rex"
{ yyEol (0);                         
} yyy95: goto yyBegin;
# line 4069 "Scanner.c"
case 1008:;
yySetPosition
# line 936 "fortran.rex"
{ yyStart (BEG);
                                       return (TokNL);
                                     
} yyy96: goto yyBegin;
# line 4077 "Scanner.c"
case 65:;
case 382:;
yySetPosition
# line 952 "fortran.rex"
{ if (yyEof)
                                      return (TokNL);
                                    else
                                      { yyEol (0); 
                                        yyStart (ENDS); 
                                      }
                                 
} yyy97: goto yyBegin;
# line 4090 "Scanner.c"
case 49:;
case 386:;
yySetPosition
# line 968 "fortran.rex"
{ if (yyEof)
                                      return (TokNL);
                                    else
                                      yyEol (0); 
                                 
} yyy98: goto yyBegin;
# line 4101 "Scanner.c"
case 50:;
yySetPosition
# line 974 "fortran.rex"
{ if ((MakeEndDos == 0) && (EndDoSwitch == 0))
                       { yyStart (ADP);  /* directive can be accepted now */ }
                     else
                       { yyLess (0); }      /* do not use characters         */
                    return (EndToken());
                  
} yyy99: goto yyBegin;
# line 4112 "Scanner.c"
case 48:;
case 118:;
case 119:;
case 395:;
yySetPosition
# line 983 "fortran.rex"
{  yyLess (0);
                                   if ((MakeEndDos == 0) && (EndDoSwitch == 0))
                                      yyStart (STD);
                                   return (EndToken());
                                
} yyy100: goto yyBegin;
# line 4125 "Scanner.c"
case 64:;
# line 1008 "fortran.rex"
{ /* was a reserved word, PUBLIC, PRIVATE, ... */

                        yyLess  (0);
                        yyStart (DIST);
                        return  (GetBEGToken());                    
} yyy101: goto yyBegin;
# line 4134 "Scanner.c"
case 62:;
# line 1014 "fortran.rex"
{ /* not a reserved word, will be a construct id  */

                       yyLess  (0);      /* = to be scanned againg */
                       yyStart (NAMED);
                       return  (TokIdentifier);                     
} yyy102: goto yyBegin;
# line 4143 "Scanner.c"
case 63:;
case 121:;
# line 1025 "fortran.rex"
{ /* not a reserved word, will be an assign */

                     if (IsParNesting ())
                       { yyLess (0);
                         yyStart (DIST);
                         return  (TokIdentifier);                    
                       }
                      else
                       { yyLess (0);
                         yyStart (DIST);
                         return  (GetBEGToken());                    
                       }
                   
} yyy103: goto yyBegin;
# line 4161 "Scanner.c"
case 61:;
case 383:;
# line 1039 "fortran.rex"
{ /* it was a reserved word */

                     yyEol   (0);
                     yyStart (ENDS);
                     return  (GetBEGToken());                     
} yyy104: goto yyBegin;
# line 4171 "Scanner.c"
case 60:;
case 120:;
case 190:;
case 391:;
# line 1045 "fortran.rex"
{ /* token form BEG was a reserved word */
                     yyLess  (0);
                     yyStart (DIST);
                     return  (GetBEGToken());                     
} yyy105: goto yyBegin;
# line 4182 "Scanner.c"
case 1007:;
yySetPosition
# line 1061 "fortran.rex"
{ return (TokColon);         
} yyy106: goto yyBegin;
# line 4188 "Scanner.c"
case 1006:;
yySetPosition
# line 1063 "fortran.rex"
{ yyStart (DIST);
                             return (TokDo);            
} yyy107: goto yyBegin;
# line 4195 "Scanner.c"
case 1004:;
yySetPosition
# line 1066 "fortran.rex"
{ yyStart (DIST);
                             return (TokIf);            
} yyy108: goto yyBegin;
# line 4202 "Scanner.c"
case 1002:;
yySetPosition
# line 1069 "fortran.rex"
{ yyStart (DIST);
                             return (TokForall);        
} yyy109: goto yyBegin;
# line 4209 "Scanner.c"
case 74:;
case 126:;
yySetPosition
# line 1072 "fortran.rex"
{ yyStart (DIST);
                                        return(TokSelectCase);     
} yyy110: goto yyBegin;
# line 4217 "Scanner.c"
case 73:;
case 125:;
case 191:;
case 192:;
case 307:;
case 308:;
case 341:;
case 342:;
case 354:;
case 369:;
case 997:;
case 998:;
case 999:;
case 1000:;
case 1001:;
case 1003:;
case 1005:;
yySetPosition
# line 1075 "fortran.rex"
{ SetIdentifier ();
                                        return (TokIdentifier); 
} yyy111: goto yyBegin;
# line 4240 "Scanner.c"
case 996:;
yySetPosition
# line 1086 "fortran.rex"
{ return(CheckReswd(StateTypes,TokDeclReal));      
} yyy112: goto yyBegin;
# line 4246 "Scanner.c"
case 995:;
yySetPosition
# line 1087 "fortran.rex"
{ return(CheckReswd(StateTypes,TokDeclInt));       
} yyy113: goto yyBegin;
# line 4252 "Scanner.c"
case 992:;
yySetPosition
# line 1088 "fortran.rex"
{ return(CheckReswd(StateTypes,TokDeclCharacter)); 
} yyy114: goto yyBegin;
# line 4258 "Scanner.c"
case 984:;
yySetPosition
# line 1089 "fortran.rex"
{ return(CheckReswd(StateTypes,TokDeclLogical));   
} yyy115: goto yyBegin;
# line 4264 "Scanner.c"
case 978:;
yySetPosition
# line 1090 "fortran.rex"
{ return(CheckReswd(StateTypes,TokDeclComplex));   
} yyy116: goto yyBegin;
# line 4270 "Scanner.c"
case 71:;
yySetPosition
# line 1092 "fortran.rex"
{ return(CheckReswd(StateTypes,TokDeclDouble)); 
} yyy117: goto yyBegin;
# line 4276 "Scanner.c"
case 72:;
yySetPosition
# line 1094 "fortran.rex"
{ return(CheckReswd(StateTypes,TokDeclCDouble)); 
} yyy118: goto yyBegin;
# line 4282 "Scanner.c"
case 973:;
yySetPosition
# line 1095 "fortran.rex"
{ return(CheckReswd(StateTypes,TokPure)); 
} yyy119: goto yyBegin;
# line 4288 "Scanner.c"
case 971:;
yySetPosition
# line 1096 "fortran.rex"
{ return(CheckReswd(StateTypes,TokType));   
} yyy120: goto yyBegin;
# line 4294 "Scanner.c"
case 968:;
yySetPosition
# line 1097 "fortran.rex"
{ return(CheckReswd(StateTypes,TokExtrinsic)); 
} yyy121: goto yyBegin;
# line 4300 "Scanner.c"
case 962:;
yySetPosition
# line 1098 "fortran.rex"
{ return(CheckReswd(StateTypes,TokRecursive)); 
} yyy122: goto yyBegin;
# line 4306 "Scanner.c"
case 955:;
yySetPosition
# line 1102 "fortran.rex"
{ return(CheckReswd(StateModule,TokProcedure)); 
} yyy123: goto yyBegin;
# line 4312 "Scanner.c"
case 949:;
yySetPosition
# line 1107 "fortran.rex"
{ return(TokSubroutine);           
} yyy124: goto yyBegin;
# line 4318 "Scanner.c"
case 940:;
yySetPosition
# line 1108 "fortran.rex"
{ ReservedWordState = StateFunc;
                                       return(TokFunction);             
} yyy125: goto yyBegin;
# line 4325 "Scanner.c"
case 932:;
yySetPosition
# line 1110 "fortran.rex"
{ return(TokProgram);              
} yyy126: goto yyBegin;
# line 4331 "Scanner.c"
case 927:;
yySetPosition
# line 1111 "fortran.rex"
{ return(TokModule);               
} yyy127: goto yyBegin;
# line 4337 "Scanner.c"
case 68:;
case 122:;
yySetPosition
# line 1112 "fortran.rex"
{ return(TokBlockData);            
} yyy128: goto yyBegin;
# line 4344 "Scanner.c"
case 922:;
yySetPosition
# line 1114 "fortran.rex"
{ return(CheckReswd(StateFunc,TokResult));      
} yyy129: goto yyBegin;
# line 4350 "Scanner.c"
case 918:;
yySetPosition
# line 1122 "fortran.rex"
{ return(TokAllocatable1);
} yyy130: goto yyBegin;
# line 4356 "Scanner.c"
case 914:;
yySetPosition
# line 1123 "fortran.rex"
{ return(TokOptional1);   
} yyy131: goto yyBegin;
# line 4362 "Scanner.c"
case 908:;
yySetPosition
# line 1124 "fortran.rex"
{ return(TokLayout1);     
} yyy132: goto yyBegin;
# line 4368 "Scanner.c"
case 902:;
yySetPosition
# line 1125 "fortran.rex"
{ return(TokPassBy1);     
} yyy133: goto yyBegin;
# line 4374 "Scanner.c"
case 897:;
yySetPosition
# line 1126 "fortran.rex"
{ return(TokMapTo1);      
} yyy134: goto yyBegin;
# line 4380 "Scanner.c"
case 891:;
yySetPosition
# line 1127 "fortran.rex"
{ return(TokPointer1);    
} yyy135: goto yyBegin;
# line 4386 "Scanner.c"
case 885:;
yySetPosition
# line 1128 "fortran.rex"
{ return(TokTarget1);     
} yyy136: goto yyBegin;
# line 4392 "Scanner.c"
case 880:;
yySetPosition
# line 1129 "fortran.rex"
{ return(TokPublic1);     
} yyy137: goto yyBegin;
# line 4398 "Scanner.c"
case 875:;
yySetPosition
# line 1130 "fortran.rex"
{ return(TokPrivate1);    
} yyy138: goto yyBegin;
# line 4404 "Scanner.c"
case 871:;
yySetPosition
# line 1131 "fortran.rex"
{ return(TokSequence1);   
} yyy139: goto yyBegin;
# line 4410 "Scanner.c"
case 864:;
yySetPosition
# line 1132 "fortran.rex"
{ return(TokSave1);       
} yyy140: goto yyBegin;
# line 4416 "Scanner.c"
case 861:;
yySetPosition
# line 1133 "fortran.rex"
{ return(TokArray1);      
} yyy141: goto yyBegin;
# line 4422 "Scanner.c"
case 857:;
yySetPosition
# line 1134 "fortran.rex"
{ return(TokDimension1);  
} yyy142: goto yyBegin;
# line 4428 "Scanner.c"
case 849:;
yySetPosition
# line 1135 "fortran.rex"
{ return(TokParameter1);  
} yyy143: goto yyBegin;
# line 4434 "Scanner.c"
case 841:;
yySetPosition
# line 1136 "fortran.rex"
{ return(TokIntrinsic1);  
} yyy144: goto yyBegin;
# line 4440 "Scanner.c"
case 835:;
yySetPosition
# line 1137 "fortran.rex"
{ return(TokExternal1);   
} yyy145: goto yyBegin;
# line 4446 "Scanner.c"
case 829:;
yySetPosition
# line 1138 "fortran.rex"
{ return(TokData1);       
} yyy146: goto yyBegin;
# line 4452 "Scanner.c"
case 826:;
yySetPosition
# line 1139 "fortran.rex"
{ return(TokIntent1);     
} yyy147: goto yyBegin;
# line 4458 "Scanner.c"
case 164:;
yySetPosition
# line 1143 "fortran.rex"
{ return(TokIn);                 
} yyy148: goto yyBegin;
# line 4464 "Scanner.c"
case 70:;
case 124:;
yySetPosition
# line 1144 "fortran.rex"
{ return(TokInOut);              
} yyy149: goto yyBegin;
# line 4471 "Scanner.c"
case 822:;
yySetPosition
# line 1145 "fortran.rex"
{ return(TokOut);                
} yyy150: goto yyBegin;
# line 4477 "Scanner.c"
case 820:;
yySetPosition
# line 1155 "fortran.rex"
{ return(CheckReswd(StateUse,TokOnly));       
} yyy151: goto yyBegin;
# line 4483 "Scanner.c"
case 817:;
yySetPosition
# line 1164 "fortran.rex"
{ return(TokOperator);   
} yyy152: goto yyBegin;
# line 4489 "Scanner.c"
case 812:;
yySetPosition
# line 1165 "fortran.rex"
{ return(TokAssignment); 
} yyy153: goto yyBegin;
# line 4495 "Scanner.c"
case 803:;
yySetPosition
# line 1177 "fortran.rex"
{ return(CheckReswd2 (StateIf,
                                            StateElseIf, TokThen));       
} yyy154: goto yyBegin;
# line 4502 "Scanner.c"
case 800:;
yySetPosition
# line 1180 "fortran.rex"
{ return(CheckReswd(StateIf,TokCall));       
} yyy155: goto yyBegin;
# line 4508 "Scanner.c"
case 797:;
yySetPosition
# line 1181 "fortran.rex"
{ return(CheckReswd(StateIf,TokAllocate));   
} yyy156: goto yyBegin;
# line 4514 "Scanner.c"
case 789:;
yySetPosition
# line 1182 "fortran.rex"
{ return(CheckReswd(StateIf,TokDeallocate)); 
} yyy157: goto yyBegin;
# line 4520 "Scanner.c"
case 781:;
yySetPosition
# line 1183 "fortran.rex"
{ return(CheckReswd(StateIf,TokContinue));   
} yyy158: goto yyBegin;
# line 4526 "Scanner.c"
case 774:;
yySetPosition
# line 1184 "fortran.rex"
{ return(CheckReswd(StateIf,TokStop));       
} yyy159: goto yyBegin;
# line 4532 "Scanner.c"
case 770:;
yySetPosition
# line 1185 "fortran.rex"
{ return(CheckReswd(StateIf,TokReturn));     
} yyy160: goto yyBegin;
# line 4538 "Scanner.c"
case 69:;
case 123:;
yySetPosition
# line 1186 "fortran.rex"
{ return(CheckReswd(StateIf,TokGoto));       
} yyy161: goto yyBegin;
# line 4545 "Scanner.c"
case 766:;
yySetPosition
# line 1188 "fortran.rex"
{ return(CheckReswd(StateIf,TokCycle));      
} yyy162: goto yyBegin;
# line 4551 "Scanner.c"
case 762:;
yySetPosition
# line 1189 "fortran.rex"
{ return(CheckReswd(StateIf,TokExit));       
} yyy163: goto yyBegin;
# line 4557 "Scanner.c"
case 759:;
yySetPosition
# line 1191 "fortran.rex"
{ return(CheckReswd(StateIf,TokRead));       
} yyy164: goto yyBegin;
# line 4563 "Scanner.c"
case 757:;
yySetPosition
# line 1192 "fortran.rex"
{ return(CheckReswd(StateIf,TokWrite));      
} yyy165: goto yyBegin;
# line 4569 "Scanner.c"
case 753:;
yySetPosition
# line 1193 "fortran.rex"
{ return(CheckReswd(StateIf,TokPrint));      
} yyy166: goto yyBegin;
# line 4575 "Scanner.c"
case 748:;
yySetPosition
# line 1194 "fortran.rex"
{ return(CheckReswd(StateIf,TokOpen));       
} yyy167: goto yyBegin;
# line 4581 "Scanner.c"
case 744:;
yySetPosition
# line 1195 "fortran.rex"
{ return(CheckReswd(StateIf,TokClose));      
} yyy168: goto yyBegin;
# line 4587 "Scanner.c"
case 739:;
yySetPosition
# line 1196 "fortran.rex"
{ return(CheckReswd(StateIf,TokInquire));    
} yyy169: goto yyBegin;
# line 4593 "Scanner.c"
case 734:;
yySetPosition
# line 1197 "fortran.rex"
{ return(CheckReswd(StateIf,TokBackspace));  
} yyy170: goto yyBegin;
# line 4599 "Scanner.c"
case 726:;
yySetPosition
# line 1198 "fortran.rex"
{ return(CheckReswd(StateIf,TokEndfile));    
} yyy171: goto yyBegin;
# line 4605 "Scanner.c"
case 719:;
yySetPosition
# line 1199 "fortran.rex"
{ return(CheckReswd(StateIf,TokRewind));     
} yyy172: goto yyBegin;
# line 4611 "Scanner.c"
case 713:;
yySetPosition
# line 1202 "fortran.rex"
{ return(CheckReswd(StateIf,TokWhere));      
} yyy173: goto yyBegin;
# line 4617 "Scanner.c"
case 710:;
yySetPosition
# line 1208 "fortran.rex"
{ return(TokDefault);        
} yyy174: goto yyBegin;
# line 4623 "Scanner.c"
case 704:;
yySetPosition
# line 1216 "fortran.rex"
{ return(CheckReswd(StateDo,TokWhile));        
} yyy175: goto yyBegin;
# line 4629 "Scanner.c"
case 699:;
yySetPosition
# line 1220 "fortran.rex"
{ return (CheckReswd (StateAssign, TokTo));    
} yyy176: goto yyBegin;
# line 4635 "Scanner.c"
case 66:;
yySetPosition
# line 1222 "fortran.rex"
{
} yyy177: goto yyBegin;
# line 4641 "Scanner.c"
case 697:;
yySetPosition
# line 1224 "fortran.rex"
{ StringLength = 0;
               yyStart (String1); 
} yyy178: goto yyBegin;
# line 4648 "Scanner.c"
case 696:;
yySetPosition
# line 1227 "fortran.rex"
{ StringLength = 0;
                  yyStart (String2); 
} yyy179: goto yyBegin;
# line 4655 "Scanner.c"
case 58:;
case 397:;
# line 1237 "fortran.rex"
{ MyLength = GetWord (MyWord); 
                       if (MyLength >= WORD_LENGTH) 
                         { printf ("Scanner fatal error: too long word %d  = %s \n",
                                   MyLength, MyWord);
                           exit (-1);
                         }
                       if (StringLength + MyLength >= STRING_LENGTH) 
                         { printf ("Scanner fatal error: too long string");
                           printf ("length %d + %d >= %d\n", StringLength,
                                    MyLength, STRING_LENGTH);
                           exit (-1);
                         }
                       for (i=0; i<MyLength; i++) 
                          StringWord[StringLength+i] = MyWord[i];
                       StringLength += MyLength; 
} yyy180: goto yyBegin;
# line 4675 "Scanner.c"
case 59:;
case 384:;
# line 1253 "fortran.rex"
{ printf ("error: string exceeds line\n");
                  SourceFileErrors += 1;
                  yyPrevious;
                  Attribute.StringConst = PutString (StringWord, StringLength);
                  return (TokCharLiteral); 
                
} yyy181: goto yyBegin;
# line 4686 "Scanner.c"
case 695:;
# line 1260 "fortran.rex"
{ StringWord[StringLength] = 39;
                       StringLength += 1;             
} yyy182: goto yyBegin;
# line 4692 "Scanner.c"
case 694:;
# line 1263 "fortran.rex"
{ yyPrevious;
                 Attribute.StringConst = PutString (StringWord, StringLength);
                 return (TokCharLiteral); 
} yyy183: goto yyBegin;
# line 4699 "Scanner.c"
case 56:;
case 398:;
# line 1267 "fortran.rex"
{ MyLength = GetWord (MyWord); 
                       for (i=0; i<MyLength; i++) 
                          StringWord[StringLength+i] = MyWord[i];
                       StringLength += MyLength; 
} yyy184: goto yyBegin;
# line 4708 "Scanner.c"
case 57:;
case 385:;
# line 1272 "fortran.rex"
{ printf ("error: string exceeds line\n");
                  SourceFileErrors += 1;
                  yyPrevious;
                  Attribute.StringConst = PutString (StringWord, StringLength);
                  return (TokCharLiteral); 
                
} yyy185: goto yyBegin;
# line 4719 "Scanner.c"
case 693:;
# line 1279 "fortran.rex"
{ StringWord[StringLength] = 34;
                                StringLength += 1;             
} yyy186: goto yyBegin;
# line 4725 "Scanner.c"
case 692:;
# line 1282 "fortran.rex"
{ yyPrevious;
                 Attribute.StringConst = PutString (StringWord, StringLength);
                 return (TokCharLiteral); 
} yyy187: goto yyBegin;
# line 4732 "Scanner.c"
case 691:;
yySetPosition
# line 1294 "fortran.rex"
{ return(TokPercent);              
} yyy188: goto yyBegin;
# line 4738 "Scanner.c"
case 685:;
yySetPosition
# line 1296 "fortran.rex"
{ return(TokLParanthesis);         
} yyy189: goto yyBegin;
# line 4744 "Scanner.c"
case 690:;
yySetPosition
# line 1297 "fortran.rex"
{ return(TokRParanthesis);         
} yyy190: goto yyBegin;
# line 4750 "Scanner.c"
case 682:;
yySetPosition
# line 1298 "fortran.rex"
{ return(TokColon);                
} yyy191: goto yyBegin;
# line 4756 "Scanner.c"
case 689:;
yySetPosition
# line 1299 "fortran.rex"
{ return(TokComma);                
} yyy192: goto yyBegin;
# line 4762 "Scanner.c"
case 688:;
yySetPosition
# line 1301 "fortran.rex"
{ return(TokLBracket);             
} yyy193: goto yyBegin;
# line 4768 "Scanner.c"
case 687:;
yySetPosition
# line 1302 "fortran.rex"
{ return(TokRBracket);             
} yyy194: goto yyBegin;
# line 4774 "Scanner.c"
case 686:;
yySetPosition
# line 1303 "fortran.rex"
{ return(TokLBracket);             
} yyy195: goto yyBegin;
# line 4780 "Scanner.c"
case 684:;
yySetPosition
# line 1304 "fortran.rex"
{ return(TokRBracket);             
} yyy196: goto yyBegin;
# line 4786 "Scanner.c"
case 683:;
yySetPosition
# line 1306 "fortran.rex"
{ ReservedWordState = 0; /* no reserved words */
                                  return(TokDoubleColon);          
} yyy197: goto yyBegin;
# line 4793 "Scanner.c"
case 673:;
yySetPosition
# line 1315 "fortran.rex"
{ return(TokBecomes);              
} yyy198: goto yyBegin;
# line 4799 "Scanner.c"
case 681:;
yySetPosition
# line 1316 "fortran.rex"
{ return(TokPAssign);              
} yyy199: goto yyBegin;
# line 4805 "Scanner.c"
case 186:;
yySetPosition
# line 1324 "fortran.rex"
{ return(TokPoint);                
} yyy200: goto yyBegin;
# line 4811 "Scanner.c"
case 680:;
yySetPosition
# line 1332 "fortran.rex"
{ return(TokNotEqual);             
} yyy201: goto yyBegin;
# line 4817 "Scanner.c"
case 679:;
yySetPosition
# line 1333 "fortran.rex"
{ return(TokNotEqual);             
} yyy202: goto yyBegin;
# line 4823 "Scanner.c"
case 678:;
yySetPosition
# line 1335 "fortran.rex"
{ return(TokNotEqual);             
} yyy203: goto yyBegin;
# line 4829 "Scanner.c"
case 676:;
yySetPosition
# line 1337 "fortran.rex"
{ return(TokNotEqual);             
} yyy204: goto yyBegin;
# line 4835 "Scanner.c"
case 675:;
yySetPosition
# line 1338 "fortran.rex"
{ return(TokEqual);                
} yyy205: goto yyBegin;
# line 4841 "Scanner.c"
case 674:;
yySetPosition
# line 1339 "fortran.rex"
{ return(TokEqual);                
} yyy206: goto yyBegin;
# line 4847 "Scanner.c"
case 672:;
yySetPosition
# line 1340 "fortran.rex"
{ return(TokGreater);              
} yyy207: goto yyBegin;
# line 4853 "Scanner.c"
case 666:;
yySetPosition
# line 1341 "fortran.rex"
{ return(TokGreater);              
} yyy208: goto yyBegin;
# line 4859 "Scanner.c"
case 670:;
yySetPosition
# line 1342 "fortran.rex"
{ return(TokGreaterEqual);         
} yyy209: goto yyBegin;
# line 4865 "Scanner.c"
case 667:;
yySetPosition
# line 1343 "fortran.rex"
{ return(TokGreaterEqual);         
} yyy210: goto yyBegin;
# line 4871 "Scanner.c"
case 665:;
yySetPosition
# line 1344 "fortran.rex"
{ return(TokLess);                 
} yyy211: goto yyBegin;
# line 4877 "Scanner.c"
case 659:;
yySetPosition
# line 1345 "fortran.rex"
{ return(TokLess);                 
} yyy212: goto yyBegin;
# line 4883 "Scanner.c"
case 663:;
yySetPosition
# line 1346 "fortran.rex"
{ return(TokLessEqual);            
} yyy213: goto yyBegin;
# line 4889 "Scanner.c"
case 660:;
yySetPosition
# line 1347 "fortran.rex"
{ return(TokLessEqual);            
} yyy214: goto yyBegin;
# line 4895 "Scanner.c"
case 658:;
yySetPosition
# line 1349 "fortran.rex"
{ return(TokAdd);                  
} yyy215: goto yyBegin;
# line 4901 "Scanner.c"
case 657:;
yySetPosition
# line 1350 "fortran.rex"
{ return(TokMinus);                
} yyy216: goto yyBegin;
# line 4907 "Scanner.c"
case 655:;
yySetPosition
# line 1351 "fortran.rex"
{ return(TokStar);                 
} yyy217: goto yyBegin;
# line 4913 "Scanner.c"
case 653:;
yySetPosition
# line 1352 "fortran.rex"
{ return(TokDivide);               
} yyy218: goto yyBegin;
# line 4919 "Scanner.c"
case 656:;
yySetPosition
# line 1353 "fortran.rex"
{ return(TokPow);                  
} yyy219: goto yyBegin;
# line 4925 "Scanner.c"
case 654:;
yySetPosition
# line 1354 "fortran.rex"
{ return(TokConcatenation);        
} yyy220: goto yyBegin;
# line 4931 "Scanner.c"
case 652:;
yySetPosition
# line 1357 "fortran.rex"
{ return(TokAnd);                  
} yyy221: goto yyBegin;
# line 4937 "Scanner.c"
case 648:;
yySetPosition
# line 1358 "fortran.rex"
{ return(TokOr);                   
} yyy222: goto yyBegin;
# line 4943 "Scanner.c"
case 645:;
yySetPosition
# line 1359 "fortran.rex"
{ return(TokXor);                  
} yyy223: goto yyBegin;
# line 4949 "Scanner.c"
case 641:;
yySetPosition
# line 1360 "fortran.rex"
{ return(TokNot);                  
} yyy224: goto yyBegin;
# line 4955 "Scanner.c"
case 638:;
yySetPosition
# line 1361 "fortran.rex"
{ return(TokEquiv);                
} yyy225: goto yyBegin;
# line 4961 "Scanner.c"
case 635:;
yySetPosition
# line 1362 "fortran.rex"
{ return(TokNotEquiv);             
} yyy226: goto yyBegin;
# line 4967 "Scanner.c"
case 630:;
yySetPosition
# line 1364 "fortran.rex"
{ return(TokTrue);                 
} yyy227: goto yyBegin;
# line 4973 "Scanner.c"
case 625:;
yySetPosition
# line 1365 "fortran.rex"
{ return(TokFalse);                
} yyy228: goto yyBegin;
# line 4979 "Scanner.c"
case 36:;
yySetPosition
# line 1368 "fortran.rex"
{ MyLength = GetUpper (MyWord);
                               Attribute.Ident = MakeIdent (MyWord,MyLength);
                               return (TokUserOp);              
} yyy229: goto yyBegin;
# line 4987 "Scanner.c"
case 54:;
case 392:;
case 399:;
yySetPosition
# line 1378 "fortran.rex"
{ MyLength = GetWord (MyWord);
                    for (i=0; i<MyLength; i++) 
                       StringWord[StringLength+i] = MyWord[i];
                    StringLength += MyLength; 
                  
} yyy230: goto yyBegin;
# line 4999 "Scanner.c"
case 55:;
yySetPosition
# line 1383 "fortran.rex"
{ yyStart(FORMAT1);
                    yyEol(0);
                    Attribute.StringConst =
                       PutString(StringWord, StringLength);
                    return (TokFormatString);
                  
} yyy231: goto yyBegin;
# line 5010 "Scanner.c"
case 53:;
case 393:;
case 400:;
yySetPosition
# line 1390 "fortran.rex"
{ yyLess (0);
                    yyStart (STD);
                    return (TokNL);
                  
} yyy232: goto yyBegin;
# line 5021 "Scanner.c"
case 411:;
yySetPosition
# line 1401 "fortran.rex"
{ return(TokTemplate);             
} yyy233: goto yyBegin;
# line 5027 "Scanner.c"
case 619:;
yySetPosition
# line 1402 "fortran.rex"
{ return(TokProcessors);           
} yyy234: goto yyBegin;
# line 5033 "Scanner.c"
case 609:;
yySetPosition
# line 1403 "fortran.rex"
{ return(TokAlign);                
} yyy235: goto yyBegin;
# line 5039 "Scanner.c"
case 606:;
yySetPosition
# line 1404 "fortran.rex"
{ return(TokRealign);              
} yyy236: goto yyBegin;
# line 5045 "Scanner.c"
case 601:;
yySetPosition
# line 1405 "fortran.rex"
{ return(TokWith);                 
} yyy237: goto yyBegin;
# line 5051 "Scanner.c"
case 597:;
yySetPosition
# line 1406 "fortran.rex"
{ return(TokDistribute);           
} yyy238: goto yyBegin;
# line 5057 "Scanner.c"
case 589:;
yySetPosition
# line 1407 "fortran.rex"
{ return(TokOnto);                 
} yyy239: goto yyBegin;
# line 5063 "Scanner.c"
case 587:;
yySetPosition
# line 1408 "fortran.rex"
{ return(TokBlock);                
} yyy240: goto yyBegin;
# line 5069 "Scanner.c"
case 583:;
yySetPosition
# line 1409 "fortran.rex"
{ return(TokCyclic);               
} yyy241: goto yyBegin;
# line 5075 "Scanner.c"
case 577:;
yySetPosition
# line 1410 "fortran.rex"
{ return(TokGenBlock);             
} yyy242: goto yyBegin;
# line 5081 "Scanner.c"
case 568:;
yySetPosition
# line 1411 "fortran.rex"
{ return(TokIndirect);             
} yyy243: goto yyBegin;
# line 5087 "Scanner.c"
case 563:;
yySetPosition
# line 1412 "fortran.rex"
{ return(TokArbitrary);            
} yyy244: goto yyBegin;
# line 5093 "Scanner.c"
case 555:;
yySetPosition
# line 1413 "fortran.rex"
{ return(TokRedistribute);         
} yyy245: goto yyBegin;
# line 5099 "Scanner.c"
case 546:;
yySetPosition
# line 1414 "fortran.rex"
{ return(TokDynamic);              
} yyy246: goto yyBegin;
# line 5105 "Scanner.c"
case 540:;
yySetPosition
# line 1415 "fortran.rex"
{ return(TokDimension);            
} yyy247: goto yyBegin;
# line 5111 "Scanner.c"
case 531:;
yySetPosition
# line 1416 "fortran.rex"
{ return(TokHPFSequence);          
} yyy248: goto yyBegin;
# line 5117 "Scanner.c"
case 45:;
case 117:;
yySetPosition
# line 1418 "fortran.rex"
{ return(TokNoSequence);           
} yyy249: goto yyBegin;
# line 5124 "Scanner.c"
case 524:;
yySetPosition
# line 1419 "fortran.rex"
{ return(TokIndependent);          
} yyy250: goto yyBegin;
# line 5130 "Scanner.c"
case 515:;
yySetPosition
# line 1420 "fortran.rex"
{ return(TokOn);                   
} yyy251: goto yyBegin;
# line 5136 "Scanner.c"
case 513:;
yySetPosition
# line 1421 "fortran.rex"
{ return(TokHome);                 
} yyy252: goto yyBegin;
# line 5142 "Scanner.c"
case 509:;
yySetPosition
# line 1422 "fortran.rex"
{ return(TokResident);             
} yyy253: goto yyBegin;
# line 5148 "Scanner.c"
case 503:;
yySetPosition
# line 1423 "fortran.rex"
{ return(TokNew);                  
} yyy254: goto yyBegin;
# line 5154 "Scanner.c"
case 501:;
yySetPosition
# line 1424 "fortran.rex"
{ return(TokReduction);            
} yyy255: goto yyBegin;
# line 5160 "Scanner.c"
case 493:;
yySetPosition
# line 1425 "fortran.rex"
{ return(TokInherit);              
} yyy256: goto yyBegin;
# line 5166 "Scanner.c"
case 486:;
yySetPosition
# line 1426 "fortran.rex"
{ return(TokRange);                
} yyy257: goto yyBegin;
# line 5172 "Scanner.c"
case 481:;
yySetPosition
# line 1427 "fortran.rex"
{ return(TokAll);                  
} yyy258: goto yyBegin;
# line 5178 "Scanner.c"
case 478:;
yySetPosition
# line 1428 "fortran.rex"
{ return(TokHPFBegin);             
} yyy259: goto yyBegin;
# line 5184 "Scanner.c"
case 473:;
yySetPosition
# line 1429 "fortran.rex"
{ return(TokHPFEnd);               
} yyy260: goto yyBegin;
# line 5190 "Scanner.c"
case 470:;
yySetPosition
# line 1430 "fortran.rex"
{ return(TokShadow);               
} yyy261: goto yyBegin;
# line 5196 "Scanner.c"
case 464:;
yySetPosition
# line 1431 "fortran.rex"
{ return(TokTaskRegion);           
} yyy262: goto yyBegin;
# line 5202 "Scanner.c"
case 44:;
case 387:;
yySetPosition
# line 1433 "fortran.rex"
{ yyStart(STD);
                                  yyEol(0);
                                  return (TokNL); 
} yyy263: goto yyBegin;
# line 5211 "Scanner.c"
case 454:;
yySetPosition
# line 1443 "fortran.rex"
{ return(TokTrace);          
} yyy264: goto yyBegin;
# line 5217 "Scanner.c"
case 451:;
yySetPosition
# line 1444 "fortran.rex"
{ return(TokTree);           
} yyy265: goto yyBegin;
# line 5223 "Scanner.c"
case 448:;
yySetPosition
# line 1445 "fortran.rex"
{ return(TokSkip);           
} yyy266: goto yyBegin;
# line 5229 "Scanner.c"
case 444:;
yySetPosition
# line 1446 "fortran.rex"
{ return(TokAllocate);       
} yyy267: goto yyBegin;
# line 5235 "Scanner.c"
case 436:;
yySetPosition
# line 1447 "fortran.rex"
{ return(TokTo);             
} yyy268: goto yyBegin;
# line 5241 "Scanner.c"
case 434:;
yySetPosition
# line 1448 "fortran.rex"
{ return(TokNoDescriptor);   
} yyy269: goto yyBegin;
# line 5247 "Scanner.c"
case 422:;
yySetPosition
# line 1449 "fortran.rex"
{ return(TokAtomic);         
} yyy270: goto yyBegin;
# line 5253 "Scanner.c"
case 416:;
yySetPosition
# line 1451 "fortran.rex"
{ yyStart (FLAGS);
                                  StringLength = 0;
                                
} yyy271: goto yyBegin;
# line 5261 "Scanner.c"
case 33:;
case 388:;
yySetPosition
# line 1455 "fortran.rex"
{ yyStart(STD);
                                  yyEol(0);
                                  return (TokNL); 
} yyy272: goto yyBegin;
# line 5270 "Scanner.c"
case 51:;
case 394:;
case 401:;
yySetPosition
# line 1465 "fortran.rex"
{ MyLength = GetWord (MyWord);
                    for (i=0; i<MyLength; i++) 
                       StringWord[StringLength+i] = MyWord[i];
                    StringLength += MyLength; 
                  
} yyy273: goto yyBegin;
# line 5282 "Scanner.c"
case 52:;
yySetPosition
# line 1470 "fortran.rex"
{ yyStart(STD);
                    yyEol(0);
                    option_string =
                       PutString(StringWord, StringLength);

                    EvalOptions (option_string);

                  
} yyy274: goto yyBegin;
# line 5295 "Scanner.c"
case 40:;
yySetPosition
# line 1494 "fortran.rex"
{ 
                 MyLength = GetWord (MyWord);
                 Attribute.IntConst = rep_convert (MyWord+2, MyLength-3, 2);
                 return (TokInteger); 
} yyy275: goto yyBegin;
# line 5304 "Scanner.c"
case 41:;
yySetPosition
# line 1499 "fortran.rex"
{ 
                 MyLength = GetWord (MyWord);
                 Attribute.IntConst = rep_convert (MyWord+2, MyLength-3, 2);
                 return (TokInteger); 
} yyy276: goto yyBegin;
# line 5313 "Scanner.c"
case 42:;
yySetPosition
# line 1504 "fortran.rex"
{
                 MyLength = GetWord (MyWord);
                 Attribute.IntConst = rep_convert (MyWord+2, MyLength-3, 8);
                 return (TokInteger); 
} yyy277: goto yyBegin;
# line 5322 "Scanner.c"
case 43:;
yySetPosition
# line 1509 "fortran.rex"
{
                 MyLength = GetWord (MyWord);
                 Attribute.IntConst = rep_convert (MyWord+2, MyLength-3, 8);
                 return (TokInteger); 
} yyy278: goto yyBegin;
# line 5331 "Scanner.c"
case 38:;
yySetPosition
# line 1514 "fortran.rex"
{
                 MyLength = GetWord (MyWord);
                 Attribute.IntConst = rep_convert (MyWord+2, MyLength-3, 16);
                 return (TokInteger); 
} yyy279: goto yyBegin;
# line 5340 "Scanner.c"
case 39:;
yySetPosition
# line 1519 "fortran.rex"
{
                 MyLength = GetWord (MyWord);
                 Attribute.IntConst = rep_convert (MyWord+2, MyLength-3, 16);
                 return (TokInteger); 
} yyy280: goto yyBegin;
# line 5349 "Scanner.c"
case 31:;
case 98:;
case 99:;
case 100:;
case 101:;
case 102:;
case 103:;
case 104:;
case 105:;
case 163:;
case 165:;
case 166:;
case 196:;
case 281:;
case 282:;
case 283:;
case 284:;
case 285:;
case 286:;
case 306:;
case 324:;
case 325:;
case 326:;
case 327:;
case 328:;
case 343:;
case 344:;
case 355:;
case 356:;
case 357:;
case 364:;
case 365:;
case 372:;
case 404:;
case 405:;
case 406:;
case 407:;
case 408:;
case 409:;
case 410:;
case 412:;
case 413:;
case 414:;
case 415:;
case 417:;
case 418:;
case 419:;
case 420:;
case 421:;
case 423:;
case 424:;
case 425:;
case 426:;
case 427:;
case 428:;
case 429:;
case 430:;
case 431:;
case 432:;
case 433:;
case 435:;
case 437:;
case 438:;
case 439:;
case 440:;
case 441:;
case 442:;
case 443:;
case 445:;
case 446:;
case 447:;
case 449:;
case 450:;
case 452:;
case 453:;
case 455:;
case 456:;
case 457:;
case 458:;
case 459:;
case 460:;
case 461:;
case 462:;
case 463:;
case 465:;
case 466:;
case 467:;
case 468:;
case 469:;
case 471:;
case 472:;
case 474:;
case 475:;
case 476:;
case 477:;
case 479:;
case 480:;
case 482:;
case 483:;
case 484:;
case 485:;
case 487:;
case 488:;
case 489:;
case 490:;
case 491:;
case 492:;
case 494:;
case 495:;
case 496:;
case 497:;
case 498:;
case 499:;
case 500:;
case 502:;
case 504:;
case 505:;
case 506:;
case 507:;
case 508:;
case 510:;
case 511:;
case 512:;
case 514:;
case 516:;
case 517:;
case 518:;
case 519:;
case 520:;
case 521:;
case 522:;
case 523:;
case 525:;
case 526:;
case 527:;
case 528:;
case 529:;
case 530:;
case 532:;
case 533:;
case 534:;
case 535:;
case 536:;
case 537:;
case 538:;
case 539:;
case 541:;
case 542:;
case 543:;
case 544:;
case 545:;
case 547:;
case 548:;
case 549:;
case 550:;
case 551:;
case 552:;
case 553:;
case 554:;
case 556:;
case 557:;
case 558:;
case 559:;
case 560:;
case 561:;
case 562:;
case 564:;
case 565:;
case 566:;
case 567:;
case 569:;
case 570:;
case 571:;
case 572:;
case 573:;
case 574:;
case 575:;
case 576:;
case 578:;
case 579:;
case 580:;
case 581:;
case 582:;
case 584:;
case 585:;
case 586:;
case 588:;
case 590:;
case 591:;
case 592:;
case 593:;
case 594:;
case 595:;
case 596:;
case 598:;
case 599:;
case 600:;
case 602:;
case 603:;
case 604:;
case 605:;
case 607:;
case 608:;
case 610:;
case 611:;
case 612:;
case 613:;
case 614:;
case 615:;
case 616:;
case 617:;
case 618:;
case 698:;
case 700:;
case 701:;
case 702:;
case 703:;
case 705:;
case 706:;
case 707:;
case 708:;
case 709:;
case 711:;
case 712:;
case 714:;
case 715:;
case 716:;
case 717:;
case 718:;
case 720:;
case 721:;
case 722:;
case 723:;
case 724:;
case 725:;
case 727:;
case 728:;
case 729:;
case 730:;
case 731:;
case 732:;
case 733:;
case 735:;
case 736:;
case 737:;
case 738:;
case 740:;
case 741:;
case 742:;
case 743:;
case 745:;
case 746:;
case 747:;
case 749:;
case 750:;
case 751:;
case 752:;
case 754:;
case 755:;
case 756:;
case 758:;
case 760:;
case 761:;
case 763:;
case 764:;
case 765:;
case 767:;
case 768:;
case 769:;
case 771:;
case 772:;
case 773:;
case 775:;
case 776:;
case 777:;
case 778:;
case 779:;
case 780:;
case 782:;
case 783:;
case 784:;
case 785:;
case 786:;
case 787:;
case 788:;
case 790:;
case 791:;
case 792:;
case 793:;
case 794:;
case 795:;
case 796:;
case 798:;
case 799:;
case 801:;
case 802:;
case 804:;
case 805:;
case 806:;
case 807:;
case 808:;
case 809:;
case 810:;
case 811:;
case 813:;
case 814:;
case 815:;
case 816:;
case 818:;
case 819:;
case 821:;
case 823:;
case 824:;
case 825:;
case 827:;
case 828:;
case 830:;
case 831:;
case 832:;
case 833:;
case 834:;
case 836:;
case 837:;
case 838:;
case 839:;
case 840:;
case 842:;
case 843:;
case 844:;
case 845:;
case 846:;
case 847:;
case 848:;
case 850:;
case 851:;
case 852:;
case 853:;
case 854:;
case 855:;
case 856:;
case 858:;
case 859:;
case 860:;
case 862:;
case 863:;
case 865:;
case 866:;
case 867:;
case 868:;
case 869:;
case 870:;
case 872:;
case 873:;
case 874:;
case 876:;
case 877:;
case 878:;
case 879:;
case 881:;
case 882:;
case 883:;
case 884:;
case 886:;
case 887:;
case 888:;
case 889:;
case 890:;
case 892:;
case 893:;
case 894:;
case 895:;
case 896:;
case 898:;
case 899:;
case 900:;
case 901:;
case 903:;
case 904:;
case 905:;
case 906:;
case 907:;
case 909:;
case 910:;
case 911:;
case 912:;
case 913:;
case 915:;
case 916:;
case 917:;
case 919:;
case 920:;
case 921:;
case 923:;
case 924:;
case 925:;
case 926:;
case 928:;
case 929:;
case 930:;
case 931:;
case 933:;
case 934:;
case 935:;
case 936:;
case 937:;
case 938:;
case 939:;
case 941:;
case 942:;
case 943:;
case 944:;
case 945:;
case 946:;
case 947:;
case 948:;
case 950:;
case 951:;
case 952:;
case 953:;
case 954:;
case 956:;
case 957:;
case 958:;
case 959:;
case 960:;
case 961:;
case 963:;
case 964:;
case 965:;
case 966:;
case 967:;
case 969:;
case 970:;
case 972:;
case 974:;
case 975:;
case 976:;
case 977:;
case 979:;
case 980:;
case 981:;
case 982:;
case 983:;
case 985:;
case 986:;
case 987:;
case 988:;
case 989:;
case 990:;
case 991:;
case 993:;
case 994:;
yySetPosition
# line 1524 "fortran.rex"
{
                  MyLength = GetUpper(MyWord);
                  Attribute.Ident=MakeIdent(MyWord,MyLength);
                  return(TokIdentifier);                      
} yyy281: goto yyBegin;
# line 5809 "Scanner.c"
case 32:;
case 106:;
case 167:;
yySetPosition
# line 1531 "fortran.rex"
{ 
                  MyLength = GetUpper(MyWord);
                  Attribute.IntConst=atoi((char *)MyWord);
                  Attribute.Ident = GetKindIdent (MyWord, MyLength);
                  return(TokInteger);       
} yyy282: goto yyBegin;
# line 5821 "Scanner.c"
case 35:;
case 116:;
case 189:;
case 256:;
yySetPosition
# line 1541 "fortran.rex"
{ 
                  MyLength = GetUpper (MyWord);
                  Attribute.StringConst = PutString (MyWord, MyLength);
                  Attribute.Ident = GetKindIdent (MyWord, MyLength);
                  return(TokRealLiteral);           
                
} yyy283: goto yyBegin;
# line 5835 "Scanner.c"
case 37:;
yySetPosition
# line 1551 "fortran.rex"
{  
                  MyLength = GetWord (MyWord);
                  Attribute.StringConst = PutString (MyWord, MyLength);
                  return(TokDRealLiteral);           
} yyy284: goto yyBegin;
# line 5844 "Scanner.c"
case 396:;
{/* BlankAction */
while (* yyChBufferIndexReg ++ == ' ') ;
TokenPtr = (char *) -- yyChBufferIndexReg;
yyState = yyStartState;
yyStatePtr = & yyStateStack [1];
goto yyContinue;
} yyy285: goto yyBegin;
case 390:;
{/* TabAction */
yyTab;
} yyy286: goto yyBegin;
case 380:;
{/* EolAction */
yyEol (0);
} yyy287: goto yyBegin;
case 1:;
case 2:;
case 3:;
case 4:;
case 5:;
case 6:;
case 7:;
case 8:;
case 9:;
case 10:;
case 11:;
case 12:;
case 13:;
case 14:;
case 15:;
case 16:;
case 17:;
case 18:;
case 19:;
case 20:;
case 21:;
case 22:;
case 23:;
case 24:;
case 25:;
case 26:;
case 27:;
case 28:;
case 29:;
case 30:;
case 34:;
case 107:;
case 108:;
case 109:;
case 110:;
case 111:;
case 112:;
case 113:;
case 114:;
case 115:;
case 168:;
case 169:;
case 170:;
case 171:;
case 172:;
case 173:;
case 174:;
case 175:;
case 176:;
case 177:;
case 178:;
case 179:;
case 180:;
case 181:;
case 182:;
case 183:;
case 184:;
case 185:;
case 187:;
case 188:;
case 197:;
case 198:;
case 199:;
case 200:;
case 201:;
case 202:;
case 203:;
case 204:;
case 205:;
case 206:;
case 207:;
case 208:;
case 209:;
case 210:;
case 211:;
case 212:;
case 213:;
case 214:;
case 215:;
case 216:;
case 217:;
case 218:;
case 219:;
case 220:;
case 221:;
case 222:;
case 223:;
case 224:;
case 225:;
case 226:;
case 227:;
case 228:;
case 229:;
case 230:;
case 231:;
case 232:;
case 233:;
case 234:;
case 235:;
case 236:;
case 237:;
case 238:;
case 239:;
case 240:;
case 241:;
case 242:;
case 243:;
case 244:;
case 245:;
case 246:;
case 247:;
case 248:;
case 249:;
case 250:;
case 251:;
case 252:;
case 253:;
case 254:;
case 255:;
case 258:;
case 259:;
case 260:;
case 261:;
case 262:;
case 263:;
case 264:;
case 265:;
case 266:;
case 267:;
case 268:;
case 269:;
case 270:;
case 271:;
case 272:;
case 273:;
case 274:;
case 275:;
case 276:;
case 277:;
case 278:;
case 279:;
case 280:;
case 287:;
case 288:;
case 289:;
case 290:;
case 309:;
case 310:;
case 311:;
case 312:;
case 313:;
case 314:;
case 315:;
case 316:;
case 317:;
case 318:;
case 319:;
case 320:;
case 321:;
case 322:;
case 323:;
case 366:;
case 367:;
case 368:;
case 377:;
case 620:;
case 621:;
case 622:;
case 623:;
case 624:;
case 626:;
case 627:;
case 628:;
case 629:;
case 631:;
case 632:;
case 633:;
case 634:;
case 636:;
case 637:;
case 639:;
case 640:;
case 642:;
case 643:;
case 644:;
case 646:;
case 647:;
case 649:;
case 650:;
case 651:;
case 661:;
case 662:;
case 664:;
case 668:;
case 669:;
case 671:;
case 677:;
	 /* non final states */
	 yyChBufferIndexReg --;			/* return character */
	 break;

case 379:
	 yySetPosition
      /* TokenLength   = 1; */
	 yyChBufferIndex = ++ yyChBufferIndexReg;
	 {
# line 622 "fortran.rex"

  printf ("illegal character: ");
  yyEcho;
  printf (" in Line %d", yyLineCount);
  printf (" in file %s", CurrentSourceName ());
  printf ("\n");

# line 6075 "Scanner.c"
	 }
	 goto yyBegin;

      case yyDNoState:
	 goto yyBegin;

case 378:
	 yyChBufferIndex = -- yyChBufferIndexReg; /* undo last state transit */
	 if (-- TokenLength == 0) {		/* get previous state */
	    yyState = yyStartState;
	 } else {
	    yyState = * (yyStatePtr - 1);
	 }

	 if (yyChBufferIndex != & yyChBufferStart [yyBytesRead]) {
					/* end of buffer sentinel in buffer */
	    if ((yyState = yyEobTrans [yyState]) == yyDNoState) continue;
	    yyChBufferIndexReg ++;
	    * yyStatePtr ++ = yyState;		/* push state */
	    goto yyContinue;
	 }
						/* end of buffer reached */
	 if (! yyEof) {
	    register char * yySource;
	    register char * yyTarget;
	    unsigned long yyChBufferFree;

	    if (yyChBufferSize == 0) {
	       yyStateRange * yyOldStateStack = yyStateStack;
	       yyInitialize ();
	       yyStatePtr += yyStateStack - yyOldStateStack;
	       yyChBufferIndexReg = yyChBufferIndex;
	    }
	    yySource = TokenPtr - 1;
	    yyTarget = (char *) & yyChBufferPtr
		[(yyMaxAlign - 1 - TokenLength) & (yyMaxAlign - 1)];
	    yyChBufferFree = Exp2 (Log2 (yyChBufferSize - 4 -
		yyMaxAlign - TokenLength));
		/* copy initial part of token in front of the input buffer */
	    if (yySource > yyTarget) {
	       TokenPtr = yyTarget + 1;
	       do * yyTarget ++ = * yySource ++;
	       while (yySource < (char *) yyChBufferIndexReg);
	       yyLineStart += (unsigned char *) yyTarget - yyChBufferStart -
				yyBytesRead;
	       yyChBufferStart = (unsigned char *) yyTarget;
	    } else {
	       yyChBufferStart = yyChBufferIndexReg;
	    }
	    yyChBufferStart2 = (char *) yyChBufferStart;
						/* extend buffer if necessary */
	    if (yyChBufferFree < yyChBufferSize >> 3 /* / 8 */ ) {
	       register unsigned long yyDelta;
	       register unsigned char * yyOldChBufferPtr = yyChBufferPtr;
	       ExtendArray ((char * *) & yyChBufferPtr, & yyChBufferSize,
				(unsigned long) sizeof (char));
	       if (yyChBufferPtr == NULL) yyErrorMessage (1);
	       yyDelta = yyChBufferPtr - yyOldChBufferPtr;
	       yyChBufferStart	+= yyDelta;
	       yyLineStart	+= yyDelta;
	       TokenPtr	+= yyDelta;
	       yyChBufferStart2	 = (char *) yyChBufferStart;
	       yyChBufferFree = Exp2 (Log2 (yyChBufferSize - 4 -
			yyMaxAlign - TokenLength));
	       if (yyStateStackSize < yyChBufferSize) {
		  yyStateRange * yyOldStateStack = yyStateStack;
		  ExtendArray ((char * *) & yyStateStack, & yyStateStackSize,
				   (unsigned long) sizeof (yyStateRange));
		  if (yyStateStack == NULL) yyErrorMessage (1);
		  yyStatePtr	+= yyStateStack - yyOldStateStack;
	       }
	    }
						/* read buffer and restart */
	    yyChBufferIndex = yyChBufferIndexReg = yyChBufferStart;
	    yyFileOffset += yyBytesRead;
	    yyBytesRead = GetLine (yySourceFile,
				(char *) yyChBufferIndex, (int) yyChBufferFree);
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = rtrue; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	    goto yyContinue;
	 }

	 if (TokenLength == 0) {		/* end of file reached */
	    yySetPosition
	    CloseFile ();
	    if (yyFileStackPtr == yyFileStack) {
# line 640 "fortran.rex"


  /* Attention: EOF is only executed after the last file */

  /* Hint: the following statement
 
     close_include_file ();

     should be executed when an included file will be closed */


# line 6175 "Scanner.c"
	    }
	    if (yyFileStackPtr == yyFileStack) return EofToken;
	    goto yyBegin;
	 }
	 break;

      default:
	 yyErrorMessage (0);
      }
   }
}

static void yyInitialize ARGS ((void))
   {
      if (yyFileStackSize == 0) {
	 yyStateStackSize = yyInitBufferSize;
	 MakeArray ((char * *) & yyStateStack, & yyStateStackSize,
		       (unsigned long) sizeof (yyStateRange));
	 if (yyStateStack == NULL) yyErrorMessage (1);
	 yyStateStack [0] = yyDefaultState;
	 yyFileStackSize = yyInitFileStackSize;
	 MakeArray ((char * *) & yyFileStack, & yyFileStackSize,
			(unsigned long) sizeof (yytFileStack));
	 if (yyFileStack == NULL) yyErrorMessage (1);
	 yyFileStackPtr = yyFileStack;
      }

      if (yyFileStackPtr >= yyFileStack + yyFileStackSize - 1) {
	 unsigned long yyyFileStackPtr = yyFileStackPtr - yyFileStack;
	 ExtendArray ((char * *) & yyFileStack, & yyFileStackSize,
			   (unsigned long) sizeof (yytFileStack));
	 if (yyFileStack == NULL) yyErrorMessage (1);
	 yyFileStackPtr = yyFileStack + yyyFileStackPtr;
      }
      yyFileStackPtr ++;			/* push file */
      yyFileStackPtr->yySourceFile	= yySourceFile		;
      yyFileStackPtr->yyEof		= yyEof			;
      yyFileStackPtr->yyChBufferPtr	= yyChBufferPtr		;
      yyFileStackPtr->yyChBufferStart	= yyChBufferStart	;
      yyFileStackPtr->yyChBufferSize	= yyChBufferSize	;
      yyFileStackPtr->yyChBufferIndex	= yyChBufferIndex	;
      yyFileStackPtr->yyBytesRead	= yyBytesRead		;
      yyFileStackPtr->yyFileOffset	= yyFileOffset		;
      yyFileStackPtr->yyLineCount	= yyLineCount		;
      yyFileStackPtr->yyLineStart	= yyLineStart		;
						/* initialize file state */
      yyChBufferSize	   = yyInitBufferSize;
      MakeArray ((char * *) & yyChBufferPtr, & yyChBufferSize,
			(unsigned long) sizeof (char));
      if (yyChBufferPtr == NULL) yyErrorMessage (1);
      yyChBufferStart	   = & yyChBufferPtr [yyMaxAlign];
      yyChBufferStart2	   = (char *) yyChBufferStart;
      yyChBufferStart [-1] = yyEolCh;		/* begin of line indicator */
      yyChBufferStart [ 0] = yyEobCh;		/* end of buffer sentinel */
      yyChBufferStart [ 1] = '\0';
      yyChBufferIndex	   = yyChBufferStart;
      TokenPtr	   = (char *) yyChBufferStart;
      yyEof		   = rfalse;
      yyBytesRead	   = 0;
      yyFileOffset	   = 0;
      yyLineCount	   = 1;
      yyLineStart	   = & yyChBufferStart [-1];
   }

void BeginFile
# if defined __STDC__ | defined __cplusplus
   (char * yyFileName)
# else
   (yyFileName) char * yyFileName;
# endif
   {
      yyInitialize ();
      yySourceFile = yyFileName == NULL ? StdIn : BeginSource (yyFileName);
      if (yySourceFile < 0) yyErrorMessage (3);
   }

void CloseFile ARGS ((void))
   {
      if (yyFileStackPtr == yyFileStack) yyErrorMessage (2);
      CloseSource (yySourceFile);
      ReleaseArray ((char * *) & yyChBufferPtr, & yyChBufferSize,
			(unsigned long) sizeof (char));
						/* pop file */
      yySourceFile	= yyFileStackPtr->yySourceFile		;
      yyEof		= yyFileStackPtr->yyEof			;
      yyChBufferPtr	= yyFileStackPtr->yyChBufferPtr		;
      yyChBufferStart	= yyFileStackPtr->yyChBufferStart	;
      yyChBufferStart2	= (char *) yyChBufferStart		;
      yyChBufferSize	= yyFileStackPtr->yyChBufferSize	;
      yyChBufferIndex	= yyFileStackPtr->yyChBufferIndex	;
      yyBytesRead	= yyFileStackPtr->yyBytesRead		;
      yyFileOffset	= yyFileStackPtr->yyFileOffset		;
      yyLineCount	= yyFileStackPtr->yyLineCount		;
      yyLineStart	= yyFileStackPtr->yyLineStart		;
      yyFileStackPtr --;
      if (yyFileStackPtr == yyFileStack) ResetScanner ();
   }

# ifdef xxGetWord
int GetWord
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register char * yySource		= TokenPtr;
      register char * yyTarget			= yyWord;
      register char * yyChBufferIndexReg	= (char *) yyChBufferIndex;

      while (yySource < yyChBufferIndexReg)
	 * yyTarget ++ = * yySource ++;
      * yyTarget = '\0';
      return (int) (yyChBufferIndexReg - TokenPtr);
   }
# endif

# ifdef xxGetLower
int GetLower
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register unsigned char * yySource	= (unsigned char *) TokenPtr;
      register unsigned char * yyTarget		= (unsigned char *) yyWord;
      register unsigned char * yyChBufferIndexReg = yyChBufferIndex;

      while (yySource < yyChBufferIndexReg)
	 * yyTarget ++ = yyToLower [* yySource ++];
      * yyTarget = '\0';
      return (int) (yyChBufferIndexReg - (unsigned char *) TokenPtr);
   }
# endif

# ifdef xxGetUpper
int GetUpper
# if defined __STDC__ | defined __cplusplus
   (char * yyWord)
# else
   (yyWord) char * yyWord;
# endif
   {
      register unsigned char * yySource	= (unsigned char *) TokenPtr;
      register unsigned char * yyTarget		= (unsigned char *) yyWord;
      register unsigned char * yyChBufferIndexReg = yyChBufferIndex;

      while (yySource < yyChBufferIndexReg)
	 * yyTarget ++ = yyToUpper [* yySource ++];
      * yyTarget = '\0';
      return (int) (yyChBufferIndexReg - (unsigned char *) TokenPtr);
   }
# endif

# ifdef xxinput
static char input ARGS ((void))
   {
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) {
	 if (! yyEof) {
	    yyLineStart -= yyBytesRead;
	    yyChBufferIndex = yyChBufferStart = yyChBufferPtr;
	    yyChBufferStart2 = (char *) yyChBufferStart;
	    yyFileOffset += yyBytesRead;
	    yyBytesRead = GetLine (yySourceFile, (char *) yyChBufferIndex,
	       (int) Exp2 (Log2 (yyChBufferSize)));
	    if (yyBytesRead <= 0) { yyBytesRead = 0; yyEof = rtrue; }
	    yyChBufferStart [yyBytesRead    ] = yyEobCh;
	    yyChBufferStart [yyBytesRead + 1] = '\0';
	 }
      }
      if (yyChBufferIndex == & yyChBufferStart [yyBytesRead]) return '\0';
      else return * yyChBufferIndex ++;
   }
# endif

static void unput
# if defined __STDC__ | defined __cplusplus
   (char yyc)
# else
   (yyc) char yyc;
# endif
   { * (-- yyChBufferIndex) = yyc; }

static void yyLess
# if defined __STDC__ | defined __cplusplus
   (int yyn)
# else
   (yyn) int yyn;
# endif
   { yyChBufferIndex -= TokenLength - yyn; TokenLength = yyn; }

void BeginScanner ARGS ((void))
   {
# line 630 "fortran.rex"

  InitrMemory ();
  InitStringMemory ();
  InitIdents ();
  InitLabels ();
  MakeEndDos = 0;
  EndDoSwitch  = 0;
  ReservedWordState = 0;

# line 6380 "Scanner.c"
   }

void CloseScanner ARGS ((void))
   {
   }

void ResetScanner ARGS ((void))
   {
      yyChBufferPtr	= yyInitChBuffer;
      yyChBufferSize	= 0;
      if (yyStateStackSize != 0)
	 ReleaseArray ((char * *) & yyStateStack, & yyStateStackSize,
			(unsigned long) sizeof (yyStateRange));
      yyStateStack	= yyInitStateStack;
      yyStateStackSize	= 0;
      if (yyFileStackSize != 0)
	 ReleaseArray ((char * *) & yyFileStack, & yyFileStackSize,
			(unsigned long) sizeof (yytFileStack));
      yyFileStackSize	= 0;
# if defined xxyyPush | defined xxyyPop
      if (yyStStStackSize != 0)
	 ReleaseArray ((char * *) & yyStStStackPtr, & yyStStStackSize,
			(unsigned long) sizeof (yyStateRange));
      yyStStStackSize	= 0;
      yyStStStackIdx	= 0;
# endif
      yyStartState	= STD;
      yyPreviousStart	= STD;
      yySourceFile	= StdIn;
   }

static void yyErrorMessage
# if defined __STDC__ | defined __cplusplus
   (int yyErrorCode)
# else
   (yyErrorCode) int yyErrorCode;
# endif
   {
      WritePosition (stderr, Attribute.Position);
      switch (yyErrorCode) {
      case 0: (void) fprintf (stderr, ": Scanner: internal error\n"); break;
      case 1: (void) fprintf (stderr, ": Scanner: out of memory\n"); break;
      case 2: (void) fprintf (stderr,
      ": Scanner: file stack underflow (too many calls of CloseFile)\n");
	      break;
      case 3: (void) fprintf (stderr,
	      ": Scanner: cannot open input file\n"); break;
      case 4: (void) fprintf (stderr,
      ": Scanner: start stack underflow (too many calls of yyPop)\n"); break;
      }
      Scanner_Exit ();
   }
